Fri Apr  1 00:41:17 2016  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/rubygems/test_gem_commands_environment_command.rb (test_execute):
	  version number may be two-digit.

Fri Apr  1 00:00:31 2016  NAKAMURA Usaku  <usa@ruby-lang.org>

	* version.h: bump to 2.1.10.  welcome to two-digit version!

Wed Mar 30 18:45:26 2016  Kimura Wataru  <kimuraw@i.nifty.jp>

	* test/ruby/test_io.rb: handled rlimit value same as r52277
	  [Bug #11852][ruby-dev:49446]

Tue Mar 29 21:10:10 2016  Kazuki Yamaguchi  <k@rhe.jp>

	* ext/openssl/extconf.rb: check SSL_CTX_set_next_proto_select_cb
	  function rather than OPENSSL_NPN_NEGOTIATED macro. it exists
	  even if it is disabled by OpenSSL configuration.
	  [ruby-core:74384] [Bug #12182]

	* ext/openssl/ossl_ssl.c: update #ifdef(s) as above.

	* test/openssl/test_ssl.rb: skip NPN tests if NPN is disabled.

Tue Mar 29 21:09:02 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/uri/http.rb (URI::HTTP#initialize): [DOC] fix example,
	  missing mandatory arguments.  [ruby-core:74540] [Bug #12215]

Tue Mar 29 21:07:30 2016  NARUSE, Yui  <naruse@ruby-lang.org>

	* thread_pthread.c (reserve_stack): fix reserving position where
	  the stack growing bottom to top. [Bug #12118]

Fri Mar 25 18:42:46 2016  Koichi ITO  <koic.ito@gmail.com>

	* variable.c: Added documentation about order of `Module#constants`
	  [ci skip][Bug #12121][ruby-dev:49505][fix GH-1301]

Fri Mar 25 18:41:14 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (enc_succ_alnum_char): try to skip an invalid character
	  gap between GREEK CAPITAL RHO and SIGMA.
	  [ruby-core:74478] [Bug #12204]

Fri Mar 25 18:38:42 2016  NARUSE, Yui  <naruse@ruby-lang.org>

	* enc/trans/JIS: update Unicode's notice. [Bug #11844]

Fri Mar 25 18:36:04 2016  Eric Wong  <e@80x24.org>

	* ext/openssl/ossl_ssl.c (ossl_sslctx_setup): document as MT-unsafe
	  [ruby-core:73803] [Bug #12069]

Fri Mar 25 18:35:08 2016  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* ext/tk/lib/tkextlib/tcllib/tablelist_tile.rb: fix method name typo.
	  [ruby-core:72513] [Bug #11893] The patch provided by Akira Matsuda.


Fri Mar 25 18:34:20 2016  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* ext/tk/lib/tkextlib/tcllib/toolbar.rb: fix method name typo.
	  [ruby-core:72511] [Bug #11891] The patch provided by Akira Matsuda.


Fri Mar 25 18:33:34 2016  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* ext/tk/lib/tkextlib/blt/tree.rb: fix method name typo.
	  [ruby-core:72510] [Bug #11890] The patch provided by Akira Matsuda.


Fri Mar 25 18:32:44 2016  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* ext/tk/lib/tk/menubar.rb: fix a typo in font name. [ruby-core:72505]
	  [Bug #11886] The patch provided by Akira Matsuda.

	* ext/tk/sample/*.rb: ditto.

Fri Mar 25 18:30:55 2016  Anthony Dmitriyev  <antstorm@gmail.com>

	* net/ftp.rb: add NullSocket#closed? to fix closing not opened
	  connection.  [Fix GH-1232]

Fri Mar 25 18:24:04 2016  Victor Nawothnig  <Victor.Nawothnig@gmail.com>

	* parse.y (parse_numvar): NTH_REF must be less than a half of
	  INT_MAX, as it is left-shifted to be ORed with back-ref flag.
	  [ruby-core:74444] [Bug#12192] [Fix GH-1296]

Fri Mar 25 18:18:29 2016  Eric Hodel  <drbrain@segment7.net>

	* marshal.c (r_object0):  raise ArgumentError when linking to undefined
	  object.

Fri Mar 25 18:18:29 2016  Eric Hodel  <drbrain@segment7.net>

	* marshal.c (r_object0): Fix Marshal crash for corrupt extended object.

Fri Mar 25 18:07:48 2016  Yutaka Kanemoto  <kanemoto@ruby-lang.org>

	* cont.c (rb_fiber_struct): keep context.uc_stack.ss_sp and context.uc_stack.ss_size
	  for later use. Patch by Rei Odaira. [ruby-core:62945] [Bug #9905]

Fri Mar 25 17:52:46 2016  Tanaka Akira  <akr@fsij.org>

	* test/openssl/utils.rb (start_server, server_loop): Use a
	  pipe to stop server instead of shutdown/close a listening socket.

Fri Mar 25 17:52:46 2016  Tanaka Akira  <akr@fsij.org>

	* test/ruby/envutil.rb (assert_join_threads): New assertion to
	  join multiple threads without exceptions.

Fri Mar 25 17:52:46 2016  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/lib/openssl/ssl.rb (SSLServer#accept): Close a socket
	  if any exception occur. 

Fri Mar 25 17:52:46 2016  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/ossl_ssl.c (ossl_ssl_close): Fix sync_close to work
	  when SSL is not started.
	  This fix the fd leak by test_https_proxy_authentication in
	  test/net/http/test_https_proxy.rb.

Fri Mar 25 17:52:46 2016  Tanaka Akira  <akr@fsij.org>

	* test/openssl: Join threads.

Fri Mar 25 17:47:06 2016  NARUSE, Yui  <naruse@ruby-lang.org>

	* insns.def (opt_mod): show its method name on ZeroDivisionError.
	  [Bug #12158]

Fri Mar 25 17:45:36 2016  Rei Odaira  <Rei.Odaira@gmail.com>

	* test/ruby/test_process.rb (TestProcess#test_setsid): AIX
	  does not allow Process::getsid(pid) when pid is in a
	  different session.

Fri Mar 25 17:42:34 2016  Rei Odaira  <Rei.Odaira@gmail.com>

	* test/ruby/test_process.rb (test_execopts_gid): Skip a test
	  that is known to fail on AIX. AIX allows setgid to
	  a supplementary group, but Ruby does not allow the "-e"
	  option when setgid'ed, so the test does not work as intended.

Fri Mar 25 17:36:24 2016  Rei Odaira  <Rei.Odaira@gmail.com>

	* test/rinda/test_rinda.rb (test_make_socket_ipv4_multicast):
	  The fifth argument to getsockopt(2) should be modified to
	  indicate the actual size of the value on return,
	  but not in AIX. This is a know bug. Skip related tests.
	* test/rinda/test_rinda.rb (test_ring_server_ipv4_multicast):
	  ditto.
	* test/rinda/test_rinda.rb (test_make_socket_unicast): ditto.
	* test/socket/test_basicsocket.rb (test_getsockopt): ditto.
	* test/socket/test_sockopt.rb (test_bool): ditto.

Fri Mar 25 17:35:06 2016  Rei Odaira  <Rei.Odaira@gmail.com>

	* test/zlib/test_zlib.rb (test_adler32_combine, test_crc32_combine):
	  Skip two tests on AIX because zconf.h in zlib does not correctly
	  recognize _LARGE_FILES in AIX. The problem was already reported
	  to zlib, and skip these tests until it is fixed.

Fri Mar 25 17:33:52 2016  Rei Odaira  <Rei.Odaira@gmail.com>

	* test/socket/test_addrinfo.rb (test_ipv6_address_predicates):
	  IN6_IS_ADDR_V4COMPAT and IN6_IS_ADDR_V4MAPPED are broken
	  on AIX, so skip related tests.

Fri Mar 25 17:32:34 2016  Rei Odaira  <Rei.Odaira@gmail.com>

	* test/gdbm/test_gdbm.rb (TestGDBM#test_s_open_lock): skip
	  this test on AIX. The issue is the same as on Solaris.
	  [ruby-dev:47631]

Fri Mar 25 17:28:13 2016  Rei Odaira  <Rei.Odaira@gmail.com>

	* thread_pthread.c (getstack): __pi_stacksize returned by
	  pthread_getthrds_np() is wrong on AIX. Use
	  __pi_stackend - __pi_stackaddr instead.

Fri Mar 25 17:21:51 2016  Alex Boyd  <alex@opengroove.org>

	* lib/irb.rb: avoid to needless truncation when using back_trace_limit option.
	  [fix GH-1205][ruby-core:72773][Bug #11969]

Fri Mar 25 17:18:59 2016  Naohisa Goto  <ngotogenome@gmail.com>

	* enc/windows_1250.c: Should not use C++ style comments (C99 feature).
	  [Bug #11843]

Fri Mar 25 17:15:19 2016  Martin Duerst  <duerst@it.aoyama.ac.jp>

	* enc/iso_8859_2.c, enc/windows_1250.c: separate Windows-1250
	  from ISO-8859-2 to fix 0x80..0x9e range (from Kimihito Matsui)

Fri Mar 25 17:15:19 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* enc/windows_1252.c: separate from ISO-8859-1 to fix 0x80..0x9e
	  range.  [ruby-core:64049] [Bug #10097]

Fri Mar 25 17:15:19 2016  Martin Duerst  <duerst@it.aoyama.ac.jp>

	* enc/iso_8859_13.c: Added three missing lower/upper-case
	  character pairs (from Kimihito Matsui)

Fri Mar 25 17:15:19 2016  Martin Duerst  <duerst@it.aoyama.ac.jp>

	* enc/iso_8859_4.c: Added missing lower/upper-case character
	  pair (U+014A and U+014B, LATIN CAPITAL/SMALL LETTER ENG)
	  (from Kimihito Matsui)

Fri Mar 25 16:53:41 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_scrub): the result should be infected by the
	  original string.

Fri Mar 25 16:53:41 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* transcode.c (rb_econv_substr_append, econv_primitive_convert):
	  the result should be infected by the original string.

Fri Mar 25 16:53:41 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/ruby.h: add raw FL macros, which assume always the
	  argument object is not a special constant.

	* internal.h (STR_EMBED_P, STR_SHARED_P): valid only for T_STRING.

	* string.c: deal with taint flags directly across String instances.

Thu Feb 25 20:03:32 2016  Naotoshi Seo  <sonots@gmail.com>

	* lib/logger.rb: Remove block from Logger.add as it's not needed
	  patch provided by Daniel Lobato Garcia [fix GH-1240] [Bug #12054]

Thu Feb 25 19:58:48 2016  Zachary Scott  <zzak@ruby-lang.org>

	* re.c: Remove deprecated kcode argument from Regexp.new and compile
	  patch provided by Dylan Pulliam [Bug #11495]

Thu Feb 25 19:49:31 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/socket/socket.c (sock_gethostname): support unlimited size
	  hostname.

Thu Feb 25 19:28:19 2016  Kouhei Sutou  <kou@cozmixng.org>

	* lib/xmlrpc/client.rb: Support SSL options in async methods of
	  XMLRPC::Client.
	  [Bug #11489]
	  Reported by Aleksandar Kostadinov. Thanks!!!

Thu Feb 25 19:25:25 2016  NARUSE, Yui  <naruse@ruby-lang.org>

	* marshal.c (r_object0): honor Marshal.load post proc
	  value for TYPE_LINK.  by Hiroshi Nakamura <nahi@ruby-lang.org>
	  https://github.com/ruby/ruby/pull/1204 fix GH-1204

Thu Feb 25 18:59:27 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/socket/option.c (sockopt_bool): relax boolean size to be one
	  too not only sizeof(int).  Winsock getsockopt() returns a single
	  byte as a boolean socket option.  [ruby-core:72730] [Bug #11958]

Thu Feb 25 18:36:26 2016  NAKAMURA Usaku  <usa@ruby-lang.org>

	* process.c (rb_execarg_parent_start1): need to convert the encoding to
	  ospath's one.

Thu Feb 25 18:36:26 2016  NAKAMURA Usaku  <usa@ruby-lang.org>

	* process.c: use rb_w32_uchdir() instead of plain chdir() on Windows.
	  reported by naruse via twitter.

	* process.c (rb_execarg_addopt): need to convert the encoding to
	  ospath's one.

Thu Feb 25 18:21:55 2016  Eric Wong  <e@80x24.org>

	* ext/stringio/stringio.c (strio_binmode): implement to set encoding
	* test/stringio/test_stringio.rb (test_binmode): new test
	  [ruby-core:72699] [Bug #11945]

Thu Feb 25 18:12:00 2016  Eric Wong  <e@80x24.org>

	* io.c (io_getpartial): remove unused kwarg from template
	* test/ruby/test_io.rb (test_readpartial_bad_args): new
	  [Bug #11885]

Thu Feb 25 17:51:35 2016  Tadashi Saito  <tad.a.digger@gmail.com>

	* compile.c, cont.c, doc, man: fix common misspelling.
	  [ruby-core:72466] [Bug #11870]

Thu Feb 25 17:48:16 2016  Eric Wong  <e@80x24.org>

	* ext/socket/init.c (rsock_init_sock): reject reserved FDs
	  [ruby-core:72445] [Bug #11862]

Thu Feb 25 17:38:59 2016  Eric Wong  <e@80x24.org>

	* ext/socket/init.c (rsock_init_sock): check FD after validating
	* test/socket/test_basicsocket.rb (test_for_fd): new
	  [ruby-core:72418] [Bug #11854]

Thu Feb 25 17:33:38 2016  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* cont.c: fix a double word typo.
	  [Bug #11313][ruby-core:69749]

Thu Feb 25 17:32:23 2016  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* ext/tk/lib/multi-tk.rb: fix typos.
	  [Bug #11764][ruby-core:71800]

Thu Feb 25 16:46:37 2016  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* re.c (reg_names_iter): should consider encoding of regexp.
	  [ruby-core:72185] [Bug #11825]

Wed Dec 23 14:13:59 2015  NAKAMURA Usaku  <usa@ruby-lang.org>

	* version.h: bump to 2.1.9.  may this version be the last of 2.1.

Wed Dec 16 21:10:03 2015  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* ext/fiddle/handle.c: check tainted string arguments.
	  Patch provided by tenderlove and nobu.

	* test/fiddle/test_handle.rb (class TestHandle): add test for above.

Wed Dec 16 21:10:03 2015  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* ext/dl/handle.c (rb_dlhandle_initialize): prohibits DL::dlopen
	  with a tainted name of library.
	  Patch by sheepman <sheepman AT sheepman.sakura.ne.jp>.

	* ext/dl/handle.c (rb_dlhandle_sym): ditto

Wed Dec 16 16:13:04 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (parse_mode_enc): fix buffer overflow.

Wed Dec 16 16:10:52 2015  Eric Wong  <e@80x24.org>

	* insns.def (opt_case_dispatch): avoid converting Infinity
	* test/ruby/test_optimization.rb (test_opt_case_dispatch_inf): new
	  [ruby-dev:49423] [Bug #11804]'

Wed Dec 16 16:07:29 2015  Rei Odaira  <Rei.Odaira@gmail.com>

	* configure.in: pthread_getattr_np is broken on AIX.
	  More specifically, the stack address and size returned are
	  not correct.

Wed Dec 16 16:04:27 2015  Eric Wong  <e@80x24.org>

	* insns.def (opt_case_dispatch): check Float#=== redefinition
	* test/ruby/test_optimization.rb (test_opt_case_dispatch): new
	  [ruby-core:71920] [Bug #11784]

Tue Dec  8 11:53:06 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ruby_atomic.h (ATOMIC_SIZE_CAS): fix the argument order of
	  InterlockedCompareExchange64.  new value and then old value is
	  the last.

Tue Dec  8 11:45:42 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* encoding.c (enc_m_loader): defer finding encoding object not to
	  be infected by marshal source.  [ruby-core:71793] [Bug #11760]

	* marshal.c (r_object0): enable compatible loader on USERDEF
	  class.  the loader function is called with the class itself,
	  instead of an allocated object, and the loaded data.

	* marshal.c (compat_allocator_table): initialize
	  compat_allocator_tbl on demand.

	* object.c (rb_undefined_alloc): extract from rb_obj_alloc.

Fri Dec  4 10:55:08 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* range.c (range_to_s): should be infected by the receiver.
	  str2 infects by appending.  [ruby-core:71811] [Bug #11767]

Wed Dec  2 15:14:29 2015  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/readline/extconf.rb: call dir_config("libedit")
	  if --enable-libedit is spcified. [Bug #11751]
	  patched by John Hein

Tue Dec  1 16:57:57 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_io_each_codepoint): raise an exception at incomplete
	  character before EOF when conversion takes place.  [Bug #11444]

Tue Dec  1 16:57:57 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_io_each_codepoint): read more data when read partially.
	  [ruby-core:70379] [Bug #11444]

Tue Dec  1 13:06:29 2015  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/digest/sha1/sha1ossl.c: fixed build error introduced at r52797.

Mon Nov 30 21:29:57 2015  Koichi Sasada  <ko1@atdot.net>

	* insns.def (defined): skip respond_to_missing? when
	  a method is available.
	  [Bug #11211]

	* test/ruby/test_defined.rb: add a test for this fix.

Mon Nov 30 21:27:09 2015  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/digest/rmd160/rmd160.c: fixed commit mistake at r52797.

Mon Nov 30 21:18:24 2015  Shugo Maeda  <shugo@ruby-lang.org>

	* io.c (argf_getpartial): should not resize str if the second
	  argument is not given.
	  [ruby-core:71668] [Bug #11738]

Mon Nov 30 21:17:08 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* lib/net/http.rb: set hostname before call ossl_ssl_set_session.
	  [Bug #11401][ruby-core:70152][fix GH-964] Patch by @mkarnebeek

Mon Nov 30 21:09:48 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* transcode.c (rb_econv_open0): rb_econv_t::source_encoding_name
	  and rb_econv_t::destination_encoding_name should refer static
	  strings always or NULL.  [ruby-core:70247] [Bug #11416]

Mon Nov 30 21:02:21 2015  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/digest/*/*.[ch]: include ruby.h before digest.h to avoid
	  includeing ext/digest/extconf.h. [Bug #3231]
	  https://msdn.microsoft.com/library/36k2cdd4.aspx

	* ext/digest/*/extconf.rb: remove ext/digest from include search path
	  to avoid confusion of cl.exe.

	* ext/digest/*/*.[ch]: explicitly specify def.h's path.

Mon Nov 30 20:54:22 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* Added missing reference of GitHub

Mon Nov 30 20:54:22 2015  Trevor Rowe  <trevorrowe@gmail.com>

	* lib/net/http.rb: Fixed regression for Net::HTTP::PUT with "Expect-100"
	  header. [fix GH-949]
	* test/net/http/test_http.rb: added test.

Wed Nov 18 20:56:50 2015  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/date/extconf.rb: try_cflags("-std=iso9899:1999") [Bug #10906]
	  ruby itself (including numeric.c) is built with strict compile
	  options including -std=iso9899:1999, but ext/date is not.
	  By the way -std=iso9899:1999 is not only a warning option but also
	  changes behavior like MACRO definitions for example INFINITY.
	  gcc on Solaris affect this.

Wed Nov 18 20:38:15 2015  Zachary Scott  <zzak@ruby-lang.org>

	* ext/openssl/ossl_pkey.c: Merge ruby/openssl@b9ea8ef [Bug #10735]

Wed Nov 18 20:31:56 2015  Aaron Patterson <tenderlove@ruby-lang.org>

	* ext/openssl/ossl_ssl.c (ossl_ssl_method_tab): Only add SSLv3 support
	  if the SSL library supports it.  Thanks Kurt Roeckx <kurt@roeckx.be>
	  [Bug #11376]

	* ext/openssl/extconf.rb: check for SSLv3 support in the SSL
	  implementation.

	* test/openssl/test_ssl.rb (class OpenSSL): Skip tests that need SSLv3
	  if there is no support.

Wed Nov 18 20:26:08 2015  Koichi Sasada  <ko1@atdot.net>

	* vm_trace.c (rb_threadptr_exec_event_hooks_orig):
	  maintain trace_running counter on internal events.

	  This patch is made by Takashi Kokubun <takashikkbn@gmail.com>.
	  [Bug #11603] https://github.com/ruby/ruby/pull/1059

Wed Nov 18 20:19:49 2015  Koichi Sasada  <ko1@atdot.net>

	* compile.c (iseq_compile_each): remove duplicated line event.
	  [Bug #10449]

	* test/ruby/test_settracefunc.rb: add and fix tests.

Wed Nov 18 20:14:38 2015  Koichi Sasada  <ko1@atdot.net>

	* vm.c (hook_before_rewind): prevent kicking :return event while
	  finishing vm_exec func because invoke_block_from_c() kick a :return
	  event for bmethods.
	  [Bug #11492]

	* test/ruby/test_settracefunc.rb: add a test.

Wed Nov 18 20:10:31 2015  Aaron Patterson <tenderlove@ruby-lang.org>

	* test/openssl/test_ssl_session.rb: Fix tests so that they take in to
	  account OpenSSL installations that have SSLv3 disabled by default.
	  Thanks Jeremy Evans <code@jeremyevans.net> for the patches.
	  [Bug #11366] [Bug #11367]

Wed Nov 18 20:04:50 2015  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* test/openssl/test_ssl_session.rb (OpenSSL#test_ctx_client_session_cb):
	  fix test failure with OpenSSL disabled SSLv3 protocol.
	  [ruby-core:63772] [Bug #10046]

Thu Oct 29 23:54:35 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (sym_to_proc), proc.c (rb_block_clear_env_self): clear
	  caller's self which is useless, so that it can get collected.
	  [Fixes GH-592]

Thu Oct 29 23:30:20 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* lib/ipaddr.rb, test/test_ipaddr.rb: Reject invalid address contained
	  EOL string. Patch by @kachick [fix GH-942][Bug #11513]

	* lib/ipaddr.rb, test/test_ipaddr.rb: split test code from library
	  script and move to test script, just like trunk.

Thu Oct 29 23:04:04 2015  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/openssl/ossl_ssl.c (ssl_npn_select_cb): explicitly raise error
	  in ext/openssl instead of OpenSSL itself because LibreSSL
	  silently truncate the selected protocol name by casting the length
	  from int to unsigned char. [Bug #11369]
	  Patch by Jeremy Evans <merch-redmine@jeremyevans.net>

Thu Oct 29 22:56:01 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in: check for libunwind.h, which is not available in
	  very old OS X SDK.  [ruby-core:71080] [Bug #11591]

Thu Oct 29 22:51:59 2015  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* test/drb/test_drb.rb: Run Rinda/DRb tests on localhost. [Fix GH-1027]
	  patch by voxik.

	* test/rinda/test_rinda.rb: ditto

Tue Sep 29 17:39:42 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (literal_concat_gen, evstr2dstr_gen): keep literal
	  encoding beginning with an interpolation same as the source file
	  encoding.  [ruby-core:70703] [Bug #11519]

Tue Sep 29 17:33:13 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/rss/rss.rb (Time#w3cdtf): fix zero-trimmed width of fraction
	  digits.  [ruby-core:70667] [Bug #11509]

Tue Sep 29 17:25:14 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* re.c (rb_memsearch_wchar, rb_memsearch_qchar): test matching
	  till the end of string.  [ruby-core:70592] [Bug #11488]

	* test/ruby/test_m17n.rb (test_include?, tet_index): add tests by
	  Tom Stuart.

Tue Sep 29 17:20:07 2015  NARUSE, Yui  <naruse@ruby-lang.org>

	* thread_pthread.c (reserve_stack): ensure the memory is really
	  allocated. [Bug #11457]

Tue Sep 29 17:18:40 2015  NAKAMURA Usaku  <usa@ruby-lang.org>

	* version.h (RUBY_VERSION): bump RUBY_VERSION to 2.1.8.

Tue Aug 18 21:40:43 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* lib/rubygems.rb: bump version to 2.2.5. this version fixed
	  CVE-2015-3900.

	* lib/rubygems/remote_fetcher.rb: ditto.

	* test/rubygems/test_gem_remote_fetcher.rb: added testcase for CVE-2015-3900

Mon Aug 17 23:27:45 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/win32/lib/win32/registry.rb (API#SetValue): data size should
	  be in bytes, not in chars.  [ruby-core:70365] [Bug #11439]

Mon Aug 17 23:27:45 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/win32/lib/win32/registry.rb (API#SetValue): add terminator
	  size, not 1 byte.  [ruby-core:70365] [Bug #11439]

Mon Aug 17 17:57:12 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* re.c (rb_memsearch): should match only char boundaries in wide
	  character encodings.  [ruby-core:70220] [Bug #11413]

Mon Aug 17 17:54:33 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* transcode.c (rb_econv_set_replacement): target encoding name can
	  be empty now.  [ruby-core:69841] [Bug #11324]

Mon Aug 17 17:52:11 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* hash.c (rb_any_hash): fix Float hash.  rb_dbl_hash() returns a
	  Fixnum, but not a long.  [Bug #9381]

Mon Aug 17 17:43:56 2015  Eric Wong  <e@80x24.org>

	* io.c (rb_io_oflags_modestr): handle O_TRUNC correctly
	* test/ruby/test_io.rb (test_reopen_stdio): new test
	  Patch-by: cremno phobia <cremno@mail.ru>
	  [ruby-core:69779] [Bug #11319]

Mon Aug 17 17:42:18 2015  Benoit Daloze  <eregontp@gmail.com>

	* lib/net/ftp.rb (makeport): close the TCPServer
	  when sending the port fails.

	* test/net/ftp/test_ftp.rb: test for above.

Mon Aug 17 17:38:15 2015  Kazuki Tsujimoto  <kazuki@callcc.net>

	* lib/net/http/response.rb (Net::HTTPResponse::Inflater#finish):
	  fix a bug that empty gzipped response body causes Zlib::BufError.
	  [ruby-core:68846] [Bug #11058]

	* test/net/http/test_httpresponse.rb: tests for the above.

Mon Aug 17 17:38:15 2015  Kazuki Tsujimoto  <kazuki@callcc.net>

	* lib/net/http/response.rb (Net::HTTPResponse#inflater):
	  fix TypeError. An exception object might be nil.
	  [ruby-core:68846] [Bug #11058]

Mon Aug 17 17:38:15 2015  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/net/http/response.rb (Net::HTTPResponse.each_response_header):
	  raise first exception even if inflate_body_io.finish raises error.
	  when begin block raises error, finish usually raises error too.

Mon Aug 17 17:16:22 2015  Aaron Patterson <tenderlove@ruby-lang.org>

	* .travis.yml: update libssl before running tests. 
	  Thanks to Chris Sinjakli <chris@sinjakli.co.uk> for figuring out the
	  travis settings!

Mon Aug 17 17:16:22 2015  Aaron Patterson <tenderlove@ruby-lang.org>

	* ext/openssl/lib/openssl/ssl.rb (module OpenSSL): raise a more
	  helpful exception when verifying the peer connection and an
	  anonymous cipher has been selected. [ruby-core:68330] [Bug #10910]
	  Thanks to Chris Sinjakli <chris@sinjakli.co.uk> for the patch.

	* test/openssl/test_ssl.rb (class OpenSSL): test for change

Mon Aug 17 17:12:46 2015  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (waitpid): return immediately if interrupted.
	  reported by <takkanm AT gmail.com> [ruby-dev:49176] [Bug #11340]

Mon Aug 17 17:09:02 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (lambda_body): pop cmdarg stack for lookahead
	  token.  [ruby-core:70067] [Bug #11380]

Mon Aug 17 17:04:57 2015  Jeremy Evans  <merch-redmine@jeremyevans.net>

	* test/openssl/test_ssl.rb: Fix LocalJumpErrors being raised
	  in OpenSSL tests. [ruby-core:70020][Bug #11368]

Mon Aug 17 16:51:45 2015  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* lib/timeout.rb (ExitException): leave Timeout::ExitException as an
	  alias of Timeout::Error for backward compatibility in stable branch.
	  [ruby-dev:49179] [Bug #11344]

Mon Aug 17 16:51:45 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/timeout.rb (ExitException): removed internal exception class
	  and use Timeout::Error instead, as using throw/catch to isolate
	  each timeouts now.  [ruby-dev:49179] [Bug #11344]

Mon Aug 17 16:49:00 2015  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* test/net/http/test_httpresponse.rb
	(HTTPResponseTest#test_read_body_content_encoding_deflate_uppercase):
	fix a failure without zlib.

Mon Aug 17 16:49:00 2015  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/net/http/response.rb (inflater): CONTENT_ENCODING can be upper
	  case. [ruby-core:69670] [Bug #11285] patched by Andy Chu

Mon Aug 17 16:46:28 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm.c (m_core_hash_merge_ptr): copy the arguments to the machine
	  stack before rewinding the control frame pointer and leaving the
	  arguments outside valid region of the value stack.
	  [ruby-core:69969] [Bug #11352]

	* vm.c (REWIND_CFP): keep the arguments region inside the valid
	  value stack.  [ruby-core:69969] [Bug #11352]

Mon Aug 17 16:44:01 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_reverse): reversed string is not a substring,
	  and should not set coderange of the original string.
	  [ruby-dev:49189] [Bug #11387]

Mon Aug 17 16:24:10 2015  Tanaka Akira  <akr@fsij.org>

	* lib/time.rb (strptime): Support %s.%N.
	  [ruby-core:68301] [Bug #10904] Patch by Sadayuki Furuhashi.

Mon Aug 17 16:22:28 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* transcode.c (load_transcoder_entry): fix transcoder loading race
	  condition, by waiting in require.  [ruby-dev:49106] [Bug #11277]

Mon Aug 17 16:18:13 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* array.c (ary_ensure_room_for_push): check if array size will
	  exceed maximum size to get rid of buffer overflow.
	  [ruby-dev:49043] [Bug #11235]

	* array.c (ary_ensure_room_for_unshift, rb_ary_splice): ditto.

Mon Aug 17 16:14:38 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/win32/lib/win32/registry.rb (Win32::Registry::API): use wide
	  versions of RegDeleteValue and RegDeleteKey.
	  [ruby-core:67958] [Bug #10820]

Tue Jul  7 13:39:46 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* ext/zlib/zlib.c: Fix indentation for rdoc.
	  [Bug #11221][ruby-core:69465]

Tue Jul  7 13:37:34 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* ext/bigdecimal/bigdecimal.gemspec: Fix require paths for released gem.
	  [fix GH-929] Patch by @voxik
	* ext/io/console/io-console.gemspec: ditto.

Fri Jul  3 21:54:46 2015  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/ruby/test_require.rb (TestRequire#test_loading_fifo_threading):
	  fix previous commit.  [Bug #11060]

Fri Jul  3 19:28:51 2015  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/ruby/test_require.rb (TestRequire#test_loading_fifo_threading):
	  ignore Errno::ENOENT on unlinking.  [Bug #11060]

Fri Jul  3 18:40:48 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (pkg_config): split --libs if --libs-only-l option
	  is not available.  patch in [ruby-core:69428] by Hans Mackowiak.
	  [ruby-core:69421] [Bug #11201]

Fri Jul  3 18:32:37 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (iseq_compile_each): out of range NTH_REF is always
	  nil.

	* parse.y (parse_numvar): check overflow of NTH_REF and range.
	  [ruby-core:69393] [Bug #11192]

	* util.c (ruby_scan_digits): make public and add length parameter.

Fri Jul  3 17:53:43 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_eval.c (rb_method_call_status): resolve refined method entry
	  to check if undefined.  [ruby-core:69064] [Bug #11117]

Fri Jul  3 17:53:43 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_eval.c (rb_method_call_status): undefined refined method is
	  not callable unless using.  [ruby-core:69064] [Bug #11117]

Fri Jul  3 17:44:27 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (rb_file_load_ok): try opening file without gvl not to
	  lock entire process.  [Bug #11060]

Tue Jun 30 11:56:24 2015  Eric Wong  <e@80x24.org>

	* numeric.c (bit_coerce): use original value for error message
	  [ruby-core:67405] [Bug #10711]
	* test/ruby/test_numeric.rb (test_coerce): check error message

Mon Jun 29 13:22:14 2015  Shota Fukumori  <her@sorah.jp>

	* ext/objspace/objspace_dump.c(dump_object): Return empty JSON object when
	  passed object is a special const, instead of SEGV.
	  Based patch by Kohei Suzuki (eagletmt). [ruby-core:69692] [Bug #11291]

	* test/objspace/test_objspace.rb(test_dump_special_consts): Test for above fix.


Wed Jun 17 11:39:15 2015  Koichi Sasada  <ko1@atdot.net>

	* vm_insnhelper.c (lep_svar_set): add WBs.

Tue Jun  9 16:29:49 2015  Eric Wong  <e@80x24.org>

	* ext/socket/ancdata.c: use RB_GC_GUARD instead of volatile
	  [ruby-core:69419] [Feature #11198]

Tue Jun  9 16:26:48 2015  Eric Wong  <e@80x24.org>

	* ext/openssl/ossl_asn1.c (ossl_asn1_traverse, ossl_asn1_decode,
	  ossl_asn1_decode_all): use RB_GC_GUARD instead of volatile
	  [ruby-core:69371] [Bug #11185]

Tue Jun  9 16:24:25 2015  NARUSE, Yui  <naruse@ruby-lang.org>

	* win32/win32.c (setup_overlapped): seek to the file end only when
	  writing (mode:a), not reading (mode:a+, read).

Tue Jun  9 16:15:31 2015  Aaron Patterson <tenderlove@ruby-lang.org>

	* load.c (loaded_feature_path): stop returning false negatives for
	  filenames which are trailing substrings of file extensions.  For
	  example, 'b', which a trailing substring of ".rb" should not return
	  false. [Bug #11155][ruby-core:69206]

	* test/ruby/test_autoload.rb: test for fix

Fri May 29 14:03:33 2015  Matt Hoyle  <matt@deployable.co>

	* ext/bigdecimal/bigdecimal.c (VpSetPTR): fix a typo, 'expoennt'
	  to 'exponent'.  [ruby-core:67980] [Bug #10823] [Fix GH-825]

Fri May 29 14:00:16 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* win32/file.c (rb_file_expand_path_internal): neither the drive
	  of base directory nor the current drive are involved in the
	  result if different than the drive of path.
	  [ruby-core:68130] [Bug #10858]

Fri May 29 14:00:16 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* win32/file.c (rb_file_expand_path_internal): do not make invalid
	  (or ADS) path if the path has a drive letter, the result also
	  should have be under it.  [ruby-core:68130] [Bug #10858]

Fri May 29 13:41:44 2015  NAKAMURA Usaku  <usa@ruby-lang.org>

	* marshal.c (r_symreal): register the symbol name first so that
	  r_symlink always returns valid names. [Bug #10991]

Thu May 28 09:51:28 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* hash.c (rb_any_hash): use same hash values with Float#hash so
	  that -0.0 and +0.0 will be identical.
	  [ruby-core:68541] [Bug #10979]

Thu May 21 14:15:10 2015  Eric Wong  <e@80x24.org>

	* ext/socket/ancdata.c (bsock_recvmsg_internal): GC guard
	  [Bug #11123]

Thu May 21 14:11:50 2015  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/imap.rb (body_ext_mpart): should work even if body-fld-dsp
	  is omitted.  [ruby-core:69093] [Bug #11128]

Thu May 21 14:08:15 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* string.c: added documentation for character sequence \' with String#sub
	  [Bug #11132][ruby-core:69121][fix GH-900][ci skip] Patch by @shishir127

Thu May 21 14:04:06 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* range.c (linear_object_p, range_include): test if covered for
	  linear objects.  [ruby-core:69052] [Bug #11113]

Thu May 21 14:01:40 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* rational.c: Added documentation for rational literal.
	  [Bug #11075][fix GH-885][ci skip] Patch by @shishir127

Thu May 21 13:57:47 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/socket/ipsocket.c (init_inetsock_internal): preserve errno
	  before other library calls and use rb_syserr_fail.
	  [ruby-core:68531] [Bug #10975]

Thu May 21 13:32:52 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/-test-/printf/printf.c (uint_to_str): renamed to get rid of
	  conflict on cygwin.  [ruby-core:68877] [Bug #11065]

Thu May 21 13:28:03 2015  Koichi Sasada  <ko1@atdot.net>

	* vm.c (vm_exec): check other events when RETURN is thrown.
	  [Bug #10724]

	* test/ruby/test_settracefunc.rb: add a test.

Thu May 21 13:23:44 2015  Masahiro Tomita  <tommy@tmtm.org>

	* ext/socket/raddrinfo.c (addrinfo_mload): fix memory leak of
	  addrinfo.  [ruby-dev:48923] [Bug #11051]

Thu May 21 13:19:52 2015  Kenta Murata  <mrkn@cookpad.com>

	* bigdecimal: conform to ruby's license.  [ruby-core:68466] [Bug #10952]

Thu May 21 09:49:01 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* gc.c (id2ref): prohibit from accessing internal objects.
	  [ruby-core:68348] [Bug #10918]

Thu May 21 09:46:58 2015  Rei Odaira  <Rei.Odaira@gmail.com>

	* ext/pty/pty.c: AIX supports autopush.
	  Patch by Perry Smith [ruby-core:58539] [Bug #9144]

Wed May 20 17:34:43 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* iseq.c (rb_iseq_compile_with_option): check source type, must be
	  an IO or a String.  [ruby-core:69219] [Bug #11159]

Wed May 13 14:32:13 2015  Tanaka Akira  <akr@fsij.org>

	* lib/resolv.rb (Resolv::DNS::Label::Str#==): Check class equality.
	  (Resolv::DNS::Name#initialize): Normalize labels as
	  Resolv::DNS::Label::Str objects.

Tue May 12 16:11:55 2015  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/tk/extconf.rb: support Tcl/Tk8.6.

	* ext/tk/tcltklib.c, ext/tk/lib/tk.rb: get rid of SEGV with Tcl/Tk8.6.
	  [Backport #10401]

Mon May 11 11:09:08 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* dln.c (dln_load): check if a different libruby is loaded by the
	  extension library, and then bail out to get rid of very frequent
	  reported stale bug reports.

	* dln.c (dln_load): raise fatal error on OSX not other extension
	  libraries to refer different libruby.

Mon May 11 10:59:53 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (lambda): push and reset cmdarg_stack in lambda body.
	  [ruby-core:69017] [Bug #11107]

Tue Apr 28 14:15:49 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/fileutils.rb (FileUtils#mv): show the exact target path in
	  the error message instead of the destination parent directory
	  name.  patched by Joao Britto <jabcalves AT gmail.com> at
	  [ruby-core:68706].  [Bug #11021]

Tue Apr 28 14:14:16 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread_pthread.c (reserve_stack): keep sp safe zone to get rid
	  of crash by -fstack-check.  [ruby-core:68740] [Bug #11030]

Fri Apr 24 17:27:31 2015  Koichi Sasada  <ko1@atdot.net>

	* test/fiddle/test_handle.rb: fix syntax.

Tue Apr 14 16:02:07 2015  NAKAMURA Usaku  <usa@ruby-lang.org>

	* version.h (RUBY_VERSION): bump RUBY_VERSION to 2.1.7.

Mon Apr 13 22:17:59 2015  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* ext/openssl/lib/openssl/ssl.rb: stricter hostname verification
	  following RFC 6125. with the patch provided by Tony Arcieri and
	  Hiroshi Nakamura [ruby-core:61545] [Bug #9644]
	* test/openssl/test_ssl.rb: add tests for above.

Mon Apr 13 17:09:06 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* win32/win32.c (different_device_p): compare by volume serial
	  numbers, not by path names.  [ruby-core:68162] [Bug #10865]

Mon Apr 13 17:09:06 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* win32/win32.c (wrename): return EXDEV if moving a directory to
	  another drive, since MoveFileExW does not set proper error code.
	  [ruby-core:68162] [Bug #10865]

Mon Apr 13 17:02:25 2015  Scott Francis  <scott.francis@shopify.com>

	* thread_pthread.c (reserve_stack): fix intermittent SIGBUS on
	  Linux, by reserving the stack virtual address space at process
	  start up so that it will not clash with the heap space.
	  [Fix GH-822]

Mon Apr 13 16:52:14 2015  Koichi Sasada  <ko1@atdot.net>

	* class.c (rb_prepend_module): need a WB for klass -> origin.

Mon Apr 13 16:48:14 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_eval.c (vm_call_super): search next super class from the
	  original class, to get rid of infinite recursion with
	  prepending.  a patch by Seiei Higa <hanachin AT gmail.com> at
	  [ruby-core:68434].  [ruby-core:68093] [Bug #10847]

Mon Apr 13 16:39:57 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (arg): fix segfault by null caused by syntax error.
	  [ruby-core:68851] [Bug #10957]

Tue Mar 31 00:49:23 2015  Naohisa Goto  <ngotogenome@gmail.com>

	* gc.c (wmap_final_func): fix memory size shortage when realloc wmap.
	  Fix SEGV during finalize of WeakRef on Solaris (though the SEGV
	  could occur on all OS/platforms). [ruby-dev:48779] [Bug #10646]

Tue Mar 31 00:38:14 2015  Seiei Higa  <hanachin@gmail.com>

	* vm_method.c (rb_method_entry): if no super class, no original
	  method entry.  [ruby-core:67389] [Bug #10707]

Tue Mar 31 00:34:39 2015  Vit Ondruch  <vondruch@redhat.com>

	* configure.in (RUBY_SETJMP_TYPE): Remove superfluous semicolon
	  which causes a syntax error with autoconf 2.63.
	  [ruby-core:67429] [Bug #10716]

Tue Mar 31 00:32:04 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/fiddle/test_handle.rb (test_NEXT): use -test-/dln/empty
	  which is always a shared object and is not used by others.
	  [ruby-dev:48629] [Bug #10384]

Tue Mar 31 00:18:12 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (primary): empty parentheses at cmdarg can be null.
	  [ruby-core:68477] [Bug #10957]

Mon Mar 30 23:30:57 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/io/console/console.c (console_dev): id_console is not a
	  constant name, use rb_const_remove() to get rid of NameError.

Sun Mar 22 04:15:39 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/thread/thread.c (Init_thread): ConditionVariable and Queue
	  are not able to copy.  [ruby-core:59961] [Bug #9440]

Wed Mar 18 02:42:37 2015  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (w32_spawn): `v2` is used not only for `shell` but also
	  `cmd`, so must not free before using `cmd`.
	  [ruby-core:66648] [Bug #10563]

Wed Mar 18 02:40:18 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* win32/win32.c (constat_reset): do nothing on non-standard
	  console emulators.  [ruby-core:66471] [Bug #10546]

Wed Mar 18 02:03:02 2015  Kazuki Tsujimoto  <kazuki@callcc.net>

	* vm_insnhelper.c (rb_vm_rewrite_cref_stack): copy nd_refinements
	  of original crefs. It fixes segmentation fault when calling
	  refined method in duplicate module. [ruby-dev:48878] [Bug #10885]

	* vm_core.h, class.c: change accordingly.

	* test/ruby/test_refinement.rb: add a test for above.

Wed Mar 18 01:58:18 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/sdbm/_sdbm.c: include ruby/ruby.h for PRIdPTRDIFF when a
	  macro `DEBUG` is defined.  based on the patch by Owen Rodley in
	  [ruby-core:67987]. [Bug #10825]

Wed Mar 18 01:45:12 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (try_cppflags, try_cflags, try_ldflags): get rid of
	  interference by modifying global variables in have_devel? method.
	  [ruby-core:67962] [Bug #10821]

Wed Mar 18 00:58:43 2015  Shugo Maeda  <shugo@ruby-lang.org>

	* class.c (method_entry_i, class_instance_method_list,
	  rb_obj_singleton_methods): should not include methods of
	  superclasses if recur is false. [ruby-dev:48854] [Bug #10826]

Wed Mar 18 00:58:43 2015  Shugo Maeda  <shugo@ruby-lang.org>

	* vm_method.c (remove_method): When remove refined
	  method, raise a NameError if the method is not
	  defined in refined class.
	
	  But if the method is defined in refined class,
	  it should keep refined method and remove original
	  method.
	  
	  Patch by Seiei Higa. [ruby-core:67722] [Bug #10765]

Wed Mar 18 00:32:08 2015  Seiei Higa  <hanachin@gmail.com>

	* vm_method.c (check_definition): Module#public_method_defined?,
	  Module#private_method_defined?, Module#protected_method_defined?
	  should not use refinements. [ruby-core:67656] [Bug #10753]

Tue Mar 10 02:40:11 2015  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* thread.c: Improve documentation for Thread#value
	  [Bug #10694][ruby-core:67324][ci skip]

Tue Mar 10 02:37:55 2015  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* string.c: [DOC] Add missing documentation around String#chomp.
	  Patch by @stderr [ci skip][fix GH-780]

Mon Mar  9 22:30:50 2015  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* spec/default.mspec: use default configuration file name.
	  https://github.com/ruby/rubyspec/commit/cc69f337b06362e5607ffa3e3ad40ef7494960cf

Mon Mar  9 22:30:50 2015  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* spec/default.mspec: remove specific version number.
	  https://github.com/ruby/rubyspec/commit/7a909e925c1baa9c700bd44af9241aef6e596714

Mon Mar  9 22:27:47 2015  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* common.mk: use ruby organization for rubyspec.

Mon Mar  9 21:52:41 2015  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/uri/generic.rb (URI::Generic.build):
	  use hostname= to detect and wrap IPv6 hosts.
	  Build is accepting URI components and users may not expect
	  that a host component needs to be wrapped with square brackets
	  since it's not providing a URI.
	  Note: initialize with arg_check => true does not wrap IPv6 hosts.
	  by Joe Rafaniello <jrafanie@redhat.com>
	  https://github.com/ruby/ruby/pull/765 fix GH-765

	* test/uri/test_generic.rb: Add more tests

Tue Mar  3 02:42:27 2015  Eric Wong  <e@80x24.org>

	* ext/io/wait/wait.c (io_nread): wrap return value with INT2FIX
	  Thanks to Yura Sokolov <funny.falcon@gmail.com>
	  [ruby-core:68369] [Bug#10923]
	* test/io/wait/test_io_wait.rb (test_nread_buffered):
	  fix broken test

Sun Mar  1 02:30:23 2015  Seiei Higa  <hanachin@gmail.com>

	* vm_method.c (rb_alias): raise a NameError when creating alias to
	  a refined method if the original method of the refined method is
	  not defined.  [ruby-core:67523] [Bug #10731]

Sun Mar  1 01:17:24 2015  Seiei Higa  <hanachin@gmail.com>

	* vm_method.c (rb_export_method): bail out if the original method
	  is undefined when the method is refined.
	  [ruby-core:67387] [Bug #10706]

Sun Mar  1 01:14:59 2015  Eric Wong  <e@80x24.org>

	* lib/resolv.rb: consider ENETUNREACH as ResolvTimeout
	  [ruby-core:67411] [Bug #10712]

Sun Mar  1 01:01:21 2015  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* lib/net/http.rb (Net::HTTP#send_request): there is no response body
	  with HEAD request. Patch by @rodrigosaito [fix GH-520]

Sun Mar  1 01:01:21 2015  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* test/net/http/test_http.rb (_test_send_request__HEAD): Added
	  failing test for send_request with HEAD method.

Sun Mar  1 00:58:30 2015  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* ext/zlib/zlib.c: fix document of method signatures.
	  [Bug #10668][ruby-core:67186][ci skip]

Sat Feb 28 02:13:17 2015  Tanaka Akira  <akr@fsij.org>

	* lib/resolv.rb (Resolv::DNS::Name#==): Compare an array of Label:Str
	  objects.  Label#Str#== is case-insensitive.

Sat Feb 28 02:13:17 2015  Ben Miller  <bmiller@rackspace.com>

	* lib/resolv.rb (Resolv::DNS::Name#==): DNS is case-insensitive, so the
	  comparison should be case-insensitive as well.
	  [ruby-core:66498] [Bug #10550]

Sat Feb 28 02:13:17 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/resolv.rb (Resolv::DNS::Name): names with different dots
	  should be different.

Thu Feb 19 19:14:34 2015  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/net/http/response.rb (Net::HTTPResponse): require one or more
	  spaces [Bug #10591].
	  by leriksen <leif.eriksen.au@gmail.com>
	  https://github.com/ruby/ruby/pull/782 fix GH-782
	  NOTE: graph.facebook.com returns without SP Reason-Phrase.

Thu Feb 19 19:10:53 2015  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* ext/tk/lib/tkextlib/tcllib/plotchart.rb: fix to invoke correct function
	  of tcllib. Patch by @zalt50 [fix GH-787]

Wed Feb 18 00:27:57 2015  Eric Hodel  <drbrain@segment7.net>

	* lib/net/http.rb:  Do not attempt SSL session resumption when the
	  session is expired.  [Bug #10533]

Wed Feb 18 00:20:36 2015  Eric Wong  <e@80x24.org>

	* vm_eval.c (rb_yield_splat): add missing GC guard
	  [Bug #10509]

Wed Feb 18 00:18:12 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/rdoc/text.rb (expand_tabs): get rid of infinite loop with
	  CR.  should check if substitution occurred too.
	  [ruby-dev:48813] [Bug #10732]

Tue Feb 17 22:59:31 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/resolv.rb (Resolv::DNS::Resource#==, #hash): elements
	  returned by Kernel#instance_variables are Symbols now.
	  [ruby-core:68128] [Bug #10857]

Sun Feb 15 07:29:12 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/socket/getaddrinfo.c (get_addr): reject too long hostname to
	  get rid of GHOST vulnerability on very old platforms.

	* ext/socket/raddrinfo.c (make_hostent_internal): ditto, paranoic
	  check for the canonical name.

Mon Feb  2 22:57:30 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/etc/etc.c (etc_getlogin): set login name encoding properly.
	  [ruby-core:66163] [Bug #10493]

Mon Feb  2 22:47:35 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* proc.c (method_proc): the receiver of binding from method should
	  be same as the receiver of the method.
	  [ruby-core:65917] [Bug #10432]

Mon Feb  2 22:43:42 2015  Aaron Patterson <aaron@tenderlovemaking.com>

	* lib/resolv.rb: fall back if canonicalization fails.
	  Thanks Vit Ondruch for the patch!  [ruby-core:65836]

	* test/resolv/test_dns.rb: test for patch

Mon Feb  2 22:38:53 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (rb_cv_binary_elf): get rid of -e option of cat
	  which is not available on BusyBox, use tr instead.
	  [ruby-core:64824] [Bug #10210]

Thu Jan 22 20:40:36 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/openssl/ossl_cipher.c (ossl_cipher_update_long): update huge
	  data gradually not to exceed INT_MAX.  workaround of OpenSSL API
	  limitation.  [ruby-core:67043] [Bug #10633]

Thu Jan 22 01:14:12 2015  NAKAMURA Usaku  <usa@ruby-lang.org>

	* signal.c (ruby_signal): since SIGKILL is not supported by MSVCRT,
	  should be treated before calling signal(3).
	  [Bug #10615]

Thu Jan 22 01:02:16 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread.c (exec_recursive): use the same last method name as
	  recursive_push in the error message when recursive_pop failed.
	  [ruby-core:66742] [Bug #10579]

Thu Jan 22 01:02:16 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (rb_frame_last_func): return the most recent frame method
	  name.

	* thread.c (recursive_list_access): use the last method name,
	  instead of the current method name which can be unset in some
	  cases, not to use a symbol by the invalid ID.
	  [ruby-core:66742] [Bug #10579]

Thu Jan 22 00:54:00 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (symbol_list): fix the node type of literal symbol list
	  with no interpolation.  [ruby-core:66343]

Thu Jan 22 00:49:52 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* object.c: [DOC] Revise documentation by Marcus Stollsteimer at
	  [ruby-core:66368].  [Bug #10526]

	  * #inspect: be more specific about generated string, remove
	    obsolete example.
	  * #nil?: use code examples instead of different call-seq's.
	  * #tap: clarify what is yielded.
	  * Integer(): be more specific about to_int and to_i, remove
	    reference to Ruby 1.8.
	  * Array(): fix error.
	  * Class: fix variable name style and indentation in example.
	  * improve consistency, fix typos and formatting.

Thu Jan 22 00:49:52 2015  Benoit Daloze  <eregontp@gmail.com>

	* object.c (Module#const_defined?): [DOC] Revise the documentation.
	  Patch by Xavier Noria.
	  [Fixes GH-754] https://github.com/ruby/ruby/pull/754

Thu Jan 22 00:49:52 2015  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* object.c: fix document of Kernel.Stirng by @suzukaze
	  [fix GH-743][ci skip]

Thu Jan 22 00:25:15 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* load.c (rb_f_load): path name needs to be transcoded to OS path
	  encoding.  [ruby-list:49994]

Wed Jan 21 04:36:27 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (NET_LUID): include winsock2.h instead of windows.h.
	  patch by Jon Forums in [ruby-core:67125].  [Bug #10640]

Wed Jan 21 04:36:27 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (NET_LUID): include also ifdef.h as a workaround of
	  a bug in mingw-w64 header.  [ruby-core:67103] [Bug #10640]

Wed Jan  7 22:34:52 2015  NARUSE, Yui  <naruse@ruby-lang.org>

	* tool/config_files.rb: use config.guess in gcc repo.

Tue Jan  6 00:04:38 2015  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* test/ruby/test_io.rb: added timeout for AIX environment.
	  [ruby-core:62983][Bug #9917]

Mon Jan  5 23:58:50 2015  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* test/ruby/test_string.rb(test_LSHIFT_neary_long_max):
	  increase timeout for Arch Linux CI environment.

Wed Dec 31 00:00:09 2014  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/net/http.rb (Net::HTTP.proxy_uri): use initializer instead
	  of parser to handle IPv6 address. [Bug #9129]

Tue Dec 30 23:46:26 2014  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* lib/rubygems/*: upgrade to RubyGems 2.2.3. [Backport #10515]

Thu Nov 13 22:32:34 2014  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* lib/rexml/document.rb: add REXML::Document#document.
	  reported by Tomas Hoger <thoger@redhat.com> and patched by nahi.

Thu Nov  6 22:57:43 2014  Naohisa Goto  <ngotogenome@gmail.com>

	* bignum.c (absint_numwords_generic): set an array element after
	  definition of a variable to fix compile error with older version
	  of fcc (Fujitsu C Compiler) 5.6 on Solaris 10 on Sparc.
	  [Bug #10350] [ruby-dev:48608]

Thu Nov  6 22:36:55 2014  Naohisa Goto  <ngotogenome@gmail.com>

	* compile.c (compile_data_alloc): add padding when strict alignment
	  is required for memory access. Currently, the padding is enabled
	  only when the CPU is 32-bit SPARC and the compiler is GCC.
	  [Bug #9681] [ruby-core:61715]

	* compile.c (STRICT_ALIGNMENT): defined if strict alignment is required

	* compile.c (ALIGNMENT_SIZE, ALIGNMENT_SIZE_MASK, PADDING_SIZE_MAX):
	  new macros for alignemnt word size, bit mask, max size of padding.

	* compile.c (calc_padding): new function to calculate padding size.

Wed Nov  5 00:18:22 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (__builtin_setjmp): disable with gcc/clang earlier
	  than 4.3 on Mac OS X.  [ruby-core:65174] [Bug #10272]

Wed Nov  5 00:01:04 2014  Tanaka Akira  <akr@fsij.org>

	* bignum.c (bary_mul_balance_with_mulfunc): Fix free work area
	  location.
	  [ruby-dev:48723] [Bug #10464]
	  [ruby-core:66044] [Bug #10465]
	  Reported by Kohji Nishihama.

Tue Oct 28 22:30:21 2014  NARUSE, Yui  <naruse@ruby-lang.org>

	* configure.in: remove apple-gcc4.2 from CC candidates.

Tue Oct 28 22:19:44 2014  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* version.h (RUBY_VERSION): bump RUBY_VERSION to 2.1.5.

Mon Oct 27 20:20:14 2014  NAKAMURA Usaku  <usa@ruby-lang.org>

	* lib/rexml/entity.rb: keep the entity size within the limitation.
	  reported by Willis Vandevanter <will@silentrobots.com> and
	  patched by nahi.

Sun Oct 26 03:31:46 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_method.c (rb_method_entry_make): warn redefinition only for
	  already defined methods, but not for undefined methods.
	  [ruby-dev:48691] [Bug #10421]

Sun Oct 26 03:21:30 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* class.c (unknown_keyword_error): delete expected keywords
	  directly from raw table, so that the given block is not called.
	  [ruby-core:65837] [Bug #10413]

Wed Oct 22 23:02:49 2014  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* ext/openssl/lib/openssl/ssl.rb (DEFAULT_PARAMS): override
	  options even if OpenSSL::SSL::OP_NO_SSLv3 is not defined.
	  this is pointed out by Stephen Touset. [ruby-core:65711] [Bug #9424]

Wed Oct 22 23:02:49 2014  Martin Bosslet  <Martin.Bosslet@gmail.com>

	* test/openssl/test_ssl.rb: Reuse TLS default options from
	  OpenSSL::SSL::SSLContext::DEFAULT_PARAMS.

Wed Oct 22 23:02:49 2014  Martin Bosslet  <Martin.Bosslet@gmail.com>

	* lib/openssl/ssl.rb: Explicitly whitelist the default
	  SSL/TLS ciphers. Forbid SSLv2 and SSLv3, disable
	  compression by default.
	  Reported by Jeff Hodges.
	  [ruby-core:59829] [Bug #9424]

Sun Oct 19 03:22:53 2014  Kazuki Tsujimoto  <kazuki@callcc.net>

	* vm_core.h, vm.c, proc.c: fix GC mark miss on bindings.
	  [ruby-dev:48616] [Bug #10368]

	* test/ruby/test_eval.rb: add a test code.

Sun Oct 19 03:13:38 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_here_document): do not append already appended
	  and disposed code fragment.  [ruby-dev:48647] [Bug #10392]

Thu Oct 16 22:10:11 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/stringio/stringio.c (strio_write): ASCII-8BIT StringIO
	  should be writable any encoding strings, without conversion.
	  [ruby-core:65240] [Bug #10285]

Thu Oct 16 22:06:03 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_eval.c (eval_string_with_cref): fix super from eval with
	  scope.  set klass in the current control frame to the class of
	  the receiver in the context to be evaluated, this class/module
	  must match the actual receiver to call super.
	  [ruby-core:65122] [Bug #10263]

Thu Oct 16 00:30:30 2014  Tanaka Akira  <akr@fsij.org>

	* lib/find.rb (Find.find): Call to_path for arguments to obtain
	  strings.
	  [ruby-core:63713] [Bug #10035] Reported by Herwin.

Thu Oct 16 00:20:12 2014  Eric Wong  <e@80x24.org>

	* object.c (rb_class_real): do not dereference 0 VALUE

	* test/ruby/test_module.rb (test_inspect_segfault):
	  Test case and bug report by Thomas Stratmann.
	  [ruby-core:65214] [Bug #10282]

Thu Oct 16 00:10:45 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* signal.c (rb_f_kill): get rid of deadlock as unhandled and
	  discarded signals do not make interrupt_cond signaled.
	  based on the patch by Kazuki Tsujimoto at [ruby-dev:48606].
	  [Bug #9820]

Thu Oct 16 00:10:45 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* signal.c (rb_f_kill): should not ignore signal unless the
	  default handler is registered.  [ruby-dev:48592] [Bug #9820]

Wed Oct 15 23:58:13 2014  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	merge r47598 partially. extracted commits are as follows. [Bug #9728]
	https://github.com/k-takata/Onigmo/commit/15ddec6d18e27fdc1988236764e766fd5892ecf5

Wed Oct 15 23:50:33 2014  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* lib/fileutils.rb: handle ENOENT error with symlink targeted to
	  non-exists file. [ruby-dev:45933] [Bug #6716]

Wed Oct 15 23:25:24 2014  NARUSE, Yui  <naruse@ruby-lang.org>

	* configure.in: NetBSD's ksh, used by configure, needs escapes.

Wed Oct 15 23:13:43 2014  Eric Wong  <e@80x24.org>

	* array.c (ary_recycle_hash): add RB_GC_GUARD
	  (rb_ary_diff): remove volatile
	  [Bug #10369]

Wed Oct 15 23:10:07 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* dir.c (dir_s_aref): fix rdoc.  `Dir.glob` allows an array but
	  `Dir[]` not.  the former accepts an optional parameter `flags`,
	  while the latter accepts arbitrary number of arguments but no
	  `flags`.  [ruby-core:65265] [Bug #10294]

Wed Oct 15 23:08:02 2014  Rei Odaira  <Rei.Odaira@gmail.com>

	* configure.in: Fix typo. [Bug #9914]

Wed Oct 15 22:46:52 2014  NAKAMURA Usaku  <usa@ruby-lang.org>

	* error.c: update exception tree. [DOC]
	  reported by @hemge via twitter.

Wed Sep 24 02:30:55 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parse_ident): just after a label, new expression should
	  start, cannot be a modifier.  [ruby-core:65211] [Bug #10279]

Wed Sep 24 02:21:41 2014  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/Makefile.sub (VCSUP): nothing to do if this worktree is not
	  under any VCS (it means that the worktree may be from the release
	  package).

Wed Sep 24 02:06:33 2014  Tanaka Akira  <akr@fsij.org>

	* test/ruby/test_time_tz.rb: Fix test error with tzdata-2014g.
	  [ruby-core:65058] [Bug #10245] Reported by Vit Ondruch.

Wed Sep 24 02:06:33 2014  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* test/minitest/test_minitest_unit.rb: removed obsoleted condition
	  for Ruby 1.8.
	* test/ruby/test_time_tz.rb: ditto.

Wed Sep 24 01:43:13 2014  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* version.h (RUBY_VERSION): bump RUBY_VERSION to 2.1.4.

Fri Sep 19 00:58:34 2014  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* version.h (RUBY_VERSION): bump RUBY_VERSION to 2.1.3.

Mon Sep 15 23:12:47 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* signal.c (check_stack_overflow): drop the last tag too close to
	  the fault page, to get rid of stack overflow deadlock.
	  [Bug #9971]

Mon Sep 15 22:34:39 2014  Natalie Weizenbaum  <nweiz@google.com>

	* ext/pathname/lib/pathname.rb (SAME_PATHS):
	  Pathname#relative_path_from uses String#casecmp to compare strings
	  on case-insensitive filesystem platforms (e.g., Windows). This can
	  return nil for strings with different encodings, and the code
	  previously assumed that it always returned a Fixnum.  [Fix GH-713]

Mon Sep 15 22:31:33 2014  Sho Hashimoto  <sho.hsmt@gmail.com>

	* ext/fiddle/lib/fiddle/import.rb (Fiddle::Importer#sizeof): fix typo,
	  SIZEOF_LONG_LON.  [Fix GH-714]

Mon Sep 15 11:08:23 2014  Shota Fukumori  <her@sorah.jp>

	* lib/mkmf.rb (configuration): Make CXXFLAGS customizable.
	  Patch by Kohei Suzuki (eagletmt). [Fixes GH-492]

Mon Sep 15 01:06:35 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (MakeMakefile#pkg_config): append --cflags to also
	  $CXXFLAGS, as they are often used by C++ compiler.
	  [ruby-core:54532] [Bug #8315]

Mon Sep 15 00:02:20 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/csv.rb (CSV#<<): honor explicitly given encoding.  based on
	  the patch by DAISUKE TANIWAKI <daisuketaniwaki AT gmail.com> at
	  [ruby-core:62113].  [Bug #9766]

Wed Sep 10 23:36:38 2014  Koichi Sasada  <ko1@atdot.net>

	* test/ruby/test_object.rb: extend timeout.

Wed Sep 10 23:36:38 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* object.c (rb_obj_copy_ivar): allocate no memory for empty
	  instance variables.  [ruby-core:64700] [Bug #10191]

Wed Sep 10 23:36:38 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* object.c (rb_obj_copy_ivar): extract function to copy instance
	  variables only for T_OBJECT from init_copy.

Wed Sep 10 23:14:42 2014  NARUSE, Yui  <naruse@ruby-lang.org>

	merge r46831 partially. extracted commits are as follows. [Bug #9344]
	https://github.com/k-takata/Onigmo/commit/bdfc1997aa15b6baddaf9a482c6610b32504bd86

	* regcomp.c: Merge Onigmo 5.14.1 25a8a69fc05ae3b56a09.
	  this includes Support for Unicode 7.0 [Bug #9092].

Wed Sep 10 22:58:25 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* common.mk (Doxyfile): revert r43888, not to require preinstalled
	  ruby.  [ruby-core:64488] [Bug #10161]

Wed Sep 10 03:29:48 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (io_close): ignore only "closed stream" IOError and
	  NoMethodError, do not swallow other exceptions at the end of
	  block.  [ruby-core:64463] [Bug #10153]

Wed Sep 10 03:17:13 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* enc/trans/euckr-tbl.rb (EUCKR_TO_UCS_TBL): add missing euro and
	  registered signs.  [ruby-core:64452] [Bug #10149]

Wed Sep 10 03:01:31 2014  Eric Wong  <e@80x24.org>

	* time.c (time_timespec): fix tv_nsec overflow
	  [Bug #10144]

Wed Sep 10 02:51:38 2014  Koichi Sasada  <ko1@atdot.net>

	* iseq.c (rb_iseq_clone): Should not insert write barrier from
	  non-RVALUE data (to non-RVALUE data, of course).

	  Ruby 2.1 also has a same problem.

Wed Sep 10 02:33:08 2014  Koichi Sasada  <ko1@atdot.net>

	* parse.y (setup_fake_str): fake strings should not set class by
	  RBASIC_SET_CLASS() because it insert write barriers to fake
	  (non-RVALUE) structure.

	  It can cause unexpected behaviour.

Fri Sep  5 17:01:38 2014  Zachary Scott  <e@zzak.io>

	* lib/rdoc/generator/template/darkfish/js/jquery.js: Backport
	  rdoc/rdoc@74f60fcb04fee1778fe2694d1a0ea6513f8e67b7

Sat Sep  6 00:57:07 2014  Eric Wong  <e@80x24.org>

	* ext/zlib/zlib.c (gzfile_reset): preserve ZSTREAM_FLAG_GZFILE
	  [Bug #10101]

	* test/zlib/test_zlib.rb (test_rewind): test each_byte

Sat Sep  6 00:47:32 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (rb_cv_broken_backtrace): exit with failure
	  normally, no needs to abort.  [ruby-core:63678] [Bug #10008]

Sat Sep  6 00:05:02 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/win32.h, win32/win32.c (rb_w32_inet_pton): add a
	  wrapper function for inet_pton minimum supported client is
	  Vista, as well as inet_ntop.

Sat Sep  6 00:05:02 2014  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* ext/socket/raddrinfo.c (rb_getaddrinfo): second argument of
	  MEMZERO is type.  Coverity Scan found this bug.

Sat Sep  6 00:05:02 2014  Tanaka Akira  <akr@fsij.org>

	* ext/socket/raddrinfo.c (numeric_getaddrinfo): Use xcalloc.
	  Suggested by Eric Wong.
	  https://bugs.ruby-lang.org/issues/9525#note-14

Sat Sep  6 00:05:02 2014  Tanaka Akira  <akr@fsij.org>

	* ext/socket: Bypass getaddrinfo() if node and serv are numeric.
	  Reporeted by Naotoshi Seo.  [ruby-core:60801] [Bug #9525]

	* ext/socket/extconf.rb: Detect struct sockaddr_in6.sin6_len.

	* ext/socket/sockport.h (SET_SIN6_LEN): New macro.
	  (INIT_SOCKADDR_IN6): Ditto.

	* ext/socket/rubysocket.h (struct rb_addrinfo): Add
	  allocated_by_malloc field.

	* ext/socket/raddrinfo.c (numeric_getaddrinfo): New function.
	  (rb_getaddrinfo): Call numeric_getaddrinfo at first.
	  (rb_freeaddrinfo): Free struct addrinfo properly when it is
	  allocated by numeric_getaddrinfo.

Sat Sep  6 00:05:02 2014  Tanaka Akira  <akr@fsij.org>

	* ext/socket: Wrap struct addrinfo by struct rb_addrinfo.

Thu Sep  4 00:31:23 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/thread/thread.c (get_array): check instance variables are
	  initialized properly.  [ruby-core:63826][Bug #10062]

Thu Sep  4 00:29:10 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_io_initialize): [DOC] fix rdoc of append mode.  it does
	  not move the pointer at open.  [ruby-core:63747] [Bug #10039]

Thu Sep  4 00:23:15 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* sprintf.c (GETASTER): should not use the numbered argument to be
	  formatted, raise ArgumentError instead.
	  [ruby-dev:48330] [Bug #9982]

Thu Sep  4 00:21:05 2014  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* test/openssl/test_pkey_rsa.rb (OpenSSL#test_sign_verify_memory_leak):
	  added timeout into testcase for low performance environment.
	  [Bug #9984][ruby-core:63367]

Tue Sep  2 02:21:58 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* hash.c (env_aset, env_has_key, env_assoc, env_has_value),
	  (env_rassoc, env_key): prohibit tainted strings if $SAFE is
	  non-zero.  [Bug #9976]

Tue Sep  2 02:08:12 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* signal.c (rb_f_kill): directly enqueue an ignored signal to self,
	  except for SIGSEGV and SIGBUS.  [ruby-dev:48203] [Bug #9820]

Sun Aug 31 01:13:21 2014  Koichi Sasada  <ko1@atdot.net>

	* gc.c: change full GC timing to keep lower memory usage.

	  Extend heap only at
	  (1) after major GC
	  or
	  (2) after several (two times, at current) minor GC

	  Details in https://bugs.ruby-lang.org/issues/9607#note-9
	  [Bug #9607]

Sun Aug 31 01:07:05 2014  Masaki Suketa <masaki.suketa@nifty.ne.jp>

	* ext/win32ole/win32ole.c (ole_create_dcom): use the converted
	  result if the argument can be converted to a string, to get rid
	  of invalid access. Thanks to nobu. [ruby-dev:48467] [Bug #10127]

Sun Aug 31 00:54:47 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* process.c (open): use UTF-8 version function to support
	  non-ascii path properly.  [ruby-core:63185] [Bug #9946]

Tue Aug 26 00:08:40 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (RUBY_SETJMP_TYPE): check for setjmp type after
	  CCDLFLAGS is appended to CFLAGS, since __builtin_setjmp can be
	  affected.  [ruby-core:62469] [Bug #9818]

Tue Aug 26 00:07:20 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in: get rid of __builtin_setjmp/__builtin_longjmp on
	  x64-mingw, which causes SEGV with callcc.
	  [ruby-core:61887] [Bug #9710]

Tue Aug 26 00:06:05 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (ac_cv_func___builtin_setjmp): should not skip
	  flags restoration in RUBY_WERROR_FLAG by `break`.
	  [ruby-dev:48086] [Bug #9698]

Tue Aug 26 00:02:51 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (ac_cv_func___builtin_setjmp): __builtin_longjmp()
	  in Apple LLVM 5.1 (LLVM 3.4svn) uses `void**`, not `jmp_buf`.
	  [Bug #9692]

Tue Aug 26 00:02:51 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (ac_cv_func___builtin_setjmp): gcc 4.9 disallows a
	  variable as the second argument of __builtin_longjmp().
	  [ruby-core:61800] [Bug #9692]

Mon Aug 25 00:36:56 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_yylex): fix invalid char in eval, should raise
	  an syntax error too, as well as directly coded.
	  [ruby-core:64243] [Bug #10117]

Mon Aug 25 00:26:12 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_yyerror): preserve source code encoding in
	  syntax error messages.  [ruby-core:64228] [Bug #10114]

Sat Aug 23 02:39:20 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_insnhelper.c (vm_call_method): unusable super class should cause
	  method missing when BasicObject is refined but not been using.
	  [ruby-core:64166] [Bug #10106]

Sat Aug 23 02:22:02 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_count): fix wrong single-byte optimization.
	  7bit ascii can be a trailing byte in Shift_JIS.
	  [ruby-dev:48442] [Bug #10078]

Thu Aug 21 01:44:46 2014  Tanaka Akira  <akr@fsij.org>

	* gc.c (mark_current_machine_context): Call SET_STACK_END.
	  This reverts a hunk of r40703 by ko1.
	  This fixes [ruby-dev:48098] [Bug #9717].

Thu Aug 21 01:41:09 2014  Tanaka Akira  <akr@fsij.org>

	* lib/time.rb (Time.parse): [DOC] Fix an example in the documentation
	  to use EST.
	  Reported by Marcus Stollsteimer.
	  [ruby-core:60778] [Bug #9521] and [ruby-core:61718] [Bug #9682]

Thu Aug 21 01:41:09 2014  Zachary Scott  <e@zzak.io>

	* lib/time.rb: [DOC] Fix timezone in example of Time.parse [Bug #9521]
	  Based on patch by @stomar

Tue Aug 19 23:31:48 2014  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	merge r46831 partially. extracted commits are as follows.
	https://github.com/k-takata/Onigmo/commit/b9fba1dc63ccb42a86e934011b468e6022fabb74
	https://github.com/k-takata/Onigmo/commit/c1fc76b9bd463948ffc5058bc352bf93732f0314
	https://github.com/k-takata/Onigmo/commit/a0efc0a200f7108ca3d5ac3039c8f952e0051619
	https://github.com/k-takata/Onigmo/commit/c7cda4ed5676167b0d01bb5555724f6164fbdb13
	[Bug #8716]

	* include/ruby/oniguruma.h (ONIG_MAX_CAPTURE_GROUP_NUM,
	  ONIGERR_TOO_MANY_CAPTURE_GROUPS): add cheking the number of capture
	  groups.

	* regerror.c (onig_error_code_to_format): ditto.

	* regparse.c (scan_env_add_mem_entry): ditto.

	* regexec.c (onig_region_copy, match_at): fix: segmation fault occurs
	  when many groups are used.

Mon Aug 18 23:38:21 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* encoding.c (enc_find): [DOC] never accepted a symbol.
	  [ruby-dev:48308] [Bug #9966]

Mon Aug 18 23:22:03 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_resize): update capa only when buffer get
	  reallocated.
	  http://d.hatena.ne.jp/nagachika/20140613/ruby_trunk_changes_46413_46420#r46413

Mon Aug 18 23:22:03 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_resize): should consider the capacity instead
	  of the old length, as pointed out by nagachika.

Mon Aug 18 23:22:03 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (expand_path): shrink expanded path which no longer needs
	  rooms to append.  [ruby-core:63114] [Bug #9934]

Mon Aug 11 23:55:32 2014  Mark Lorenz  <mlorenz@covermymeds.com>

	* lib/erb.rb (result): [DOC] no longer accepts a Proc, as
	  Kernel.eval does not.  [fix GH-619]

Mon Aug 11 23:38:20 2014  Tanaka Akira  <akr@fsij.org>

	* io.c (rb_io_autoclose_p): Don't raise on frozen IO.

Mon Aug 11 23:38:20 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_io_fileno, rb_io_inspect): non-modification does not
	  error on frozen IO.  [ruby-dev:48241] [Bug #9865]

Mon Aug 11 22:34:47 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (posix_fadvise): disable use of posix_fadvise
	  itself on 32-bit AIX.  [ruby-core:62968] [Bug #9914]

Mon Aug 11 22:34:47 2014    <kanemoto@ruby-lang.org>

	* io.c (rb_io_advise): AIX currently does not support a 32-bit call to
	  posix_fadvise() if _LARGE_FILES is defined. Patch by Rei Odaira.
	  [ruby-core:62968] [Bug #9914]

Mon Aug 11 22:14:28 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_insnhelper.c (vm_callee_setup_keyword_arg): adjust VM stack
	  pointer to get rid of overwriting splat arguments by arguments
	  for `to_hash` conversion.  [ruby-core:63593] [Bug #10016]

Fri Aug  8 23:36:01 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/stringio/stringio.c (strio_write): use rb_str_append to
	  reuse coderange bits other than ASCII-8BIT, and keep
	  taintedness.  [ruby-dev:48118] [Bug #9769]

Mon Aug  4 01:29:57 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* hash.c (env_shift): fix memory leak on Windows, free environment
	  strings block always.  [ruby-dev:48332] [Bug #9983]

Mon Aug  4 01:26:46 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* hash.c (env_select): fix memory leak and crash on Windows, make
	  keys array first instead of iterating on environ directly.
	  [ruby-dev:48325] [Bug #9978]

Mon Aug  4 01:24:09 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* hash.c (ruby_setenv): fix memory leak on Windows, free
	  environment strings block after check for the size.
	  [ruby-dev:48323] [Bug #9977]

Mon Aug  4 01:11:07 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* re.c (match_aref, rb_reg_regsub): consider encoding of captured
	  names, encoding-incompatible should not match.
	  [ruby-dev:48278] [Bug #9903]

Mon Aug  4 00:52:42 2014  Koichi Sasada  <ko1@atdot.net>

	* vm_eval.c (rb_catch_protect): fix same problem of [Bug #9961].

	* vm_eval.c (rb_iterate): ditto.

Mon Aug  4 00:52:42 2014  Koichi Sasada  <ko1@atdot.net>

	* vm.c (rb_vm_rewind_cfp): add new function to rewind specified cfp
	  with invoking RUBY_EVENT_C_RETURN.
	  [Bug #9961]

	* vm_core.h: ditto.

	* eval.c (rb_protect): use it.

	* eval.c (rb_rescue2): ditto.

	* vm_eval.c (rb_iterate): ditto.

	* test/ruby/test_settracefunc.rb: add a test.

	* vm_core.h (rb_vm_rewind_cfp): add the prototype declaration.

Sun Aug  3 00:06:10 2014  Charlie Somerville  <charliesome@ruby-lang.org>

	* node.c (dump_node): handle nd_value == (NODE *)-1 to mean this
	  keyword argument is required

Thu Jul 31 01:56:11 2014  Koichi Sasada  <ko1@atdot.net>

	* compile.c (rb_iseq_compile_node): put start label of block after
	  trace (b_call).
	  [Bug #9964]

	* test/ruby/test_settracefunc.rb: add a test.

	  added assert_consistent_call_return() method check call/return
	  consistency.

Thu Jul 31 01:22:43 2014  Koichi Sasada  <ko1@atdot.net>

	* vm.c (invoke_block_from_c): move call/return event timing for
	  bmethod. It can invoke inconsistent call event if this call raises
	  argument error.
	  [Bug #9959]

	* vm_insnhelper.c (vm_call_bmethod_body): ditto.

	* test/ruby/test_settracefunc.rb: add a test.

Thu Jul 31 01:12:55 2014  Koichi Sasada  <ko1@atdot.net>

	* vm_core.h: add VM_FRAME_MAGIC_RESCUE to recognize normal block or
	  rescue clause.

	* vm.c (vm_exec): use VM_FRAME_MAGIC_RESCUE on at rescue/ensure.

	* test/ruby/test_settracefunc.rb: should not invoke b_return at rescue
	  clause.
	  [Bug #9957]

	* vm_dump.c (control_frame_dump): check VM_FRAME_MAGIC_RESCUE.

	* vm_dump.c (vm_stack_dump_each): ditto.

Thu Jul 31 00:44:34 2014  Koichi Sasada  <ko1@atdot.net>

	* vm_trace.c: clear and restore recursive checking thread local data
	  to avoid unexpected throw from TracePoint.
	  [Bug #9940]

	* test/ruby/test_settracefunc.rb: add a test.

	* thread.c: added
	  * rb_threadptr_reset_recursive_data(rb_thread_t *th);
	  * rb_threadptr_restore_recursive_data(rb_thread_t *th, VALUE old);

	* vm_core.h: ditto.

Wed Jul 23 23:49:59 2014  Hiroshi Shirosaki  <h.shirosaki@gmail.com>

	* lib/test/unit/parallel.rb: fix test-all parallel failure if a test
	  is skipped after raise.
	  DL::TestFunc#test_sinf is skipped after raise on mingw ruby.
	  But it causes Marshal.load failure due to undefined class/module
	  DL::DLError when doing test-all parallel and test-all doesn't
	  complete. We create new MiniTest::Skip object to avoid Marshal.load
	  failure.
	  [ruby-core:62133] [Bug #9767]

	* test/testunit/test_parallel.rb (TestParallel): add a test.

	* test/testunit/tests_for_parallel/ptest_forth.rb: ditto.

Wed Jul 23 23:11:28 2014  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* test/socket/test_socket.rb: unix socket is required by test case.

Wed Jul 23 23:11:28 2014  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* test/socket/test_addrinfo.rb: remove unused variables.
	* test/socket/test_nonblock.rb: ditto.
	* test/socket/test_socket.rb: ditto.
	* test/socket/test_unix.rb: ditto.
	* test/testunit/test_parallel.rb: ditto.
	* test/webrick/test_filehandler.rb: ditto.
	* test/xmlrpc/test_features.rb: ditto.
	* test/zlib/test_zlib.rb: ditto.

Wed Jul 23 23:05:19 2014  Tanaka Akira  <akr@fsij.org>

	* ext/pathname/lib/pathname.rb (cleanpath_aggressive): make all
	  separators File::SEPARATOR from File::ALT_SEPARATOR.
	  Reported by Daniel Rikowski.
	  Fixed by Nobuyoshi Nakada.  [Bug #9618]

	* ext/pathname/lib/pathname.rb (cleanpath_conservative): ditto.

Wed Jul 23 22:51:34 2014  Naohisa Goto  <ngotogenome@gmail.com>

	* lib/fileutils.rb (rmdir): rescue Errno::EEXIST in addition to
	  ENOTEMPTY (and ENOENT), because SUSv3 describes that "If the
	  directory is not an empty directory, rmdir() shall fail and set
	  errno to [EEXIST] or [ENOTEMPTY]" and Solaris uses EEXIST.
	  [Bug #9571] [ruby-dev:48017]

Wed Jul 23 22:43:50 2014  Tanaka Akira  <akr@fsij.org>

	* lib/resolv.rb (bind_random_port): Rescue EPERM for FreeBSD which
	  security.mac.portacl.port_high is changed.
	  See mac_portacl(4) for details.
	  Reported by Jakub Szafranski.  [ruby-core:60917] [Bug #9544]

Wed Jul 23 22:24:26 2014  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* test/openssl/test_x509cert.rb: split assertions into algorithms.
	  CentOS 7 seems finish MD5 support
	  http://chkbuild005.hsbt.org/chkbuild/ruby-trunk/log/20140722T140010Z.fail.html.gz

	* test/openssl/test_x509req.rb: ditto.

Sat Jul 19 01:44:34 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* re.c (match_aref): should not ignore name after NUL byte.
	  [ruby-dev:48275] [Bug #9902]

Sun Jul 13 23:28:41 2014  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* test/test_timeout.rb (test_timeout): inverted test condition.
	  [Bug #8523]

Sun Jul 13 23:18:11 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/digest/digest.c (rb_digest_instance_equal): no need to call
	  `to_s` twice.  [Bug #9913]

Sun Jul 13 23:18:11 2014  Benoit Daloze  <eregontp@gmail.com>

	* ext/digest/digest.c (rb_digest_instance_equal):
	  fix #== for non-string arguments. [ruby-core:62967] [Bug #9913]

	* test/digest/test_digest.rb: add test for above.

Sun Jul 13 23:10:03 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* array.c (yield_indexed_values): extract from permute0(),
	  rpermute0(), and rcombinate0().

Sun Jul 13 23:02:36 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* array.c (rb_ary_permutation): `p` is the array of size `r`, as
	  commented at permute0().  since `n >= r` here, buffer overflow
	  never happened, just reduce unnecessary allocation though.

Sun Jul 13 22:52:43 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* pack.c (encodes): fix buffer overrun by tail_lf.  Thanks to
	  Mamoru Tasaka and Tomas Hoger.  [ruby-core:63604] [Bug #10019]

Sun Jul 13 22:44:05 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/thread/thread.c (undumpable): ConditionVariable and Queue
	  are not dumpable.  [ruby-core:61677] [Bug #9674]

Fri Jul 11 23:07:09 2014  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/matrix.rb: Fix sign for cross_product [#9499]

Sun Jul  6 23:16:30 2014  Masaya Tarui  <tarui@ruby-lang.org>

	* st.c (st_foreach_check): change start point of search at check
	  from top to current. [ruby-dev:48047] [Bug #9646]

Sun Jul  6 22:56:03 2014  Zachary Scott  <e@zzak.io>

	* lib/gserver.rb: [DOC] Fixed typo in example by @stomar [Bug #9543]

Fri Jul  4 00:46:03 2014  Zachary Scott  <e@zzak.io>

	* enumerator.c: [DOC] Fix example to show Enumerator#peek behavior
	  Patch by Erik Hollembeak [Bug #9814]

Fri Jul  4 00:44:43 2014  Zachary Scott  <e@zzak.io>

	* enum.c: [DOC] Use #find in example to clarify alias by @rachellogie
	  Patch submitted via documenting-ruby/ruby#34

Fri Jul  4 00:42:57 2014  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* man/ruby.1: remove deadlink. [ruby-core:62145][Bug #9773]

Fri Jul  4 00:25:16 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* struct.c (not_a_member): extract name error and use same error
	  messages.  based on the patch by Marcus Stollsteimer <sto.mar AT
	  web.de> at [ruby-core:61721].  [Bug #9684]

Thu Jul  3 01:19:50 2014  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* numeric.c (num_step_scan_args): table argument of rb_get_kwargs() is
	  array of IDs, not Symbols. [ruby-dev:48353] [Bug #9811]

Thu Jul  3 01:19:50 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* numeric.c (num_step_scan_args): check keyword arguments and fail
	  if they conflict with positional arguments.
	  [ruby-dev:48177] [Bug #9811]

Tue Jul  1 03:05:22 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (read_all): truncate the buffer before appending read data,
	  instead of truncating before reading.
	  [ruby-core:55951] [Bug #8625]

Tue Jul  1 03:05:22 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (io_setstrbuf, io_read): should not shorten the given buffer until
	  read succeeds.  [ruby-core:55951] [Bug #8625]

Mon Jun 30 03:15:59 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm.c (core_hash_merge_kwd): should return the result hash, which
	  may be converted from and differ from the given argument.
	  [ruby-core:62921] [Bug #9898]

Mon Jun 30 03:07:22 2014  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/ftp.rb (gets, readline): read lines without LF properly.
	  [ruby-core:63205] [Bug #9949]

	* test/net/ftp/test_buffered_socket.rb: related test.

Mon Jun 30 02:59:08 2014  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/imap.rb (body_type_1part): Gmail IMAP reports a body
	  type as "MIXED" followed immediately by params
	  [ruby-core:62864] [Bug #9885]
	  Patch by @rayners (David Raynes). [Fixes GH-622] 
	  https://github.com/ruby/ruby/pull/622

Mon Jun 30 02:46:44 2014  Rei Odaira  <Rei.Odaira@gmail.com>

	* signal.c (ruby_signal): should return either `old.sa_sigaction`
	  or `old.sa_handler`, depending on whether `SA_SIGINFO` is set in
	  `old.sa_flags`, because they may not be a union.
	  [ruby-core:62836] [Bug #9878]

Mon Jun 30 02:36:08 2014  Eric Wong  <e@80x24.org>

	* process.c (proc_getgroups, proc_setgroups): use ALLOCV_N
	  [Bug #9856]

Mon Jun 30 02:28:10 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (io_setstrbuf): always check if the buffer is modifiable.
	  [ruby-core:62643] [Bug #9847]

Mon Jun 30 02:25:00 2014  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/lib/openssl/ssl.rb (OpenSSL::SSL::SSLServer#accept):
	  Consider Socket#accept as well as TCPServer#accept.
	  Reported by Sam Stelfox.  [ruby-core:62064] [Bug #9750]

Mon Jun 30 02:18:47 2014  Eric Wong  <e@80x24.org>

	* complex.c (parse_comp): replace ALLOCA_N with ALLOCV_N/ALLOCV_END
	  [Bug #9608]
	* rational.c (read_digits): ditto

Mon Jun 30 02:10:34 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vsnprintf.c (BSD_vfprintf): fix string width when precision is
	  given.  as the result of `memchr` is NULL or its offset from the
	  start cannot exceed the size, the comparison was always false.
	  [ruby-core:62737] [Bug #9861]

Mon Jun 30 01:46:19 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/fiddle/extconf.rb: supply 0 to fill RUBY_LIBFFI_MODVERSION
	  with 3-digit.  libffi 3.1 returns just 2-digit.
	  [ruby-core:62920] [Bug #9897]

Mon Jun 30 00:57:05 2014  Koichi Sasada  <ko1@atdot.net>

	* vm.c (rb_vm_pop_cfunc_frame): added.  It cares c_return event.
	  The patch base by drkaes (Stefan Kaes).
	  [Bug #9321]

	* variable.c (rb_mod_const_missing): use rb_vm_pop_cfunc_frame()
	  instead of rb_frame_pop().

	* vm_eval.c (raise_method_missing): ditto.

	* vm_eval.c (rb_iterate): ditto.

	* internal.h (rb_vm_pop_cfunc_frame): add decl.

	* test/ruby/test_settracefunc.rb: add tests.
	  provided by drkaes (Stefan Kaes).

	* vm.c, eval.c, include/ruby/intern.h (rb_frame_pop):
	  move definition of rb_frame_pop() and deprecate it.
	  It doesn't care about `return' events.

Sun Jun 29 01:34:06 2014  Tanaka Akira  <akr@fsij.org>

	* lib/webrick/utils.rb (create_listeners): Close socket objects.

Sat Jun 28 16:35:51 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_substr): need to reset code range for shared
	  string too, not only copied string.
	  [ruby-core:62842] [Bug #9882]

Sat Jun 28 14:37:17 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (local_tbl_gen): remove local variables duplicated with
	  arguments.
	  [ruby-core:60501] [Bug #9486]

Tue Jun 24 00:21:58 2014  Koichi Sasada  <ko1@atdot.net>

	* eval.c (rb_using_refinement): add write-barriers for
	  cref->nd_refinements.

Tue Jun 24 00:14:20 2014  Tanaka Akira  <akr@fsij.org>

	* lib/net/ftp.rb (transfercmd): Close TCP server socket even if an
	  exception occur.

Tue Jun 24 00:06:41 2014  Hiroshi Shirosaki  <h.shirosaki@gmail.com>

	* thread_win32.c (rb_w32_stack_overflow_handler): use Structured
	  Exception Handling by AddVectoredExceptionHandler() for machine
	  stack overflow on mingw.
	  This would be equivalent to the handling using __try and __except
	  on mswin introduced by r43748.

Mon Jun 23 23:56:54 2014  Eric Wong  <e@80x24.org>

	* signal.c (signal_exec): ignore immediate cmd for SIG_IGN
	* signal.c (trap_handler): set cmd to true for SIG_IGN
	* signal.c (trap): handle nil and true values for oldcmd
	  [Bug #9835]

Mon Jun 23 02:46:14 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* class.c (rb_mod_init_copy): always clear instance variable,
	  constant and method tables first, regardless the source tables.
	  [ruby-dev:48182] [Bug #9813]

Mon Jun 23 02:36:04 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread.c (thread_start_func_2): stop if forked in a sub-thread,
	  the thread has become the main thread.
	  [ruby-core:62070] [Bug #9751]

Mon Jun 23 01:53:18 2014  Josh Goebel  <dreamer3@gmail.com>

	* net/protocol.rb (using_each_crlf_line): fix SMTP dot-stuffing
	  for messages not ending with a new-line.
	  [ruby-core:61441] [Bug #9627] [fix GH-616]

Fri Jun 20 00:40:06 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread_pthread.c (ruby_init_stack, ruby_stack_overflowed_p):
	  place get_stack above others to get stack boundary information.
	  [ruby-core:60113] [Bug #9454]

Fri Jun 20 00:40:06 2014  NARUSE, Yui  <naruse@ruby-lang.org>

	* thread_pthread.c: rlimit is only available on Linux.
	  At least r44712 breaks FreeBSD.
	  [ruby-core:60113] [Bug #9454]

Fri Jun 20 00:40:06 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread_pthread.c: get current main thread stack size, which may
	  be expanded than allocated size at initialization, by rlimit().
	  [ruby-core:60113] [Bug #9454]

Fri Jun 20 00:20:02 2014  Hiroshi Shirosaki  <h.shirosaki@gmail.com>

	* configure.in: enable SSE2 on mingw. target='i386-pc-mingw32'.
	  [ruby-core:62095] [Bug #8358]

Tue Jun 17 00:45:44 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (compile_array_): make copy a first hash not to modify
	  the argument itself.  keyword splat should be non-destructive.
	  [ruby-core:62161] [Bug #9776]

Tue Jun 17 00:37:15 2014  Bugra Barin  <bugrabarin@hotmail.com>

	* dln.c (dln_load): use wchar version to load a library in
	  non-ascii path on Windows.  based on the patch by Bugra Barin
	  <bugrabarin AT hotmail.com> in [ruby-core:61845].  [Bug #9699]

Tue Jun 17 00:26:59 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* process.c (obj2uid, obj2gid): now getpwnam_r() and getgrnam_r()
	  may need larger buffers than sysconf values, so retry with
	  expanding the buffer when ERANGE is returned.
	  [ruby-core:61325] [Bug #9600]

Wed Jun 11 22:58:30 2014  Eric Wong  <e@80x24.org>

	* gc.c (ruby_gc_set_params): simplify condition

Wed Jun 11 22:58:30 2014  Eric Wong  <e@80x24.org>

	* gc.c (ruby_gc_set_params): fix building without RGenGC

Wed Jun 11 02:43:32 2014  Kazuki Tsujimoto  <kazuki@callcc.net>

	* test/objspace/test_objspace.rb (TestObjSpace#test_dump_uninitialized_file):
	  remove dependency on json library.

Wed Jun 11 02:43:32 2014  Scott Francis  <scott.francis@shopify.com>

	* ext/objspace/objspace_dump.c: Check fptr before trying to dump RFILE
	  object fd. [GH-562]

	* test/objspace/test_objspace.rb: add test

Wed Jun 11 02:27:55 2014  Akinori MUSHA  <knu@iDaemons.org>

	* configure.in: Fix a build problem with clang and --with-opt-dir.
	  If ruby is configured with --with-opt-dir=dir when using clang
	  as compiler, a warning `clang: warning: argument unused during
	  compilation: '-I dir'` is emitted almost every time clang
	  compiles a file.  Unfortunately, RUBY_CHECK_PRINTF_PREFIX takes
	  any output from the compiler as fatal error, and the check thus
	  fails due to the warning.  This is an attempt to fix the problem
	  by adding a flag -Qunused-arguments to CFLAGS locally in the
	  function to suppress the warning. [ruby-dev:48062] [Bug #9658]
	  [Fixes GH-571] https://github.com/ruby/ruby/pull/571

Wed Jun 11 02:18:34 2014  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* numeric.c: Fix Numeric#step with 0 unit [Bug #9575]

Wed Jun 11 00:36:05 2014  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* test/ruby/test_string (test_LSHIFT_neary_long_max): extend timeout.
	  this test fails on some CI environment by timeout.

Sat Jun  7 01:17:16 2014  Tanaka Akira  <akr@fsij.org>

	* signal.c (check_stack_overflow): Don't use ucontext_t if ucontext.h
	  is not available.
	  Fixes build on Android (x86).

Tue Jun  3 00:38:33 2014  Eric Wong  <e@80x24.org>

	* class.c (rb_class_subclass_add): use xmalloc
	* class.c (rb_module_add_to_subclasses_list): ditto
	* class.c (rb_class_remove_from_super_subclasses): use xfree
	* class.c (rb_class_remove_from_module_subclasses): ditto
	  [Bug #9616]

Mon Jun  2 02:19:30 2014  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (rb_w32_accept, open_ifs_socket, socketpair_internal):
	  reset inherit flag of socket to avoid unintentional inheritance of
	  socket.  note that the return value of SetHandleInformation() is not
	  verified intentionally because old Windows may return an error.
	  [Bug #9688] [ruby-core:61754]

Mon Jun  2 02:12:10 2014  Eric Wong  <e@80x24.org>

	* time.c (time_mload): freeze and preserve marshal-loaded time zone
	* test/ruby/test_time.rb: add test for GC on loaded object
	  [Bug #9652]

Mon Jun  2 01:57:59 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_insnhelper.c (vm_callee_setup_arg): turn a macro into an
	  inline function.

Mon Jun  2 01:46:43 2014  Eric Wong  <e@80x24.org>

	* variable.c (rb_const_set): delete existing entry on redefinition
	  [Bug #9645]
	* test/ruby/test_const.rb (test_redefinition): test for leak

Fri May 30 00:13:19 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (setup_exception): preserve errinfo across calling #to_s
	  method on the exception.  [ruby-core:61091] [Bug #9568]

Thu May 29 20:57:59 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* numeric.c (ruby_num_interval_step_size): check signs and get rid
	  of implementation dependent behavior of negative division.
	  [ruby-core:61106] [Bug #9570]

Wed May 28 23:47:22 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (rb_cv_func___builtin_unreachable): try with an
	  external variable not only by a warning, which might not be
	  shown due to the optimization.  [ruby-core:61647] [Bug #9665]

Wed May 28 23:40:57 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/openssl/ossl_asn1.c (ossl_asn1_initialize): SYMID on a value
	  other than Symbol is an undefined behavior.  fix up r31699.
	  [ruby-core:62142] [Bug #9771]

Wed May 28 23:37:32 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/stringio/stringio.c (strio_putc): fix for non-ascii
	  encoding, like as IO#putc.  [ruby-dev:48114] [Bug #9765]

Wed May 28 01:05:06 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/fileutils.rb (FileUtils#copy_entry): update rdoc about
	  preserve option and permissions, following r31123.
	  [ruby-core:62065] [Bug #9748]

Wed May 28 00:57:06 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* proc.c (umethod_bind): use the ancestor iclass instead of new
	  iclass to get rid of infinite recursion, if the defined module
	  is already included.  [ruby-core:62014] [Bug #9721]

Wed May 28 00:57:06 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* proc.c (rb_method_call_with_block, umethod_bind): call with
	  IClass including the module for a module instance method.
	  [ruby-core:61936] [Bug #9721]

	* vm_insnhelper.c (vm_search_super_method): allow bound
	  UnboundMethod case.

Wed May 28 00:38:37 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* array.c (ary_reject): may be turned into a shared array during
	  the given block.  [ruby-dev:48101] [Bug #9727]

Wed May 28 00:29:02 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (str_buf_cat): should round up the capacity by 4KiB,
	  but not number of rooms.  [ruby-core:61886] [Bug #9709]

Wed May 28 00:23:11 2014  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/xmlrpc/client.rb (do_rpc): don't check body length.
	  If HTTP content-encoding is used, the length may be different.
	  [Bug #8182] [ruby-core:53811]

Wed May 28 00:18:29 2014  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c (d_lite_cmp): should compare with #<.

Fri May 23 00:04:13 2014  Tanaka Akira  <akr@fsij.org>

	* ext/socket/socket.c (sock_s_getnameinfo): Save errno for EAI_SYSTEM.
	  Reported by Saravana kumar.  [ruby-core:61820] [Bug #9697]
	  Fixed by Heesob Park.  [ruby-core:61868]

Fri May 23 00:04:13 2014  Tanaka Akira  <akr@fsij.org>

	* ext/socket: Wrap struct addrinfo by struct rb_addrinfo.

Fri May 23 00:04:13 2014  Tanaka Akira  <akr@fsij.org>

	* ext/socket/ipsocket.c (ip_s_getaddress): Don't access freed memory.

Mon May 19 00:47:00 2014  Koichi Sasada  <ko1@atdot.net>

	* test/ruby/test_array.rb: remove useless `assert'.

Mon May 19 00:47:00 2014  Koichi Sasada  <ko1@atdot.net>

	* array.c (rb_ary_modify): remember shared array owner if a shared
	  array owner is promoted and a shared array is not promoted.

	  Now, shared array is WB-unprotected so that shared arrays are not
	  promoted.  All objects referred from shared array should be marked
	  correctly.

	  [ruby-core:61919] [ruby-trunk - Bug #9718]

	* test/ruby/test_array.rb: add a test for above.

Mon May 19 00:26:53 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_yylex): only a newline after label should be
	  significant.  [ruby-core:61658] [Bug #9669]

Mon May 19 00:26:53 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (lex_state_e, parser_params, f_arglist, parser_yylex):
	  separate EXPR_LABELARG from EXPR_BEG and let newline significant,
	  so that required keyword argument can place at the end of
	  argument list without parentheses.  [ruby-core:61658] [Bug #9669]

Fri May 16 00:27:02 2014  James Edward Gray II  <james@graysoftinc.com>

	* lib/csv.rb: Fixed a broken regular expression that was causing
	  CSV to miss escaping some special meaning characters when used
	  in parsing.
	  Reported by David Unric
	  [ruby-core:54986] [Bug #8405]

Fri May 16 00:14:25 2014  Kohei Suzuki  <eagletmt@gmail.com>

	* vm_method.c (rb_method_entry_get_without_cache): me->klass is 0
	  for a method aliased in a module.  [ruby-core:61636] [Bug #9663]

Fri May 16 00:14:25 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_method.c (rb_method_entry_get_without_cache): get rid of
	  infinite recursion at aliases in a subclass and a superclass.
	  return actually defined class for other than singleton class.
	  [ruby-core:60431] [Bug #9475]

Mon May 12 22:53:08 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (primary): flush cmdarg flags inside left-paren in a
	  command argument, to allow parenthesed do-block as an argument
	  without arguments parentheses.  [ruby-core:61950] [Bug #9726]

Mon May 12 22:22:43 2014  Koichi Sasada  <ko1@atdot.net>

	* vm.c (invoke_block_from_c): add VM_FRAME_FLAG_BMETHOD to record
	  it is bmethod frame.

	* vm.c (vm_exec): invoke RUBY_EVENT_RETURN event if rollbacked frame
	  is VM_FRAME_FLAG_BMETHOD.
	  [Bug #9759]

	* test/ruby/test_settracefunc.rb: add a test for TracePoint/set_trace_func.

	* vm_core.h: rename rb_thread_t::passed_me to
	  rb_thread_t::passed_bmethod_me to clarify the usage.

	* vm_insnhelper.c (vm_call_bmethod_body): use renamed member.

Mon May 12 22:11:47 2014  Shota Fukumori  <her@sorah.jp>

	* vm_eval.c (eval_string_with_cref): Unify to use NIL_P.

Mon May 12 22:11:47 2014  Shota Fukumori  <her@sorah.jp>

	* vm_eval.c (eval_string_with_cref): Use file path even if scope is
	  given. Related to [ruby-core:56099] [Bug #8662] and r42103.

Thu May  8 01:13:10 2014  NARUSE, Yui  <naruse@ruby-lang.org>

	* configure.in: correct pthread_setname_np's prototype on NetBSD.
	  [Bug #9586]

Tue May  6 00:54:56 2014  Narihiro Nakamura  <authornari@gmail.com>

	* gc.c (gc_after_sweep): suppress unnecessary expanding heap.
	  Tomb heap pages are freed pages here, so expanding heap is
	  not required.

Mon May  5 02:35:20 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/openssl/ossl_pkey.c (ossl_pkey_verify): as EVP_VerifyFinal()
	  finalizes only a copy of the digest context, the context must be
	  cleaned up after initialization by EVP_MD_CTX_cleanup() or a
	  memory leak will occur.  [ruby-core:62038] [Bug #9743]

Mon May  5 02:21:48 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/dl/cptr.c (dlptr_free), ext/dl/handle.c (dlhandle_free),
	  ext/fiddle/handle.c (fiddle_handle_free),
	  ext/fiddle/pointer.c (fiddle_ptr_free): fix memory leak.
	  based on the patch Heesob Park at [ruby-dev:48021] [Bug #9599].

Mon May  5 01:20:27 2014  Eric Wong  <e@80x24.org>

	* gc.c (rb_gc_writebarrier): drop special case for big hash/array
	  [Bug #9518]

Mon May  5 01:13:00 2014  Koichi Sasada  <ko1@atdot.net>

	* gc.c (gc_before_sweep): cap `malloc_limit' to
	  gc_params.malloc_limit_max.  It can grow and grow with such case:
	    `loop{"a" * (1024 ** 2)}'
	  [Bug #9687]

	  This issue is pointed by Tim Robertson.
	  http://www.omniref.com/blog/blog/2014/03/27/ruby-garbage-collection-still-not-ready-for-production/

Mon May  5 00:52:18 2014  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (BigDecimal_initialize): Insert GC guard.

	* ext/bigdecimal/bigdecimal.c (BigDecimal_global_new): ditto.

Mon May  5 00:42:35 2014  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* ext/psych/psych.gemspec: update gemspec for psych-2.0.5

Mon May  5 00:42:35 2014  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* ext/psych/lib/psych.rb: Merge psych-2.0.5. bump version to
	  libyaml-0.1.6 for CVE-2014-2525.
	* ext/psych/yaml/config.h: ditto.
	* ext/psych/yaml/scanner.c: ditto.
	* ext/psych/yaml/yaml_private.h: ditto.

Mon May  5 00:35:20 2014  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/visitors/yaml_tree.rb: support dumping Encoding
	  objects.

	* ext/psych/lib/psych/visitors/to_ruby.rb: support loading Encoding
	  objects.

	* test/psych/test_encoding.rb: add test

	* ext/psych/lib/psych.rb: add version

Mon May  5 00:16:35 2014  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* gc.c: Fix up default GC params by @csfrancis [fix GH-556]

Fri May  2 00:19:36 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/openssl/ossl.c (ossl_make_error): check NULL for unknown
	  error reasons with old OpenSSL, and insert a colon iff formatted
	  message is not empty.

Thu May  1 20:56:56 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/readline/extconf.rb (rl_hook_func_t): check pointer type.
	  [ruby-dev:48089] [Bug #9702]

Thu May  1 20:47:08 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/readline/extconf.rb: fix typo, `$defs` not `$DEFS`.
	  [ruby-core:61756] [Bug #9578]

Thu May  1 20:47:08 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/readline/extconf.rb (rl_hook_func_t): define as Function for
	  very old readline versions.  [ruby-core:61209] [Bug #9578]

Thu May  1 20:47:08 2014  Tanaka Akira  <akr@fsij.org>

	* ext/readline/readline.c (Init_readline): Use rl_hook_func_t instead
	  of Function to support readline-6.3.  (rl_hook_func_t is available
	  since readline-4.2.)
	  Reported by Dmitry Medvinsky.  [ruby-core:61141] [Bug #9578]

Sat Mar  1 21:00:27 2014  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* proc.c: Having optional keyword arguments makes maximum arity +1,
	  not unlimited [#8072]

Sat Mar  1 17:25:12 2014  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* proc.c: Having any mandatory keyword argument increases min arity
	  [#9299]

Mon Feb 24 14:56:41 2014  WATANABE Hirofumi  <eban@ruby-lang.org>

	* tool/make-snapshot: needs CXXFLAGS.  [ruby-core:59393][Bug #9320]

Mon Feb 24 14:56:41 2014  NAKAMURA Usaku  <usa@ruby-lang.org>

	* tool/make-snapshot: support new version scheme.

Mon Feb 24 13:05:48 2014  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych.rb: New release of psych.
	* ext/psych/psych.gemspec: ditto

Mon Feb 24 13:05:48 2014  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/yaml/emitter.c: merge libyaml 0.1.5
	* ext/psych/yaml/loader.c: ditto
	* ext/psych/yaml/parser.c: ditto
	* ext/psych/yaml/reader.c: ditto
	* ext/psych/yaml/scanner.c: ditto
	* ext/psych/yaml/writer.c: ditto
	* ext/psych/yaml/yaml_private.h: ditto

Sat Feb 22 22:26:43 2014  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/io/console/console.c (console_dev): need read access for conout$
	  because some functions need it.  [Bug#9554]

Sat Feb 22 21:56:26 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (iseq_set_arguments): set arg_keyword_check from
	  nd_cflag, which is set by parser.  internal ID is used for
	  unnamed keyword rest argument, which should be separated from no
	  keyword check.

	* iseq.c (rb_iseq_parameters): if no keyword check, keyword rest is
	  present.

	* parse.y (new_args_tail_gen): set keywords check to nd_cflag, which
	  equals to that keyword rest is not present.

Sat Feb 22 21:56:26 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* iseq.c (rb_iseq_parameters): push argument type symbol only for
	  unnamed rest keywords argument.

Sat Feb 22 21:56:26 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* proc.c (rb_iseq_min_max_arity): maximum argument is unlimited if
	  having rest keywords argument.  [ruby-core:53298] [Bug #8072]

Sat Feb 22 18:55:08 2014  Shugo Maeda  <shugo@ruby-lang.org>

	* ext/socket/init.c (wait_connectable): break if the socket is
	  writable to avoid infinite loops on FreeBSD and other platforms
	  which conforms to SUSv3.  This problem cannot be reproduced with
	  loopback interfaces, so it's hard to write test code.
	  rsock_connect() and wait_connectable() are overly complicated, so
	  they should be refactored, but I commit this fix as a workaround
	  for the release of Ruby 1.9.3 scheduled on Feb 24.
	  [ruby-core:60940] [Bug #9547]

Sat Feb 22 18:48:57 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* class.c (rb_mod_init_copy): do nothing if copying self.
	  [ruby-dev:47989] [Bug #9535]

	* hash.c (rb_hash_initialize_copy): ditto.

Sat Feb 22 18:20:58 2014  Masaki Matsushita  <glass.saga@gmail.com>

	* hash.c (rb_hash_flatten): fix behavior of flatten(-1).
	  [ruby-dev:47988] [Bug #9533]

	* test/ruby/test_array.rb: test for above.

Sat Feb 22 17:46:32 2014  Tanaka Akira  <akr@fsij.org>

	* lib/open-uri.rb: Make proxy disabling working again.
	  Fixed by Christophe Philemotte.   [ruby-core:59650] [Bug #9385]

Sat Feb 22 17:33:39 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (rb_mod_s_constants): return its own constants for other
	  than Module itself.  [ruby-core:59763] [Bug #9413]

Sat Feb 22 16:51:36 2014  Eric Wong <e@80x24.org>

	* ext/json/generator/depend: add build dependencies for json extension
	  [Bug #9374] [ruby-core:59609]
	* ext/json/parser/depend: ditto

Sat Feb 22 16:34:12 2014  Yusuke Endoh  <mame@tsg.ne.jp>

	* ext/fiddle/closure.c: use sizeof(*pcl) for correct sizeof value.
	  [ruby-core:57599] [Bug #8978].

Sat Feb 22 16:34:12 2014  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/fiddle/closure.c: use sizeof(*pcl) for correct sizeof value.
	  [ruby-core:57599] [Bug #8978].  Thanks mame!

Sat Feb 22 16:17:54 2014  Eric Wong  <e@80x24.org>

	* ext/socket/ancdata.c (bsock_sendmsg_internal): only retry on error
	  (bsock_recvmsg_internal): ditto
	* test/socket/test_unix.rb: test above for infinite loop

Sat Feb 22 15:56:53 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread_pthread.c (rb_thread_create_timer_thread): fix for platforms
	  where PTHREAD_STACK_MIN is a dynamic value and not a compile-time
	  constant.  [ruby-dev:47911] [Bug #9436]

Sat Feb 22 15:56:53 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread_pthread.c (rb_thread_create_timer_thread): expand timer
	  thread stack size to get rid of segfault on FreeBSD/powerpc64.
	  based on the patch by Steve Wills at [ruby-core:59923].
	  [ruby-core:56590] [Bug #8783]

Sat Feb 22 15:13:38 2014  Benoit Daloze  <eregontp@gmail.com>

	* range.c (Range#size): [DOC] improve description and add examples.
	  Patch by @skade. [Fixes GH-501]

Sat Feb 22 15:07:58 2014  Zachary Scott  <e@zzak.io>

	* lib/racc/rdoc/grammar.en.rdoc: [DOC] Correct grammar and typos
	  Patch by Giorgos Tsiftsis [Bug #9429] [ci skip]

Sat Feb 22 15:06:32 2014  Zachary Scott  <e@zzak.io>

	* lib/open-uri.rb: [DOC] use lower case version of core classes, same
	  as commit r44878, based on patch by Jonathan Jackson [Bug #9483]

Sat Feb 22 15:06:32 2014  Zachary Scott  <e@zzak.io>

	* ext/ripper/lib/ripper/lexer.rb: [DOC] use lower case version of core
	  classes when referring to return value, since we aren't directly
	  talking about the class. Patch by Jonathan Jackson [Bug #9483]

Sat Feb 22 15:03:05 2014  Ayumu AIZAWA  <ayumu.aizawa@gmail.com>

	* variable.c: adding extra example in docs.
	  patched by Steve Klabnik. [Bug #9210]

Sat Feb 22 15:01:21 2014  Tanaka Akira  <akr@fsij.org>

	* lib/resolv.rb (Resolv::DNS::Resource::TXT#data): Return concatenated
	  string.
	  Patch by Ryan Brunner.  [ruby-core:58220] [Bug #9093]

Sat Feb 22 14:52:55 2014  Zachary Scott  <e@zzak.io>

	* ext/openssl/ossl_pkey_dh.c: Fixed typo by Sandor Szuecs [Bug #9243]

Sat Feb 22 14:45:36 2014  Zachary Scott  <e@zzak.io>

	* lib/xmlrpc/client.rb: [DOC] Remove note about SSL package on RAA
	  Since RAA has been deprecated, and the SSL package has been replaced
	  with net/https this statement is entirely false and should be
	  deleted. [Bug #9152]

Sat Feb 22 14:31:23 2014  Zachary Scott  <e@zzak.io>

	* lib/net/smtp.rb: [DOC] Remove dead link to RAA by Giorgos Tsiftsis
	  Fixes the following bugs: [Bug #9152] [Bug #9268] [Bug #9394]
	* lib/open-uri.rb: ditto

Sat Feb 22 14:18:35 2014  Tanaka Akira  <akr@fsij.org>

	* lib/resolv.rb: Ignore name servers which cause EAFNOSUPPORT on
	  socket creation.
	  Reported by Bjoern Rennhak.  [ruby-core:60442] [Bug #9477]

Sat Feb 22 14:07:04 2014  Tanaka Akira  <akr@fsij.org>

	* lib/resolv.rb (Resolv::DNS::Message::MessageDecoder): Raise
	  DecodeError if no data before the limit.
	  Reported by Will Bryant.  [ruby-core:60557] [Bug #9498]

Sat Feb 22 13:49:30 2014  Shugo Maeda  <shugo@ruby-lang.org>

	* vm_insnhelper.c (vm_call_method): should check ci->me->flag of
	  a refining method in case the method is private.
	  [ruby-core:60111] [Bug #9452]

	* vm_method.c (make_method_entry_refined): set me->flag of a refined
	  method entry to NOEX_PUBLIC in case the original method is private
	  and it is refined as a public method.  The original flag is stored
	  in me->def->body.orig_me, so it's OK to make a refined method
	  entry public.  [ruby-core:60111] [Bug #9452]

	* test/ruby/test_refinement.rb: related tests.

Sat Feb 22 13:26:57 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* iseq.c (iseq_load): keep type_map to get rid of memory leak.
	  based on a patch by Eric Wong at [ruby-core:59699].  [Bug #9399]

Sat Feb 22 13:17:32 2014  Masaki Matsushita  <glass.saga@gmail.com>

	* ext/thread/thread.c (rb_szqueue_clear): notify SZQUEUE_WAITERS
	  on SizedQueue#clear. [ruby-core:59462] [Bug #9342]

	* test/thread/test_queue.rb: add test. the patch is from
	  Justin Collins.

Sat Feb 22 01:35:02 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in: check if pthread_setname_np is available.

	* thread_pthread.c: pthread_setname_np is not available on old
	  Darwins.  [ruby-core:60524] [Bug #9492]

Sat Feb 22 00:21:50 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (local_push_gen, local_pop_gen): save cmdarg_stack to
	  isolate command argument state from outer scope.
	  [ruby-core:59342] [Bug #9308]

Fri Feb 21 23:51:38 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* encoding.c (must_encindex, rb_enc_from_index, rb_obj_encoding): mask
	  encoding index and ignore dummy flags.  [ruby-core:59354] [Bug #9314]

Fri Feb 21 23:10:12 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (RbConfig): expand RUBY_SO_NAME for extensions
	  backward compatibility.  [ruby-core:59426] [Bug #9329]

Fri Feb 21 23:07:56 2014  Akio Tajima <artonx@yahoo.co.jp>

	* win32/Makefile.sub: remove HAVE_FSEEKO because fseeko removed from win32/win32.c
	  Fixed [Bug #9333].

Fri Feb 21 23:00:34 2014  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/visitors/yaml_tree.rb: dumping strings with
	  quotes should not have changed.  [ruby-core:59316] [Bug #9300]

	* ext/psych/lib/psych.rb: fixed missing require.

	* test/psych/test_string.rb: test

Sun Feb 2 05:48:42 2014  Eric Wong <e@80x24.org>

	* io.c (rb_io_syswrite): add RB_GC_GUARD
	  [Bug #9472][ruby-core:60407]

Fri Feb 21 17:42:42 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/resolv.rb (Resolv::Hosts#lazy_initialize): should not
	  consider encodings in hosts file.  [ruby-core:59239] [Bug #9273]

	* lib/resolv.rb (Resolv::Config.parse_resolv_conf): ditto.

Fri Feb 21 16:47:20 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (get_encoding): respect BOM on pseudo encodings.
	  [ruby-dev:47895] [Bug #9415]

Fri Feb 21 16:47:20 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (get_actual_encoding): get actual encoding according to
	  the BOM if exists.

	* string.c (rb_str_inspect): use according encoding, instead of
	  pseudo encodings, UTF-{16,32}.  [ruby-core:59757] [Bug #8940]

Fri Feb 21 13:39:21 2014  Charlie Somerville  <charliesome@ruby-lang.org>

	* compile.c (iseq_build_from_ary_body): Use :blockptr instead of :block
	  as hash key when loading serialized instruction sequences from arrays.
	  [Bug #9455] [ruby-core:60146]

Thu Feb 20 12:58:45 2014  Tanaka Akira  <akr@fsij.org>

	* process.c (READ_FROM_CHILD): Apply the last hunk of
	  0001-process.c-avoid-EINTR-from-Process.spawn.patch written by
	  Eric Wong in [Bug #8770].

Thu Feb 20 12:58:45 2014  Eric Wong  <normalperson@yhbt.net>

	* process.c (send_child_error): retry write on EINTR to fix
	  occasional Errno::EINTR from Process.spawn.

	* process.c (recv_child_error): retry read on EINTR to fix
	  occasional Errno::EINTR from Process.spawn.

Thu Feb 20 12:24:59 2014  Eric Hodel  <drbrain@segment7.net>

	* lib/rinda/ring.rb (Rinda::RingFinger#make_socket):  Use
	  ipv4_multicast_ttl option for portability.

Thu Feb 20 10:19:40 2014  Tanaka Akira  <akr@fsij.org>

	* ext/socket/option.c: IP_MULTICAST_LOOP and IP_MULTICAST_TTL socket
	  option takes a byte on OpenBSD.
	  Fixed by Jeremy Evans.  [ruby-core:59496] [Bug #9350]

Wed Feb 19 15:25:13 2014  Koichi Sasada  <ko1@atdot.net>

	* gc.c (ruby_gc_set_params): don't show obsolete warnings for
	  RUBY_FREE_MIN/RUBY_HEAP_MIN_SLOTS if
	  RUBY_GC_HEAP_FREE_SLOTS/RUBY_GC_HEAP_INIT_SLOTS are given.
	  [Bug #9276]

Wed Feb 19 14:25:55 2014  Koichi Sasada  <ko1@atdot.net>

	* test/ruby/test_gc.rb: ignore warning messages for running with -w
	  option such as chkbuild.

Wed Feb 19 14:25:55 2014  Koichi Sasada  <ko1@atdot.net>

	* gc.c (get_envparam_double): fix a warning message.

Wed Feb 19 14:25:55 2014  Koichi Sasada  <ko1@atdot.net>

	* gc.c: introduce new environment variable
	  "RUBY_GC_HEAP_OLDOBJECT_LIMIT_FACTOR" to control major/minor GC
	  frequency.

	  Do full GC when the number of old objects is more than R * N
	  where R is this factor and
	  N is the number of old objects just after last full GC.

	* test/ruby/test_gc.rb: add a test.

Wed Feb 19 07:51:02 2014  Eric Hodel  <drbrain@segment7.net>

	* lib/rinda/ring.rb (Rinda::RingFinger#make_socket):  Use
	  ipv4_multicast_loop option for portability.  Patch by Jeremy Evans.
	  [ruby-trunk - Bug #9351]

Mon Feb 17 05:43:20 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in: reset LDFLAGS and DLDFLAGS for opt-dir again after
	  LIBPATHFLAG and RPATHFLAG are set.  [ruby-dev:47868] [Bug #9317]

Sun Feb 16 07:13:36 2014  Tanaka Akira  <akr@fsij.org>

	* configure.in: Fix compilation error.
	  https://bugs.ruby-lang.org/issues/8358#note-16

Sun Feb 16 07:13:36 2014  Vit Ondruch  <vondruch@redhat.com>

	* configure.in: add qouting brackets and append wildcard for the
	  rest after target_cpu, to properly detect platform for SSE2
	  instructions.  [ruby-core:60576] [Bug #8358]

Sun Feb 16 07:13:36 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in: -mstackrealign is necessary for -msse2 working.
	  [ruby-core:54716] [Bug #8349]

Sun Feb 16 07:13:36 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in: -mstackrealign is necessary for -msse2 working.
	  [ruby-core:54716] [Bug #8349]

	* configure.in: use SSE2 instructions to drop unexpected precisions on
	  other than mingw.  [ruby-core:59472] [Bug #8358]

Sun Feb 16 07:13:36 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in: use SSE2 instructions for drop unexpected
	  precisions.  [ruby-core:54738] [Bug #8358]

Fri Feb  7 04:19:19 2014  Koichi Sasada  <ko1@atdot.net>

	* gc.c (get_envparam_int): correct warning messsages.

	* gc.c (get_envparam_double): ditto.

Fri Feb  7 04:19:19 2014  Koichi Sasada  <ko1@atdot.net>

	* gc.c (get_envparam_int): don't accept a value equals to lowerbound
	  (changed by last commit) because "" or "foo" (not a number) strings
	  are parsed as 0. They should be rejected.

	* gc.c (get_envparam_double): ditto.

Thu Feb 6 08:23:28 2014  Eric Wong  <e@80x24.org>

	* ext/thread/thread.c (rb_szqueue_max_set): use correct queue and
	  limit wakeups.  [Bug #9343][ruby-core:60517]
	* test/thread/test_queue.rb (test_sized_queue_assign_max):
	  test for bug

Thu Feb  6 11:27:39 2014  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems: RubyGems 2.2.2 which contains the following bug fixes:
	  http://rubygems.rubyforge.org/rubygems-update/History_txt.html#label-2.2.2+%2F+2014-02-05
	  https://bugs.ruby-lang.org/issues/9489

Thu Feb  6 11:23:59 2014  Koichi Sasada  <ko1@atdot.net>

	* gc.c (ruby_gc_set_params): if RUBY_GC_OLDMALLOC_LIMIT is provided,
	  then set objspace->rgengc.oldmalloc_increase_limit.
	  Without this fix, the env variable RUBY_GC_OLDMALLOC_LIMIT
	  does not work.

	* gc.c (get_envparam_int): accept a value equals to lowerbound.

	* gc.c (get_envparam_double): ditto.

Wed Feb  5 23:57:05 2014  Charlie Somerville  <charliesome@ruby-lang.org>

	* ext/thread/thread.c (rb_szqueue_push): check GET_SZQUEUE_WAITERS
	  instead of GET_QUEUE_WAITERS to prevent deadlock. Patch by Eric Wong.
	  [Bug #9302] [ruby-core:59324]

	* test/thread/test_queue.rb: add test

Wed Feb  5 23:43:30 2014  NAKAMURA Usaku  <usa@ruby-lang.org>

	* hash.c (rb_objid_hash): should return `long'.  brushup r44534.

	* object.c (rb_obj_hash): follow above change.

Wed Feb  5 23:43:30 2014  NAKAMURA Usaku  <usa@ruby-lang.org>

	* hash.c (rb_any_hash): should treat the return value of rb_objid_hash()
	  as `long', because ruby assumes the hash value of the object id of
	  an object is `long'.
	  this fixes test failures on mswin64 introduced at r44525.

Wed Feb  5 23:43:30 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* hash.c (rb_objid_hash): return hash value from object ID with a
	  salt, extract from rb_any_hash().

	* object.c (rb_obj_hash): return same value as rb_any_hash().
	  fix r44125.  [ruby-core:59638] [Bug #9381]

Wed Feb  5 22:28:41 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_insnhelper.c (vm_search_super_method): allow bound method from a
	  module, yet another method transplanting.

Wed Feb  5 22:28:41 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_insnhelper.c (vm_search_super_method): when super called in a
	  bound UnboundMethod generated from a module, no superclass is
	  found since the current defined class is the module, then call
	  method_missing in that case.  [ruby-core:59619] [Bug #9377]

Wed Feb  5 21:57:40 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/socket/socket.c (rsock_syserr_fail_host_port): add errno
	  argument version anduse rb_syserr_fail_str() instead of
	  rb_sys_fail_str() with restoring errno.

	* ext/socket/socket.c (rsock_syserr_fail_path): ditto, and
	  rb_syserr_fail().

	* ext/socket/socket.c (rsock_sys_fail_sockaddr): ditto, use
	  rsock_syserr_fail_raddrinfo().

	* ext/socket/socket.c (rsock_sys_fail_raddrinfo): ditto.

	* ext/socket/socket.c (setup_domain_and_type): ditto.

Wed Feb  5 21:57:40 2014  Eric Wong  <normalperson@yhbt.net>

	* ext/socket/socket.c (rsock_sys_fail_host_port): save and restore errno
	  before calling rb_sys_fail_str to prevent [BUG] errno == 0.
	  Patch by Eric Wong. [ruby-core:59498] [Bug #9352]

	* ext/socket/socket.c (rsock_sys_fail_path): ditto
	* ext/socket/socket.c (rsock_sys_fail_sockaddr): ditto
	* ext/socket/socket.c (rsock_sys_fail_raddrinfo): ditto
	* ext/socket/socket.c (rsock_sys_fail_raddrinfo_or_sockaddr): ditto

Wed Feb  5 21:12:02 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/timeout.rb (Timeout::ExitException.catch): pass arguments
	  for new instance.

	* lib/timeout.rb (Timeout::ExitException#exception): fallback to
	  Timeout::Error if couldn't throw.  [ruby-dev:47872] [Bug #9380]

	* lib/timeout.rb (Timeout#timeout): initialize ExitException with
	  message for the fallback case.

Wed Feb  5 21:12:02 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/timeout.rb (Timeout#timeout): should not rescue ordinarily
	  raised ExitException, which should not be thrown.

	* lib/timeout.rb (Timeout::ExitException.catch): set @thread only if
	  it ought to be caught.

	* lib/timeout.rb (Timeout#timeout): when a custom exception is given,
	  no instance is needed to be caught, so defer creating new instance
	  until it is raised.  [ruby-core:59511] [Bug #9354]

Wed Feb  5 17:55:28 2014  Aman Gupta <ruby@tmm1.net>

	* array.c (ary_add_hash): Fix consistency issue between Array#uniq and
	  Array#uniq! [Bug #9340] [ruby-core:59457]
	* test/ruby/test_array.rb (class TestArray): regression test for above.

Wed Feb  5 11:48:42 2014  Charlie Somerville  <charliesome@ruby-lang.org>

	* struct.c (rb_struct_set): return assigned value from setter method
	  rather than struct object. [Bug #9353] [ruby-core:59509]

	* test/ruby/test_struct.rb (test_setter_method_returns_value): add test

Wed Feb  5 11:13:21 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_modify_expand): enable capacity and disable
	  assocation with packed objects when setting capa, so that
	  pack("p") string fails to unpack properly after modified.

Sun Feb  2 22:39:28 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/delegate.rb (Delegator): keep source information methods
	  which start and end with '__'.  [ruby-core:59718] [Bug #9403]

Fri Jan 31 12:10:16 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* proc.c (mnew_from_me): keep iclass as-is, to make inheritance
	  chain consistent.  [ruby-core:59358] [Bug #9315]

	* proc.c (method_owner): return the original defined_class from
	  prepended iclass, instead.

Fri Jan 31 12:05:59 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in: let mingw do something black-magic, and check if
	  _gmtime64_s() is available actually.

	* win32/win32.c (gmtime_s, localtime_s): use _gmtime64_s() and
	  _localtime64_s() if available, not depending on very confusing
	  mingw variants macros.  based on the patch by phasis68 (Heesob
	  Park) at [ruby-core:58764].  [ruby-core:58391] [Bug #9119]

Thu Jan 30 15:02:35 2014  Shugo Maeda  <shugo@ruby-lang.org>

	* configure.in: use $@ instead of $(.TARGET) because .TARGET is not
	  supported by GNU make.

Mon Jan 27 16:49:52 2014  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (BigDecimal_divide): Add an additional
	  digit for the quotient to be compatible with bigdecimal 1.2.1 and
	  the former.  [ruby-core:59365] [#9316] [#9305]

	* test/bigdecimal/test_bigdecimal.rb: tests for the above change.

	* ext/bigdecimal/bigdecimal.gemspec: bigdecimal version 1.2.4.

Mon Jan 27 16:45:34 2014  Yamashita Yuu  <yamashita@geishatokyo.com>

	* ext/openssl/ossl_ssl.c (Init_ossl_ssl): Declare a constant
	  `OP_MSIE_SSLV2_RSA_PADDING` only if the macro is defined.  The
	  `SSL_OP_MSIE_SSLV2_RSA_PADDING` has been removed from latest
	  snapshot of OpenSSL 1.0.1.  [Fixes GH-488]

Thu Jan 23 10:37:24 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* hash.c (HAS_EXTRA_STATES): warn extra states only when something
	  differ.  [ruby-core:59254] [Bug #9275]

Thu Jan  9 14:05:24 2014  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/{setup.mak,Makefile.sub}: update fake.rb like
	  template/fake.rb.in.

Thu Jan  9 14:05:24 2014  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/Makefile.sub (fake.rb): should depend on version.h because
	  if RUBY_VERSION is updated, fake.rb need to say the new version
	  to avoid install error in rbconfig.rb.

Thu Jan  9 08:21:00 2014  Aman Gupta <ruby@tmm1.net>

	* test/net/imap/cacert.pem: generate new CA cert, since the last one
	  expired. [Bug #9341] [ruby-core:59459]
	* test/net/imap/server.crt: new server cert signed with updated CA.
	* test/net/imap/Makefile: add `make regen_certs` to automate this
	  process.

Thu Dec 26 03:28:11 2013  Koichi Sasada  <ko1@atdot.net>

	* vm_insnhelper.c (argument_error): insert dummy frame to make
	  a backtrace object intead of modify backtrace string array.
	  [Bug #9295]

	* test/ruby/test_backtrace.rb: add a test for this patch.
	  fix test to compare a result of Exception#backtrace with
	  a result of Exception#backtrace_locations.

Wed Dec 25 16:58:31 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* proc.c (rb_mod_define_method): consider visibility only if self
	  in the caller is same as the receiver, otherwise make public as
	  well as old behavior.  [ruby-core:57747] [Bug #9005]
	  [ruby-core:58497] [Bug #9141]

	* vm.c (rb_vm_cref_in_context): return ruby level cref if self is
	  same.

Wed Dec 25 16:35:34 2013  Yusuke Endoh  <mame@tsg.ne.jp>

	* sample/trick2013/: added the award-winning entries of TRICK 2013.
	  See https://github.com/tric/trick2013 for the contest outline.
	  (Matz has approved the attachment.)

Tue Dec 24 23:47:50 2013  Koichi Sasada  <ko1@atdot.net>

	* README.EXT: add a refer to URL.

Tue Dec 24 23:47:50 2013  Koichi Sasada  <ko1@atdot.net>

	* README.EXT: add a document about RGenGC.
	  Reviewed by havenwood.
	  [misc #8962]

	* README.EXT.ja: ditto.

Mon Dec 23 19:00:00 2013  Eric Hodel  <drbrain@segment7.net>

	* test/rubygems/test_gem_ext_builder.rb:  Fix warning due to ambiguous
	  expression.

Mon Dec 23 16:13:10 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems/commands/install_command.rb:  Restore gem install
	  --ignore-dependencies for remote gems
	* test/rubygems/test_gem_commands_install_command.rb:  Test for the
	  above.

Mon Dec 23 16:12:24 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* array.c: Have to_h raise on elements that are not key-value pairs
	  [#9239]

	* enum.c: ditto

Sun Dec 22 19:22:52 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rdoc.rb:  Set RDoc to release version.

Sun Dec 22 19:22:31 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems.rb:  Set RubyGems to release version.

Sun Dec 22 19:22:01 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems.rb (module Gem):  Fix comment for
	  Gem::load_path_insert_index.

Sun Dec 22 18:08:42 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/Makefile.sub (fake.rb): fixed wrong RUBY_PLATFORM, to correctly
	  install win32.h.
	  [ruby-core:58801][Bug #9199] reported by arton.

Fri Dec 20 17:52:50 2013  Koichi Sasada  <ko1@atdot.net>

	* vm_method.c: check definition of
	  GLOBAL_METHOD_CACHE_SIZE and GLOBAL_METHOD_CACHE_MASK.

Fri Dec 20 17:03:10 2013  Koichi Sasada  <ko1@atdot.net>

	* include/ruby/ruby.h: rename OBJ_WRITE and OBJ_WRITTEN into
	  RB_OBJ_WRITE and RB_OBJ_WRITTEN.

	* array.c, class.c, compile.c, hash.c, internal.h, iseq.c,
	  proc.c, process.c, re.c, string.c, variable.c, vm.c,
	  vm_eval.c, vm_insnhelper.c, vm_insnhelper.h, 
	  vm_method.c: catch up this change.

Fri Dec 20 16:01:35 2013  Koichi Sasada  <ko1@atdot.net>

	* include/ruby/ruby.h: add a comment for WB interfaces.

Fri Dec 20 16:00:52 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in: DLDFLAGS is defined in --with-opt-dir handler, so
	  ${DLDFLAGS=} does not work now.  use RUBY_APPEND_OPTIONS instead.
	  [ruby-dev:47855] [Bug #9256]

Fri Dec 20 14:19:12 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* configure.in (AC_ARG_WITH): use withval directly.
	  fix failure on FreeBSD.
	  http://fb32.rubyci.org/~chkbuild/ruby-trunk/log/20131217T070301Z.diff.html.gz

Fri Dec 20 14:00:01 2013  Aman Gupta <ruby@tmm1.net>

	* include/ruby/ruby.h (struct RClass): add super, remove iv_index_tbl.
	  since RCLASS_SUPER() is commonly used inside while loops, we move it
	  back inside struct RClass to improve cache hits. this provides a
	  small improvement (1%) in hotspots like rb_obj_is_kind_of()
	* internal.h (struct rb_classext_struct): remove super, add
	  iv_index_table
	* internal.h (RCLASS_SUPER): update for new location
	* internal.h (RCLASS_SET_SUPER): ditto
	* internal.h (RCLASS_IV_INDEX_TBL): ditto
	* object.c (rb_class_get_superclass): ditto
	* include/ruby/backward/classext.h (RCLASS_SUPER): ditto

Fri Dec 20 07:07:35 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems:  Update to RubyGems master 03d6ae7.  Changes include:

	  * Fixed typos.

	  * Relaxed Gem.ruby test for ruby packagers that do not use `ruby`.

	* test/rubygems:  ditto.

Thu Dec 19 14:03:04 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (heap_get_freeobj): improve hot path performance.

	* gc.c (heap_get_freeobj_from_next_freepage): replace with
	  heap_get_freepage(). It returns freeobj instead of freepage.
	  This is not on hot path.

Thu Dec 19 12:05:17 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems:  Update to RubyGems master af60443.  Changes include:

	  * Improved speed of `gem install --ignore-dependencies`.

	  * Open read-write for exclusive flock.  [ruby-trunk - Bug #9257]

	  * Remove specification before install to prevent infinite loop.

Thu Dec 19 11:23:49 2013  Aman Gupta <ruby@tmm1.net>

	* vm_insnhelper.c (vm_call_iseq_setup_normal): simple for loop
	  condition optimization. this area shows up as a hotspot in VM
	  profiles.

Thu Dec 19 10:50:13 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (newobj_of): don't need to RBASIC_SET_CLASS() which includes WB
	  here because created obj is always YOUNG/INFANT.

Thu Dec 19 10:48:37 2013  Koichi Sasada  <ko1@atdot.net>

	* benchmark/gc/gcbench.rb: check GC::OPTS availability
	  for not MRI 2.1.0.

Thu Dec 19 03:10:30 2013  Aman Gupta <ruby@tmm1.net>

	* gc.c (heap_get_freeobj): remove redundant assignment. heap->freelist
	  is set after the while() loop already.

Thu Dec 19 01:54:30 2013  Koichi Sasada  <ko1@atdot.net>

	* test/runner.rb: fix commit miss on r44278.

Thu Dec 19 00:26:11 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (garbage_collect_body): lazy_sweep setting should work
	  without USE_RGENGC.

Wed Dec 18 23:31:04 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (gc_profile_dump_major_reason): fix this function because major_reason
	  can be OR of multiple reasons.

	* gc.c (gc_profile_dump_on): ditto.

Wed Dec 18 17:03:00 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (gc_profile_record_get): should return an empty array
	  when profiling is active.

Wed Dec 18 16:49:40 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (gc_profile_clear, gc_profile_enable): remove rest_sweep().

	* gc.c: check objspace->profile.current_record before inserting
	  profiling record by new macro gc_prof_enabled().

Wed Dec 18 14:32:06 2013  Koichi Sasada  <ko1@atdot.net>

	* vm_exec.h (VM_DEBUG_STACKOVERFLOW): added.
	  disable stack overflow check for every stack pushing as default.

	* vm_exec.c (vm_stack_overflow_for_insn): ditto.

Wed Dec 18 10:00:22 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems:  Update to RubyGems master d8f12e2.  This increases the
	  speed of `gem install --ignore-dependencies` which helps bundler
	  tests.
	* test/rubygems:  ditto.

Wed Dec 18 09:00:17 2013  Koichi Sasada  <ko1@atdot.net>

	* test/ruby/test_gc.rb (test_expand_heap): allow +/-1 diff.

Tue Dec 17 23:44:15 2013  Kazuki Tsujimoto  <kazuki@callcc.net>

	* test/ruby/test_io.rb: fix duplicated test name.

Tue Dec 17 20:15:00 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* hash.c (rb_hash_reject): revert to deprecated behavior, with
	  warnings, due to compatibility for HashWithDifferentAccess.
	  [ruby-core:59154] [Bug #9223]

Tue Dec 17 17:30:56 2013  Akinori MUSHA  <knu@iDaemons.org>

	* misc/ruby-electric.el: Import version 2.1.1 from
	  https://github.com/knu/ruby-electric.el.

	  * ruby-electric-delete-backward-char: Enable support for number
	    prefix.

	  * ruby-electric-curlies: Fix electric operation after an open
	    curly.

Tue Dec 17 16:19:09 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_trace.c (rb_postponed_job_flush): isolate exceptions in
	  postponed jobs and restore outer ones.  based on a patch by
	  tarui.  [ruby-core:58652] [Bug #9168]

Tue Dec 17 10:48:04 2013  Aman Gupta <ruby@tmm1.net>

	* configure.in (RUBY_DTRACE_POSTPROCESS): Fix compatibility with
	  systemtap on linux. stap requires `dtrace -G` post-processing, but
	  the dtrace compatibility wrapper is very strict about probes.d
	  syntax.

Tue Dec 17 05:18:17 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems:  Update to RubyGems master 1c5f4b3.  Allows rubygems
	  repackagers to disable backward-compatible shared gem directory
	  behavior.
	* test/rubygems:  ditto.

Tue Dec 17 05:14:35 2013  Eric Hodel  <drbrain@segment7.net>

	* NEWS (RDoc):  Update version number so I don't have to change it
	  for the final release.

Mon Dec 16 19:19:19 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (rb_objspace_markable_object_p): should check special_const_p
	  first (by is_markable_object()).

Mon Dec 16 19:12:54 2013  Koichi Sasada  <ko1@atdot.net>

	* ext/objspace/objspace.c (reachable_object_from_root_i): use
	  compare_by_identity hash to avoid hash modify problem
	  during iteration.
	  [Bug #9252]

	* ext/objspace/objspace.c (reachable_objects_from_root): ditto.

Mon Dec 16 18:16:28 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (gc_verify_internal_consistency): should not use
	  rb_objspace_each_objects() because it call rest_sweep().

Mon Dec 16 18:07:30 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (rb_objspace_markable_object_p): fix last commit (build error).

Mon Dec 16 18:04:28 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (rb_objspace_markable_object_p): it should be live objects.

Mon Dec 16 18:00:51 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (rb_objspace_each_objects): should not clear dont_lazy_sweep
	  flag in nested case.

Mon Dec 16 16:40:35 2013  Koichi Sasada  <ko1@atdot.net>

	* vm_method.c (rb_method_entry_make): fix WB miss.
	  Note that rb_method_entry_t::klass is not constified.
	  We may  constify this field.

	* test/ruby/test_alias.rb: add a test.

Mon Dec 16 14:14:22 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c: use gc_verify_internal_consistency() instead of
	  gc_check_before_marks_i() for check consistency
	  on RGENGC_CHECK_MODE >= 2.

Mon Dec 16 14:01:48 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* process.c (make_clock_result): add :second as a unit for
	  Process.clock_gettime.

Mon Dec 16 13:10:54 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c: introduce GC.verify_internal_consistency method to verify GC
	  internal data structure.

	  Now this method only checks generation (old/young) consistency.

Mon Dec 16 11:49:26 2013  Aman Gupta <ruby@tmm1.net>

	* gc.c (gc_info_decode): Fix build errors when compiled with
	  RGENGC_ESTIMATE_OLDMALLOC=0
	* gc.c (objspace_malloc_increase): ditto

Sun Dec 15 13:38:29 2013  Koichi Sasada  <ko1@atdot.net>

	* ext/objspace/objspace.c (reachable_object_from_root_i):
	  reachable objects should not include categories and
	  category_objects because it is noisy information.

	  In fact, objects created after calling
	  ObjectSpace.reachable_objects_from_root should not be included
	  as a returning hash objects. Currently, mswin64 platform has a
	  problem because of this behavior. Should we trace new objects?

Sun Dec 15 07:09:28 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rdoc:  Update to RDoc master 263a9e5.  This improves the
	  accessibility of the search box.

Sat Dec 14 17:39:00 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_insnhelper.c (vm_callee_setup_arg_complex): count post
	  arguments as mandatory arguments.  [ruby-core:57706] [Bug #8993]

	* vm_insnhelper.c (vm_yield_setup_block_args): ditto.

Sat Dec 14 16:26:46 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (rubylibprefix): replace exec_prefix as well as
	  bindir and libdir.  a patch by kimuraw (Wataru Kimura) at
	  [ruby-dev:47852].  [Bug #9160]

Sat Dec 14 14:42:53 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/logger.rb (lock_shift_log): no need to rotate the log file
	  if it has been rotated by another process.  based on the patch
	  by no6v (Nobuhiro IMAI) in [ruby-core:58620].  [Bug #9133]

Sat Dec 14 13:01:45 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* proc.c (mnew_from_me): method by respond_to_missing? should be
	  owned by the original class.

Sat Dec 14 11:55:31 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/scanf.rb (IO#scanf): fix mistaken use of rescue modifier.
	  a patch by Mon_Ouie at [ruby-core:52813].  [Bug #7940]

Sat Dec 14 11:44:52 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* util.c (ruby_qsort): fix potential stack overflow on a large
	  machine.  based on the patch by Conrad Irwin <conrad.irwin AT
	  gmail.com> at [ruby-core:51816].  [Bug #7772]

Sat Dec 14 11:25:56 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* object.c (rb_mod_const_defined): support nested class path as
	  well as const_get.  [Feature #7414]

Sat Dec 14 01:31:52 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (rb_rescue2): reuse tags pushed for body proc to protect
	  rescue proc too.

Sat Dec 14 01:15:51 2013  Masaya Tarui  <tarui@ruby-lang.org>

	* gc.c (wmap_final_func): Bugfix. Should update *value to new pointer.

Sat Dec 14 01:05:46 2013  Tanaka Akira  <akr@fsij.org>

	* ext/socket/lib/socket.rb: Don't test $! in "ensure" clause because
	  it may be set before the body.
	  Reported by ko1 and mrkn.  [ruby-core:59088] [Bug #9247]

	* lib/cgi/core.rb: Ditto.

	* lib/drb/ssl.rb: Ditto.

Sat Dec 14 00:34:31 2013  Naohisa Goto  <ngotogenome@gmail.com>

	* internal.h (ruby_sized_xrealloc2): fix typo introduced in r44117,
	  which cause compile error on Solaris.

Sat Dec 14 00:22:16 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread.c: (exec_recursive): use rb_catch_protect() instead of
	  rb_catch_obj() and PUSH_TAG(), and reduce pushing tags and
	  machine stack usage.

Sat Dec 14 00:18:08 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* proc.c (mnew_from_me): achieve the original defined_class from
	  prepended iclass, to fix inherited owner.

	* proc.c (method_owner): return the defined class, but not the
	  class which the method object is created from.

Fri Dec 13 22:29:21 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* proc.c (method_owner): return the class where alias is defined, not
	  the class original method is defined.

	* vm_method.c (rb_method_entry_make, rb_alias): store the originally
	  defined class in me.  [Bug #7993] [Bug #7842] [Bug #9236]

	* vm_method.c (rb_method_entry_get_without_cache): cache included
	  module but not iclass.

Fri Dec 13 16:27:17 2013  Aman Gupta <ruby@tmm1.net>

	* gc.c (gc_info_decode): Use :major_by=>:nofree as fallback reason
	  when other trigger conditions are present.

Fri Dec 13 13:25:30 2013  Koichi Sasada  <ko1@atdot.net>

	* error.c: add Exception#backtrace_locations.
	  Now, there are no setter and independent from Exception#backtrace.
	  [Feature #8960]

	* eval.c (setup_exception): set backtrace locations for `bt_location'
	  special attribute.

	* vm_backtrace.c (rb_backtrace_to_location_ary): added.

	* internal.h: ditto.

	* test/ruby/test_backtrace.rb: add a test for
	  Exception#backtrace_locations.

Fri Dec 13 12:01:07 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (garbage_collect_body): use rb_bug() and explicit error message
	  instead of using assert().
	  [Bug #9222]

Fri Dec 13 11:52:41 2013  Koichi Sasada  <ko1@atdot.net>

	* array.c: fix comment to remove the word "shady".

	* variable.c: ditto.

Fri Dec 13 11:33:55 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c: rename *shady* func/macros.
	  * RVALUE_RAW_SHADY()   -> RVALUE_WB_PROTECTED_RAW()
	  * RVALUE_SHADY()       -> RVALUE_RAW_SHADY()
	  * rgengc_check_shady() -> rgengc_check_relation().
	  And fix some messages using "shady" to "non-WB-protected".

Fri Dec 13 10:04:23 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems/request_set/lockfile.rb:  Import RubyGems master a8d0669
	  with a 1.8.7 compatibility fix.
	* test/rubygems/test_gem_request_set_lockfile.rb:  ditto.

Fri Dec 13 09:50:49 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems:  Update to RubyGems master ddac51f.  Changes:

	  * Allow override for the shared gem installation directory for
	    rubygems packagers.

	  * Lock gem cache files for read and write to improve thread safety.

	  * Use io/console when available.

	  * Minor cleanup.

	* test/rubygems:  ditto.

Fri Dec 13 08:15:31 2013  Aman Gupta <ruby@tmm1.net>

	* class.c (include_modules_at): use RCLASS_M_TBL_WRAPPER for
	  equality checks. this avoids an unnecessary deference inside a tight
	  loop, fixing a performance regression from r43973.
	* object.c (rb_obj_is_kind_of): ditto.
	* object.c (rb_class_inherited_p): ditto.

Wed Dec 13 02:00:00 2013  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (VpSetPTR): fix for limitation of the resulting
	  precision.
	  [ruby-core:50269] [Bug #7458]

	* test/bigdecimal/test_bigdecimal.rb (test_limit): add tests for the above
	  change.

Wed Dec 13 01:56:00 2013  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (VpAddAbs): put out a conditional branch from
	  the inside of while-loop.

	* ext/bigdecimal/bigdecimal.c (VpSubAbs): ditto.

Wed Dec 13 01:53:00 2013  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (VPrint): be a static function, support another
	  dump formats, and add more information of the given bigdecimal.

	* ext/bigdecimal/bigdecimal.h: ditto.

Wed Dec 11 16:45:58 2013  Koichi Sasada  <ko1@atdot.net>

	* eval.c (rb_raise_jump): call c_return hook immediately after
	  popping `raise' frame.
	  Patches by deivid (David Rodriguez). [Bug #8886]

	* test/ruby/test_settracefunc.rb: catch up this fix.

Wed Dec 11 16:01:26 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* hash.c (rb_hash_reject): return a plain hash, without copying
	  the class, default value, instance variables, and taintedness.
	  they had been copied just by accident.
	  [ruby-core:59045] [Bug #9223]

Wed Dec 11 15:36:15 2013  Aman Gupta <ruby@tmm1.net>

	* compile.c (iseq_specialized_instruction): emit opt_aset instruction
	  to optimize Hash#[]= and Array#[]= when called with Fixnum argument.
	  [Bug #9227] [ruby-core:58956]

Wed Dec 11 04:54:03 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems:  Update to RubyGems master ec8ed22.  Notable changes
	  include:

	  * Renamed extension_install_dir to extension_dir (backwards
	    compatible).

	  * Fixed creation of gem.deps.rb.lock file from
	    TestGemRequestSet#test_install_from_gemdeps_install_dir

	  * Fixed a typo and some documentation.

	* test/rubygems:  ditto.

Wed Dec 11 03:18:08 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* insns.def: Fix optimization bug of Float#/ [Bug #9238]

Tue Dec 10 23:58:30 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/date/date_strptime.c (date__strptime_internal): unset
	  case-insensitive flag for [:alpha:], which already implies both
	  cases, to get rid of backtrack explosion.  [ruby-core:58984]
	  [Bug #9221]

Tue Dec 10 23:44:42 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* array.c (rb_ary_hash): add salt to differentiate false and empty
	  array.  [ruby-core:58993] [Bug #9231]

	* hash.c (rb_any_hash, rb_hash_hash): ditto.

Tue Dec 10 18:16:09 2013  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* man/ruby.1: [DOC] Use www.ruby-toolbox.com instead of RAA.

Tue Dec 10 17:21:30 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* gc.c (wmap_finalize, wmap_aset_update): use simple malloced array
	  instead of T_ARRAY, to reduce GC pressure.

Tue Dec 10 15:56:48 2013  Aman Gupta <ruby@tmm1.net>

	* gc.c (reflist_add): revert changes from r44109. it is unnecessary
	  after r44113
	* gc.c (allrefs_i): fix whitespace
	* gc.c (allrefs_roots_i): fix whitespace

Tue Dec 10 15:46:03 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (allrefs_add): push obj only if allrefs table doesn't have
	  obj.

	* gc.c (allrefs_roots_i): ditto.

Tue Dec 10 15:28:10 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (RGENGC_CHECK_MODE): separate checkers to different modes.
	  * 2: enable generational bits check (for debugging)
	  * 3: enable livness check
	  * 4: show all references

Tue Dec 10 15:15:37 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (gc_marks_check): disable GC during checking and
	  restore malloc_increase info.

Tue Dec 10 14:41:53 2013  Aman Gupta <ruby@tmm1.net>

	* gc.c (reflist_add): return 0 if reference already exists
	* gc.c (allrefs_add): return 1 on newly added references
	* gc.c (allrefs_i): follow references to construct complete object
	  graph. before this patch, RGENGC_CHECK could fail to verify some WB
	  miss issues. [Bug #9226] [ruby-core:58959]

Tue Dec 10 11:20:56 2013  Aman Gupta <ruby@tmm1.net>

	* ext/objspace/objspace_dump.c (dump_object): include fstring flag on
	  strings. include gc flags (old, remembered, wb_protected) on all objects.
	* ext/objspace/objspace_dump.c (Init_objspace_dump): initialize lazy
	  IDs before first use.
	* gc.c (rb_obj_gc_flags): new function to retrieve object flags
	* internal.h (RB_OBJ_GC_FLAGS_MAX): maximum flags allowed for one obj
	* test/objspace/test_objspace.rb (test_dump_flags): test for above
	* test/objspace/test_objspace.rb (test_trace_object_allocations):
	  resolve name before dump (for rb_class_path_cached)

Tue Dec 10 07:48:29 2013  Aman Gupta <ruby@tmm1.net>

	* vm_method.c (rb_clear_method_cache_by_class): fire
	  ruby::method-cache-clear probe on global or klass-level method cache
	  clear [Bug #9190]
	* probes.d (provider ruby): new dtrace probe
	* doc/dtrace_probes.rdoc: docs for new probe
	* test/dtrace/test_method_cache.rb: test for new probe

Tue Dec 10 06:14:11 2013  Eric Hodel  <drbrain@segment7.net>

	* ext/.document:  Remove curses from documentable directories.

Tue Dec 10 04:55:36 2013  Zachary Scott  <e@zzak.io>

	* ext/openssl/lib/openssl/digest.rb: Deprecate OpenSSL::Digest::Digest
	  [Fixes GH-446] https://github.com/ruby/ruby/pull/446

Tue Dec 10 00:41:42 2013  Kazuki Tsujimoto  <kazuki@callcc.net>

	* ext/thread/thread.c: [DOC] add call-seq alias for Queue#enq, #<<, etc.

	* ext/thread/thread.c (Init_thread): use rb_define_alias instead of
	  rb_alias to document alias.

Mon Dec  9 20:00:00 2013  Charlie Somerville  <charliesome@ruby-lang.org>

	* internal.h (RCLASS_SERIAL): Add RCLASS_SERIAL as a convenience
	  accessor for RCLASS_EXT(klass)->class_serial.

	* class.c, vm_insnhelper.c, vm_method.c: Use RCLASS_SERIAL

Mon Dec  9 19:50:00 2013  Charlie Somerville  <charliesome@ruby-lang.org>

	* compile.c, insns.def, test/ruby/test_rubyvm.rb, vm.c, vm_core.h,
	  vm_insnhelper.c, vm_insnhelper.h, vm_method.c: Rename method_serial
	  to global_method_state and constant_serial to global_constant_state
	  after discussion with ko1.

Mon Dec  9 18:50:43 2013  Aman Gupta <ruby@tmm1.net>

	* hash.c (rb_hash_replace): fix segv on `{}.replace({})` introduced
	  in r44060 [Bug #9230] [ruby-core:58991]
	* test/ruby/test_hash.rb: regression test for above

Mon Dec  9 18:10:10 2013  Koichi Sasada  <ko1@atdot.net>

	* vm.c (vm_stat): renamed from ruby_vm_stat.
	  Should not use ruby_ prefix here.

Mon Dec  9 16:13:31 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* gc.c (wmap_size): add ObjectSpace::WeakMap#size and #length.

Mon Dec  9 15:26:17 2013  Shugo Maeda  <shugo@ruby-lang.org>

	* test/test_curses.rb: removed.

Mon Dec  9 13:36:55 2013  Shugo Maeda  <shugo@ruby-lang.org>

	* ext/curses, sample/curses: removed curses.

	* NEWS: added an entry for the above change.

Mon Dec  9 12:26:05 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/objspace/object_tracing.c (newobj_i): use cached class path
	  only to get rid object allocation during NEWOBJ hook.
	  [ruby-core:58853] [Bug #9212]

	* variable.c (rb_class_path_cached): returns cached class path
	  only, without searching and allocating new class path string.

Mon Dec  9 11:14:26 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/date/date_parse.c (parse_time): unset case-insensitive flag
	  for [:alpha:], which already implies both cases, to get rid of
	  backtrack explosion.  [ruby-core:58876] [Bug #9221]

Mon Dec  9 08:40:40 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems:  Update to RubyGems master bf37240.  Fixes useless
	  error message with `gem install -g` with no gem dependencies file.
	* test/rubygems:  ditto.

Mon Dec  9 04:52:25 2013  Eric Hodel  <drbrain@segment7.net>

	* NEWS:  Update RubyGems entry with notable features.

Mon Dec  9 04:43:54 2013  Eric Hodel  <drbrain@segment7.net>

	* ext/.document:  Add syslog/lib and thread/thread.c to documentable
	  items.  [ruby-trunk - Bug #9228]

Mon Dec  9 04:28:50 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems:  Update to RubyGems master 096db36.  Changes include
	  support for PATH in Gemfile.lock and a typo fix from Akira Matsuda.
	* test/rubygems:  ditto.

Mon Dec  9 02:10:32 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/net/http/responses.rb:
	  Add `HTTPIMUsed`, as it is also supported by rack/rails.
	  RFC - http://tools.ietf.org/html/rfc3229
	  by Vipul A M <vipulnsward@gmail.com>
	  https://github.com/ruby/ruby/pull/447 fix GH-447

Sun Dec  8 20:47:35 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* class.c (rb_get_kwargs): when values is non-null, remove
	  extracted keywords from the rest keyword argument.

Sun Dec  8 20:26:54 2013  Yutaka Kanemoto  <kanemoto@ruby-lang.org>

	* common.mk (ruby.imp): avoid circular dependency on AIX

Sun Dec  8 20:21:00 2013  Kenta Murata  <mrkn@mrkn.jp>

	* bigdecimal.c (BigDecimal_coerce): convert a Float to a BigDecimal instead
	  of converting the receiver to a Float.  The reason is there are BigDecimal
	  instances with precisions that is smaller than the Float's precision.
	  [ruby-core:58756] [Bug #9192]

	* test/bigdecimal/test_bigdecimal.rb: add tests for the above change.

Sun Dec  8 18:28:20 2013  Kazuki Tsujimoto  <kazuki@callcc.net>

	* NEWS: [DOC] update NEWS about GC.

Sun Dec  8 17:52:24 2013  Kazuki Tsujimoto  <kazuki@callcc.net>

	* object.c: [DOC] document Module#singleton_class?.

Sun Dec  8 16:19:28 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* class.c (rb_get_kwargs): if optional is negative, unknown
	  keywords are allowed.

	* vm_insnhelper.c (vm_callee_setup_keyword_arg): check unknown
	  keywords.

Sun Dec  8 14:55:12 2013  Kazuki Tsujimoto  <kazuki@callcc.net>

	* array.c (rb_ary_shuffle_bang, rb_ary_sample): rename local variables.

Sun Dec  8 13:59:38 2013  Kazuki Tsujimoto  <kazuki@callcc.net>

	* array.c (rb_ary_shuffle_bang, rb_ary_sample): check
	  unknown keywords.

	* test/ruby/test_array.rb (test_shuffle, test_sample): tests for
	  the above.

Sun Dec  8 13:01:11 2013  Aman Gupta <ruby@tmm1.net>

	* vm.c (ruby_vm_stat): add RubyVM.stat() for access to internal cache
	  counters. this methods behaves like GC.stat, accepting an optional
	  hash or symbol argument. [Bug #9190] [ruby-core:58750]
	* test/ruby/test_rubyvm.rb: test for new method

Sun Dec  8 11:59:40 2013  Aman Gupta <ruby@tmm1.net>

	* hash.c (rb_hash_replace): add a write barrier to fix GC mark miss on
	  hashes using Hash#replace [Bug #9226] [ruby-core:58948]

Sun Dec  8 11:21:00 2013  Aman Gupta <ruby@tmm1.net>

	* include/ruby/ruby.h: add RGENGC_WB_PROTECTED_NODE_CREF setting
	  In a large app, this reduces the size of
	  remembered_shady_object_count by 80%. [Bug #9225] [ruby-core:58947]
	* gc.c (rb_node_newnode): add FL_WB_PROTECTED flag to NODE_CREF
	* class.c (rewrite_cref_stack): insert OBJ_WRITE for NODE_CREF
	* iseq.c (set_relation): ditto
	* iseq.c (rb_iseq_clone): ditto
	* vm_eval.c (rb_yield_refine_block): ditto
	* vm_insnhelper.c (vm_cref_push): ditto
	* vm_insnhelper.h (COPY_CREF): ditto

Sun Dec  8 10:45:05 2013  Aman Gupta <ruby@tmm1.net>

	* hash.c (hash_aset_str): revert r43870 due to performance issue
	  [Bug #9188] [ruby-core:58730]
	* parse.y (assoc): convert literal string hash keys to fstrings
	* test/ruby/test_hash.rb (class TestHash): expand test

Sun Dec  8 10:22:38 2013  Aman Gupta <ruby@tmm1.net>

	* parse.y (register_symid_str): use fstrings in symbol table
	  [Bug #9171] [ruby-core:58656]
	* parse.y (rb_id2str): ditto
	* string.c (rb_fstring): create frozen_strings on first usage. this
	  allows rb_fstring() calls from the parser (before cString is created)
	* string.c (fstring_set_class_i): set klass on fstrings generated
	  before cString was defined
	* string.c (Init_String): convert frozen_strings table to String
	  objects after boot
	* ext/-test-/symbol/type.c (bug_sym_id2str): expose rb_id2str()
	* test/-ext-/symbol/test_type.rb (module Test_Symbol): verify symbol
	  table entries are fstrings

Sun Dec  8 10:24:20 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems.rb:  Update version for upcoming ruby 2.1.0 RC.

Sun Dec  8 10:21:36 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems:  Update to RubyGems master 14749ce.  This fixes bugs
	  handling of gem dependencies lockfiles (Gemfile.lock).

	* test/rubygems:  ditto.

Sun Dec  8 09:40:00 2013  Charlie Somerville  <charliesome@ruby-lang.org>

	* array.c (rb_ary_or): use RHASH_TBL_RAW instead of RHASH_TBL

	* process.c (rb_execarg_fixup): use RHASH_TBL_RAW and insert write
	  barriers where appropriate

	* vm.c (kwmerge_i): use RHASH_TBL_RAW

	* vm.c (HASH_ASET): use rb_hash_aset instead of calling directly into
	  st_insert

Sat Dec  7 11:15:52 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* hash.c (rb_hash_reject): copy unrejected elements only to new hash,
	  so that the change on the original receiver can affect.
	  [ruby-core:58914] [Bug #9223]

Sat Dec  7 08:25:00 2013  Richo Healey  <richo@psych0tik.net>

	* test/ruby/test_struct.rb: Add regression test for question marks and
	  bangs in struct members. [Closes GH-468]

Fri Dec  6 19:33:39 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* class.c (rb_extract_keywords, rb_get_kwargs): move from
	  vm_insnhelper.c.

Fri Dec  6 19:18:02 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c: change oldmalloc meaning.
	  Increase oldmalloc_increase with malloc_increase
	  instead of using obj_memsize_of().

	  This change will avoid the danger of memory full without major GC.

Fri Dec  6 19:08:48 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (atomic_sub_nounderflow): not 0 but val itself.

Fri Dec  6 18:37:11 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (rb_objspace_alloc, Init_heap): initialize
	  oldmalloc_increase_limit at Init_heap.

	  rb_objspace_alloc() is not called on some platforms.

Fri Dec  6 18:33:39 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (garbage_collect_body): bug fix.
	  initialize after recording.

Fri Dec  6 17:49:46 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (atomic_sub_nounderflow): added to simplify atomic sub with
	  care about underflow.

	* gc.c (objspace_malloc_increase): use it.

Fri Dec  6 17:10:44 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_insnhelper.c (rb_get_kwargs): get keyword argument values from an
	  option hash, not only checking keys.

	* dir.c (dir_initialize): use rb_get_kwargs.

	* gc.c (gc_start_internal): ditto.

Fri Dec  6 16:47:45 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* misc/ruby-mode.el (ruby-brace-to-do-end): split single line block.

	* misc/ruby-mode.el (ruby-do-end-to-brace): shrink single line block
	  to one line.

Fri Dec  6 16:16:30 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (gc_start_internal): do not use rb_gc_start() and rb_gc().

Fri Dec  6 15:24:30 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (gc_start_internal, rb_gc): do not need
	  heap_pages_free_unused_pages() here.
	  It was done in after_sweep().

	* gc.c (rb_gc): The reason is now GPR_FLAG_CAPI.

Fri Dec  6 14:05:19 2013  Aman Gupta <ruby@tmm1.net>

	* gc.c (gc_start_internal): GC.start() now accepts two optional
	  keyword arguments. These can be used to disable full_mark (minor
	  mark only) or disable immediate_sweep (use lazy sweep). These new
	  options are useful for benchmarking GC behavior, or performing minor
	  GC out-of-band.
	* test/ruby/test_gc.rb (class TestGc): tests for new options.

Fri Dec  6 11:51:28 2013  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* lib/erb.rb: [DOC] fix broken link, Use rubygems.org and www.ruby-toolbox.com instead of RAA.
	  [Bug #9197]

Fri Dec  6 10:50:54 2013  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* lib/webrick/httprequest.rb: [DOC] Fix broken link of CGI specification by @udzura [fix GH-466]

Thu Dec  6 01:27:00 2013  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (GetVpValueWithPrec):
	  treat 0.0 and -0.0 of floating-point numbers specially for an optimization
	  and to correctly propagate its signbit to the result.
	  [Bug #9214] [ruby-core:58858]

	* test/bigdecimal/test_bigdecimal.rb: add tests case for the above change.

	* test/bigdecimal/test_bigdecimal_util.rb: ditto.

Thu Dec  5 22:18:01 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (configuration): strip destdir part from prefix to get
	  rid of duplication.  a patch by arton at [ruby-core:58859].
	  [ruby-core:58856] [Bug #9213]

Thu Dec  5 21:53:29 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* array.c (rb_ary_or): lhs elements are preferred, so should not
	  replace with rhs elements.

	* test/ruby/test_array.rb (test_OR_in_order): import the test failed
	  by r43969 from rubyspec/core/array/union_spec.rb.

Thu Dec  5 21:05:42 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (gc_info_decode): fix to avoid syntax error on VS2012.

Thu Dec  5 19:35:35 2013  Martin Duerst <duerst@it.aoyama.ac.jp>

	* st.c: tweaked comment

Thu Dec  5 19:21:10 2013  Aman Gupta <ruby@tmm1.net>

	* gc.c (struct rb_objspace): rename internal last_collection_flags to
	  latest_gc_info
	* gc.c (gc_latest_collection_info): add GC.latest_gc_info() with similar
	  behavior to GC.stat()
	* gc.c (rb_gc_latest_gc_info): new c-api for above
	* gc.c (gc_stat_internal): remove :last_collection_flags from GC.stat
	* gc.c (gc_profile_decode_flags): remove GC::Profiler.decode_flags
	* include/ruby/intern.h (rb_gc_latest_gc_info): export new c-api
	* test/ruby/test_gc.rb (class TestGc): test for new behavior
	* NEWS: note about new api

	* gc.c (gc_stat_internal): raise TypeError on wrong type
	* gc.c (gc_stat): fix error message

Thu Dec  5 18:18:08 2013  Aman Gupta <ruby@tmm1.net>

	* ext/objspace/gc_hook.c: remove this file
	* ext/-test-/tracepoint/gc_hook.c: new filename for above
	* ext/objspace/objspace.c: remove ObjectSpace.after_gc_start_hook=
	* test/objspace/test_objspace.rb: remove test
	* test/-ext-/tracepoint/test_tracepoint.rb: add above test for
	  tracepoint re-entry

Thu Dec  5 17:44:53 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c: change function names vm_ prefix to objspace_ prefix.
	  They are objspace_ functionality.

Thu Dec  5 16:11:04 2013  Aman Gupta <ruby@tmm1.net>

	* include/ruby/intern.h: add rb_gc_stat() for access to GC.stat
	  variables from c-api
	* gc.c (rb_gc_stat): new c-api method. accepts either VALUE hash like
	  GC.stat, or VALUE symbol key and returns size_t directly. the second
	  form is useful to avoid allocations, i.e. for usage inside
	  INTERNAL_EVENT_GC tracepoints.
	* gc.c (gc_stat): add GC.stat(:key) to return single value instead of hash
	* gc.c (gc_stat_internal): helper method to retrieve single or all stat values
	* test/ruby/test_gc.rb (class TestGc): test for new behavior
	* NEWS: note about this new api

Thu Dec  5 14:40:41 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* hash.c (rb_hash): revert r43981 and bail out to the outermost frame
	  when recursion is detected.

Thu Dec  5 13:47:15 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (vm_malloc_size): added.
	  return malloc_usable_size() if possible.

	* gc.c (MALLOC_ALLOCATED_SIZE): add new setting macro to enable
	  GC.allocated_size.
	  If platform supports `malloc_usable_size()' (or similar one),
	  GC.allocated_size can be implemented with this function.
	  Default is 0.

	* gc.c (vm_xmalloc, vm_xrealloc, vm_xfree): use vm_malloc_size()
	  to detect collect allocated size.

	* gc.c (vm_malloc_increase): refactoring.

Thu Dec  5 13:19:03 2013  Aman Gupta <ruby@tmm1.net>

	* include/ruby/ruby.h: remove INTERNAL_EVENT_GC_END and replace with
	  two new events: GC_END_MARK and GC_END_SWEEP
	* gc.c (gc_after_sweep): emit GC_END_SWEEP after lazy sweep is done
	* gc.c (gc_marks_body): emit GC_END_MARK at end of minor/major mark
	* ext/-test-/tracepoint/tracepoint.c (struct tracepoint_track): tests
	  for new events.
	* test/-ext-/tracepoint/test_tracepoint.rb (class TestTracepointObj):
	  ditto.
	* NEWS: remove ObjectSpace.after_gc_*_hook. These are only a sample,
	  and will be removed before ruby 2.1.
	* ext/objspace/gc_hook.c: remove ObjectSpace.after_gc_end_hook=

Thu Dec  5 10:47:56 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ruby_atomic.h (ATOMIC_PTR_EXCHANGE): atomic exchange function for
	  a generic pointer.

Thu Dec  5 10:47:09 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* gc.c (finalize_deferred): flush all deferred finalizers while other
	  finalizers can get ready to run newly by lazy sweep.
	  [ruby-core:58833] [Bug #9205]

Thu Dec  5 09:07:59 2013  Aman Gupta <ruby@tmm1.net>

	* gc.c (ruby_gc_set_params): Accept safe_level argument so GC tuning
	  settings can be applied before rb_safe_level() is available.
	* internal.h (rb_gc_set_params): ditto.
	* ruby.c (process_options): Apply GC tuning early during boot process
	  so boot-time allocations can benefit. This also benefits any code
	  loaded in via `ruby -r`.

Wed Dec  4 13:02:13 2013  Aman Gupta <ruby@tmm1.net>

	* vm_trace.c (rb_suppress_tracing): Fix initialization of stack
	  allocated rb_trace_arg_t structure. Without this patch, sometimes
	  INTERNAL_EVENT_GC would be skipped accidentally inside
	  rb_threadptr_exec_event_hooks_orig().

Wed Dec  4 12:57:24 2013  Aman Gupta <ruby@tmm1.net>

	* string.c (fstr_update_callback): Improve implementation in r43968
	  based on feedback from @nagachika. In the existing case, we can
	  return ST_STOP to prevent any hash modification. In the !existing
	  case, set both key and value to the fstr.

Wed Dec  4 12:47:54 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/delegate.rb (Delegator#method_missing): ignore the target if not
	  set, and delegate to global methods.  [ruby-core:58572] [Bug #9155]

	* lib/delegate.rb (Delegator#respond_to_missing): ditto.

	* lib/delegate.rb (SimpleDelegator#__getobj__): yield and return if
	  not delegated but a block is given, like as Hash#fetch.

	* lib/delegate.rb (DelegateClass#__getobj__): ditto.

Tue Dec  3 23:48:18 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in: check malloc_size() availability.

	* gc.c: use malloc_size() with malloc/malloc.h if available.

Tue Dec  3 23:06:20 2013  Narihiro Nakamura  <authornari@gmail.com>

	* object.c (rb_obj_clone): don't copy FL_WB_PROTECTED of a
	  original object.

Tue Dec  3 22:32:18 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* hash.c (rb_hash_recursive): make similar (recursive) constructs
	  return same hash value.  execute recursively, and rewind to the
	  topmost frame with an object which .eql? to the recursive
	  object, if recursion is detected.

	* hash.c (rb_hash): detect recursion for all `hash' methods.  each
	  `hash' methods no longer need to use rb_exec_recursive().

Tue Dec  3 21:53:15 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_eval.c (rb_catch_protect): new function similar to
	  rb_catch_obj(), but protect from all global jumps like as
	  rb_load_protect(), rb_protect(), etc.

Tue Dec  3 20:18:46 2013  Narihiro Nakamura  <authornari@gmail.com>

	* object.c (rb_obj_clone): Protect FL_PROMOTED and FL_WB_PROTECTED
	  flags of a destination object.

Tue Dec  3 20:16:38 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* array.c (rb_hash_rehash): use hash_alloc() instead of rb_hash_new(),
	  to hide temporary object from ObjectSpace.  [Bug #9187]

Tue Dec  3 17:11:47 2013  Aman Gupta <ruby@tmm1.net>

	* load.c (features_index_add_single): Move loaded_features_index array values off
	  the ruby heap. [Bug #9201] [ruby-core:58805]
	* load.c (loaded_features_index_clear_i): Clean up off-heap array structure.
	* vm.c (rb_vm_mark): Remove unnecessary mark_tbl for loaded_features_index.
	  This improves minor GC time by 15% in a large application.

Tue Dec  3 17:01:45 2013  Aman Gupta <ruby@tmm1.net>

	* include/ruby/ruby.h (struct RClass): Add wrapper struct around
	  RClass->m_tbl with serial. This prevents double marking method
	  tables, since many classes/modules can share the same method table.
	  This improves minor mark time in a large application by 30%.
	* internal.h (struct method_table_wrapper): Define new
	  wrapper struct with additional serial.
	* internal.h (RCLASS_M_TBL_INIT): New macro for initializing method
	  table wrapper and st_table.
	* method.h (void rb_sweep_method_entry): Rename rb_free_m_table to
	  rb_free_m_tbl for consistency
	* .gdbinit (define rb_method_entry): Update rb_method_entry gdb helper
	  for new method table structure.
	* class.c: Use RCLASS_M_TBL_WRAPPER and
	  RCLASS_M_TBL_INIT macros.
	* class.c (rb_include_class_new): Share WRAPPER between module and
	  iclass, so serial can prevent double marking.
	* eval.c (rb_prepend_module): ditto.
	* eval.c (rb_using_refinement): ditto.
	* gc.c: Mark and free new wrapper struct.
	* gc.c (obj_memsize_of): Count size of additional wrapper struct.

Tue Dec  3 14:05:49 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* array.c (rb_ary_uniq_bang): remove duplicate code.

Tue Dec  3 13:40:42 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* array.c (ary_add_hash): set and return values because string keys
	  will be frozen. [ruby-core:58809] [Bug #9202]

	* array.c (rb_ary_uniq_bang): ditto.

	* array.c (rb_ary_or): ditto.

	* array.c (rb_ary_uniq): ditto.

	* test/ruby/test_array.rb: tests for above.

	The patch is from normalperson (Eric Wong).

Tue Dec  3 12:20:21 2013  Aman Gupta <ruby@tmm1.net>

	* string.c (rb_fstring): Use st_update instead of st_lookup +
	  st_insert.
	* string.c (fstr_update_callback): New callback for st_update.

Tue Dec  3 12:17:59 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/rdoc/constant.rb (RDoc::Constant#documented?): workaround for
	  NoMethodError when the original of alias is not found.

Tue Dec  3 10:43:58 2013  Eric Hodel  <drbrain@segment7.net>

	* ext/openssl/lib/openssl/buffering.rb:  Return ASCII-8BIT strings from
	  SSLSocket methods.  [ruby-trunk - Bug #9028]
	* test/openssl/test_ssl.rb:  Test for the above.

Tue Dec  3 09:42:27 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rdoc:  Update to RDoc master 900de99.  Changes include:

	  Fixed documentation display of constants

	  Fixed handling of unknown parsers

	* test/rdoc:  ditto.

Mon Dec  2 22:30:10 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* hash.c (getenv): fixed test failures introduced by r43950.
	  [ruby-core:58774] [Bug #9195] reported by phasis68 (Heesob Park).

Mon Dec  2 21:49:19 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* hash.c (rb_hash_rehash): make temporary st_table under the control
	  of GC. [Bug #9187]

	* test/ruby/test_hash.rb: add a test for above.

Mon Dec  2 17:23:00 2013  Charlie Somerville  <charliesome@ruby-lang.org>

	* variable.c (rb_mod_constants): when calling Module#constants with
	  inherit=false, there is no need to use a hashtable to deduplicate
	  constant names. [Feature #9196] [ruby-core:58786]

Mon Dec  2 14:16:52 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/net/smtp.rb (Net::SMTP#critical):  Always return a
	  Net::SMTP::Response.  Patch by Pawel Veselov.
	  [ruby-trunk - Bug #9125]
	* test/net/smtp/test_smtp.rb:  Test for the above.

Mon Dec  2 05:52:33 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems:  Update to RubyGems master baa965b.  Notable changes:

	  Copy directories to lib/ when installing extensions.  This completes
	  the fix for [ruby-trunk - Bug #9106]

	* test/rubygems:  ditto.

Mon Dec  2 02:03:47 2013  Shota Fukumori  <her@sorah.jp>

	* test/ruby/test_case.rb (test_nomethoderror):
	  Add test related to r43913, r43914

Mon Dec  2 00:53:01 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* hash.c (getenv): use ANSI codepage version of getenv() for miniruby
	  on Windows.
	  [ruby-core:58732] [Bug #9189] reported by phasis68 (Heesob Park).

Sun Dec  1 22:14:27 2013  Zachary Scott  <e@zzak.io>

	* doc/contributors.rdoc: [DOC] Import contributors from redmine wiki
	  Many wiki pages have become outdated and spam-ridden, we will import
	  these to trunk and begin maintaining them in ruby-trunk. This will
	  also allow new contributors to easily contribute patches to update
	  these pages, where previously a redmine account with wiki access was
	  required. Another bonus is having a contributors file to show thanks
	  to all of the people who have submitted a patch to Ruby.

Sun Dec  1 18:03:26 2013  Zachary Scott  <e@zzak.io>

	* doc/maintainers.rdoc: [DOC] Current maintainers of Ruby

Sun Dec  1 17:17:36 2013  Zachary Scott  <e@zzak.io>

	* doc/contributing.rdoc: [DOC] Current branch maintainers

Sun Dec  1 17:16:36 2013  Zachary Scott  <e@zzak.io>

	* doc/contributing.rdoc: [DOC] Reporting other (ruby-lang.org) issues

Sun Dec  1 17:15:51 2013  Zachary Scott  <e@zzak.io>

	* doc/contributing.rdoc: [DOC] Current platform maintainers

Sun Dec  1 17:14:55 2013  Zachary Scott  <e@zzak.io>

	* doc/contributing.rdoc: [DOC] Reporting downstream distro issues

Sun Dec  1 14:37:20 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* hash.c (rb_hash_to_a): specify array capa.

Sun Dec  1 14:15:36 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* hash.c (rb_hash_rehash): fix to free new st_table when exception
	  is raised in do_hash(). [Bug #9187]

Sun Dec  1 11:57:59 2013  Zachary Scott  <e@zzak.io>

	* ext/openssl/lib/openssl/buffering.rb: Fix warning in copyright

Sun Dec  1 08:27:28 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems:  Update to RubyGems master 66e5c39.  Notable changes:

	  Implement gem.deps.rb (Gemfile) .lock support

	  Fixed `gem uninstall` for a relative directory in GEM_HOME.

	* test/rubygems:  ditto.

Sun Dec  1 06:00:49 2013  Aman Gupta <ruby@tmm1.net>

	* test/ruby/test_gc.rb (test_gc_reason): Force minor GC by consuming
	  free slots to fix test.

Sat Nov 30 21:22:11 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* dir.c (dir_initialize): check unknown keywords.  [ruby-dev:47152]
	  [Bug #8060]

Sat Nov 30 18:05:38 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/win32ole/win32ole.c (hash2named_arg): correct declaration to fix
	  build failure.  a patch by phasis68 (Heesob Park) at
	  [ruby-core:58710].  [Bug #9184]

Sat Nov 30 17:46:35 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (ruby_cleanup): determine exit status and signal to terminate
	  before finalization, to get rid of access destroyed T_DATA exception
	  object.  [ruby-core:58643] [Bug #9167]

Sat Nov 30 16:25:14 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* enumerator.c (enumerator_with_index): should not store local variable
	  address to memoize the arguments.  it is invalidated after the return.
	  [ruby-core:58692] [Bug #9178]

Sat Nov 30 13:28:13 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* siphash.c (sip_hash24): fix for aligned word access little endian
	  platforms.  [ruby-core:58658] [Bug #9172]

Sat Nov 30 13:21:15 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_eval.c (rb_yield_block): implement non-nil block argument.

Fri Nov 29 20:59:39 2013  Masaya Tarui  <tarui@ruby-lang.org>

	* vm_dump.c (rb_vmdebug_debug_print_pre): Bugfix. Get PC directly.
	  PC is cached into local stack and cfp->pc is incorrect at next of
	  branch or jump.
	* vm_exec.h (DEBUG_ENTER_INSN): catch up this change.
	* vm_core.h: update signature of rb_vmdebug_debug_print_pre.

Fri Nov 29 20:43:57 2013  Masaya Tarui  <tarui@ruby-lang.org>

	* compile.c: Bugsfix for dump_disasm_list.
	  rb_inspect denies a hidden object. So, insert wrapper that creates
	  the unhidden one.
	  adjust->label is null sometimes.
	  insn_data_line_no makes no sense at all.

Fri Nov 29 18:06:45 2013  Shota Fukumori  <her@sorah.jp>

	* test/ruby/test_case.rb (test_method_missing): Test for r43913.

Fri Nov 29 17:53:22 2013  Shota Fukumori  <her@sorah.jp>

	* vm_insnhelper.c (check_match): Fix SEGV with VM_CHECKMATCH_TYPE_CASE
	  and class of `pattern` has `method_missing`
	  [Bug #8872] [ruby-core:58606]

Fri Nov 29 17:06:09 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_eval.c (rb_yield_block): yield block with rb_block_call_func
	  arguments.

	* range.c (range_each): use rb_yield_block.

	* include/ruby/ruby.h (RB_BLOCK_CALL_FUNC_ARGLIST): constify argv.

	* enum.c (rb_enum_values_pack): ditto.

	* vm_eval.c (rb_block_call, rb_check_block_call): ditto.

	* include/ruby/ruby.h (RB_BLOCK_CALL_FUNC_ARGLIST): for declaration
	  argument list of rb_block_call_func.

Fri Nov 29 11:26:43 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/ruby.h (rb_block_call_func): add blockarg.  block
	  function can take block argument, e.g., proc {|&blockarg| ...}.

Thu Nov 28 21:43:48 2013  Zachary Scott  <e@zzak.io>

	* doc/dtrace_probes.rdoc: [DOC] Import dtrace probes doc from wiki

Thu Nov 28 21:17:32 2013  Zachary Scott  <e@zzak.io>

	* doc/contributing.rdoc: [DOC] Add heading above ChangeLog tips to
	  setup entry for commits, its not required. Actually easier if
	  contributors don't include a ChangeLog entry.

Thu Nov 28 21:16:18 2013  Zachary Scott  <e@zzak.io>

	* doc/contributing.rdoc: [DOC] Add coding style heading for patch
	  rules

Thu Nov 28 21:15:45 2013  Zachary Scott  <e@zzak.io>

	* doc/contributing.rdoc: [DOC] Add notes about deciding what to patch

Thu Nov 28 19:43:45 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* benchmark/bm_hash_flatten.rb: added. r43896 is about 4 times faster
	  than 2.0.0p353.

	* benchmark/bm_hash_keys.rb: added. r43896 is about 5 times faster
	  than 2.0.0p353.

	* benchmark/bm_hash_values.rb: added. r43896 is about 5 times faster
	  than 2.0.0p353.

Thu Nov 28 19:29:04 2013  Zachary Scott  <e@zzak.io>

	* doc/contributing.rdoc: [DOC] Add notes about slideshow proposals
	  from wiki page: HowToRequestFeatures

Thu Nov 28 17:34:42 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* st.c: add st_values() and st_values_check().

	* include/ruby/st.h: add prototypes for above.

	* hash.c (rb_hash_values): use st_values_check() for performance
	  improvement if VALUE and st_data_t are compatible.

Thu Nov 28 17:14:14 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* st.c (st_keys): fix not to use Qundef in st.c.

	* include/ruby/st.h: define modified prototype.

	* hash.c (rb_hash_keys): use modified st_keys().

Thu Nov 28 16:34:43 2013  Aman Gupta <ruby@tmm1.net>

	* gc.c: Expose details about last garbage collection via GC.stat.
	* gc.c (gc_stat): Add :last_collection_flags for reason/trigger/type of
	  last GC run.
	* gc.c (gc_prof_sweep_timer_stop): Record HAVE_FINALIZE GPR even
	  without GC_PROFILE_MORE_DETAIL.
	* gc.c (gc_profile_flags): Add GC::Profiler.decode_flags to make sense
	  of GC.stat[:last_collection_flags]
	* test/ruby/test_gc.rb (class TestGc): Test for above.

Thu Nov 28 16:15:47 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* win32/win32.c (rb_w32_dup2): extract from rb_cloexec_dup2() and
	  redirect_dup2().

Tue Nov 28 14:40:00 2013  Akira Matsuda  <ronnie@dio.jp>

	* lib/drb/ssl.rb:  [Doc] Fix typo

Thu Nov 28 13:56:05 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* common.mk (Doxyfile): tool/file2lastrev.rb needs running with
	  BASERUBY since r43617.  [ruby-dev:47823] [Bug #9169]

Thu Nov 28 09:18:39 2013  Koichi Sasada  <ko1@atdot.net>

	* string.c (rb_fstring): fstrings should be ELTS_SHARED.
	  If we resurrect dying objects (non-marked, but not swept yet),
	  pointing shared string can be collected.
	  To avoid such issue, fstrings (recorded to fstring_table)
	  should not be ELTS_SHARED (should not have a shared string).

Thu Nov 28 01:35:08 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* st.c (st_keys): fix to use st_index_t for size of hash.

Thu Nov 28 00:36:52 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* st.c (st_keys): define st_keys(). it writes each key to buffer.

	* hash.c (rb_hash_keys): use st_keys() for performance improvement
	  if st_data_t and VALUE are compatible.

	* include/ruby/st.h: define macro ST_DATA_COMPATIBLE_P() to predicate
	  whether st_data_t and passed type are compatible.

	* configure.in: check existence of builtin function to use in
	  ST_DATA_COMPATIBLE_P().

Thu Nov 28 00:07:28 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* ruby_atomic.h: remove duplicate definitions between ATOMIC_XXX
	  and ATOMIC_SIZE_XXX.

Wed Nov 27 23:55:50 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* ruby_atomic.h: define ATOMIC_SIZE_CAS() with
	  __atomic_compare_exchange_n() and refactoring.

Tue Nov 27 21:43:00 2013  Akira Matsuda  <ronnie@dio.jp>

	* lib/irb/notifier.rb:  [Doc] Fix typo
	* ext/json/lib/json/common.rb:  Ditto.

Tue Nov 27 18:04:57 2013  Akira Matsuda  <ronnie@dio.jp>

	* lib/irb/notifier.rb:  Fix typo

Wed Nov 27 17:54:57 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (gc_mark_stacked_objects): check only when check_mode > 0.

Wed Nov 27 16:07:19 2013  Aman Gupta <ruby@tmm1.net>

	* test/ruby/test_gc.rb (class TestGc): Fix warning in
	  test_expand_heap.

Wed Nov 27 15:55:52 2013  Aman Gupta <ruby@tmm1.net>

	* gc.c (Init_GC): Add new GC::INTERNAL_CONSTANTS for information about
	  GC heap/page/slot sizing.
	* test/ruby/test_gc.rb (class TestGc): test for above.

Wed Nov 27 15:21:17 2013  Aman Gupta <ruby@tmm1.net>

	* gc.c (gc_page_sweep): Fix compile warning from last commit.
	* hash.c (hash_aset_str): Re-use existing variable to avoid
	  unnecessary pointer dereferencing.

Wed Nov 27 15:12:55 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (gc_page_sweep): disable debug print.

Wed Nov 27 15:05:59 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (gc_stat): add new information heap_eden_page_length and
	  heap_tomb_page_length.

	* test/ruby/test_gc.rb: fix to use GC.stat[:heap_eden_page_length]
	  instead of GC.stat[:heap_length].
	  This test expects `heap_eden_page_length' (used pages size).

Wed Nov 27 15:02:53 2013  Aman Gupta <ruby@tmm1.net>

	* test/ruby/test_eval.rb (class TestEval): Use assert_same instead of
	  assert_equal.
	* test/ruby/test_hash.rb (class TestHash): ditto.
	* test/ruby/test_iseq.rb (class TestISeq): ditto.

Wed Nov 27 14:50:02 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rinda/ring.rb:  Announce RingServer for the same process.
	  [ruby-trunk - Bug #9163]
	* test/rinda/test_rinda.rb:  Tests for the above.

Wed Nov 27 14:37:33 2013  Aman Gupta <ruby@tmm1.net>

	* test/ruby/test_eval.rb (class TestEval): Add test for shared eval
	  filenames via rb_fstring().
	* test/ruby/test_iseq.rb (class TestISeq): Add test for shared
	  iseq labels via rb_fstring(). [Bug #9159]

Wed Nov 27 14:24:55 2013  Aman Gupta <ruby@tmm1.net>

	* hash.c (hash_aset_str): Use rb_fstring() to de-duplicate hash string
	  keys. Patch by Eric Wong. [Bug #8998] [ruby-core:57727]
	* test/ruby/test_hash.rb (class TestHash): test for above.

Wed Nov 27 10:39:39 2013  Aman Gupta <ruby@tmm1.net>

	* gc.c: Rename rb_heap_t members:
	    used -> page_length
	    limit -> total_slots

Wed Nov 27 08:24:49 2013  Aman Gupta <ruby@tmm1.net>

	* compile.c: Use rb_fstring() to de-duplicate string literals in code.
	  [ruby-core:58599] [Bug #9159] [ruby-core:54405]
	* iseq.c (prepare_iseq_build): De-duplicate iseq labels and source
	  locations.
	* re.c (rb_reg_initialize): Use rb_fstring() for regex string.
	* string.c (rb_fstring): Handle non-string and already-fstr arguments.
	* vm_eval.c (eval_string_with_cref): De-duplicate eval source
	  filename.

Wed Nov 27 07:13:54 2013  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych.rb: psych version 2.0.2
	* ext/psych/psych.gemspec: ditto

Wed Nov 27 06:40:18 2013  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/scalar_scanner.rb: fix support for negative
	  years.
	* ext/psych/lib/psych/visitors/yaml_tree.rb: ditto
	* test/psych/test_date_time.rb: test for change.
	  Fixes: https://github.com/tenderlove/psych/issues/168

Wed Nov 27 04:46:55 2013  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/scalar_scanner.rb: fix regexp for matching TIME
	  strings.
	* test/psych/test_date_time.rb: test for change.
	  Fixes: https://github.com/tenderlove/psych/issues/171

Wed Nov 27 02:26:58 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (str_new4): copy the original capacity so that memsize of
	  frozen shared string returns correct size.

Wed Nov 27 02:20:13 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* array.c (rb_ary_hash): should not ignore the rest of recursive
	  constructs.

	* hash.c (rb_hash_hash): ditto.

	* range.c (range_hash): ditto.

	* struct.c (rb_struct_hash): ditto.

	* test/-ext-/test_recursion.rb (TestRecursion): separate from
	  test/ruby/test_thread.rb.

Tue Nov 26 22:43:36 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* hash.c (rb_hash): cut off if recursion detected to get rid of stack
	  overflow.  [ruby-core:58567] [Bug #9151]

Tue Nov 26 20:02:39 2013  Koichi Sasada  <ko1@atdot.net>

	* test/ruby/test_settracefunc.rb: add tests for a_call/a_return
	  by Brandur <brandur@mutelight.org> [Feature #9120]

Tue Nov 26 19:29:52 2013  Koichi Sasada  <ko1@atdot.net>

	* common.mk: add useful config "set breakpoint pending on"
	  for run.gdb.

Tue Nov 26 19:17:47 2013  Koichi Sasada  <ko1@atdot.net>

	* ext/objspace/object_tracing.c (newobj_i): skip class_path if class
	  is frozen.

	  rb_class_path() can modify frozen classes (and causes errors).
	  This patch is temporary. We need no-modification/no-allocation
	  class path function.

Tue Nov 26 18:12:13 2013  Koichi Sasada  <ko1@atdot.net>

	* vm_trace.c: skip "exception check" and "reentrant check (only normal
	  events)  for internal events.

	  Reentrant check for internal events are remaining.

Tue Nov 26 17:38:16 2013  Koichi Sasada  <ko1@atdot.net>

	* vm_trace.c: prohibit to specify normal events and internal events
	  simultaneously.
	  I will introduce special care for internal events later.

	* ext/-test-/tracepoint/tracepoint.c: test this behavior.

	* test/-ext-/tracepoint/test_tracepoint.rb: ditto.

Tue Nov 26 16:30:31 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (rb_readlink): fix buffer overflow on a long symlink. since
	  rb_str_modify_expand() expands from its length but not its capacity,
	  need to set the length properly for each expansion.
	  [ruby-core:58592] [Bug #9157]

Tue Nov 26 14:23:17 2013  Aman Gupta <ruby@tmm1.net>

	* ext/objspace/objspace_dump.c (dump_append_string_value): Escape
	  control characters for strict json parsers.
	* ext/objspace/objspace_dump.c (objspace_dump): Document File/IO
	  output option.

Tue Nov 26 11:43:19 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* ruby_atomic.h: use __atomic builtin functions supported by GCC.
	  __sync family are legacy functions now and it is recommended
	  that new code use the __atomic functions.
	  http://gcc.gnu.org/onlinedocs/gcc/_005f_005fatomic-Builtins.html

	* configure.in: check existence of __atomic functions.

Tue Nov 26 10:57:49 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/bigdecimal/bigdecimal.gemspec: revert Gem::Specification#date
	  for snapshot/release tarballs.

Tue Nov 26 06:42:50 2013  Aman Gupta <ruby@tmm1.net>

	* NEWS: Add ObjectSpace.after_gc_{start,end}_hook=
	* ext/objspace/objspace_dump.c: [DOC] catch up dump/dump_all to r43679

Tue Nov 26 04:12:10 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems:  Update to RubyGems master 612f85a.  Notable changes:

	  Fixed installation and activation of git: and path: gems via
	  Gem.use_gemdeps

	  Improved documentation coverage

	* test/rubygems:  ditto.

Mon Nov 25 22:23:03 2013  Zachary Scott  <e@zzak.io>

	* lib/xmlrpc.rb: [DOC] Fix link to xmlrpc4r site [Bug #9148]
	  Patch by Giorgos Tsiftsis

Mon Nov 25 19:48:10 2013  Zachary Scott  <e@zzak.io>

	* lib/uri/common.rb: [DOC] typo fixes by @vipulnsward [Fixes GH-456]
	  https://github.com/ruby/ruby/pull/456
	* lib/uri/generic.rb: [DOC] ditto.

Mon Nov 25 14:34:42 2013  Zachary Scott  <e@zzak.io>

	* ext/bigdecimal/bigdecimal.gemspec: bump BigDecimal to 1.2.3 for
	  proper release date in RubyGems

Mon Nov 25 14:25:08 2013  Zachary Scott  <e@zzak.io>

	* ext/bigdecimal/bigdecimal.gemspec: Remove Gem::Specification#date
	  We should rely on rubygems to create the date the gem was released
	  for each version.

Mon Nov 25 06:53:30 2013  Koichi Sasada  <ko1@atdot.net>

	* internal.h: do not use ruby_sized_xrealloc() and ruby_sized_xfree()
	  if HAVE_MALLOC_USABLE_SIZE (or _WIN32) is defined.

	  We don't need these function if malloc_usable_size() is available.

	* gc.c: catch up this change.

	* gc.c: define HAVE_MALLOC_USABLE_SIZE on _WIN32.

	* array.c (ary_resize_capa): do not use ruby_sized_xfree() with
	  local variable to avoid "unused local variable" warning.
	  This change only has few impact.

	* string.c (rb_str_resize): ditto.

Mon Nov 25 05:05:04 2013  Koichi Sasada  <ko1@atdot.net>

	* test/-ext-/tracepoint/test_tracepoint.rb: catch up GC.stat changes
	  at r43835.

Mon Nov 25 04:45:59 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c: continue to change OLDSPACE -> OLDMALLOC.
	  RGENGC_ESTIMATE_OLDSPACE -> RGENGC_ESTIMATE_OLDMALLOC.

	* gc.c: add a new major GC reason GPR_FLAG_MAJOR_BY_OLDMALLOC.

Mon Nov 25 04:16:09 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c: change terminology "..._num" to "..._slots" about slot operation.
	  * final_num -> final_slots
	  * objspace_live_num() -> objspace_live_slots()
	  * objspace_limit_num() -> objspace_limit_slots()
	  * objspace_free_num() -> objspace_free_slots()

Mon Nov 25 04:03:12 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (gc_stat): add internal information.
	  * heap_swept_slot
	  * malloc_increase
	  * malloc_limit
	  * remembered_shady_object
	  * remembered_shady_object_limit
	  * old_object
	  * old_object_limit
	  * oldmalloc_increase
	  * oldmalloc_limit

	* gc.c (gc_stat): rename names.
	  * heap_live_num -> heap_live_slot
	  * heap_free_num -> heap_free_slot
	  * heap_final_slot -> heap_final_slot

	  Quote from RDoc of GC.stat():
	    "The contents of the hash are implementation specific and may
	    be changed in the future."

	* test/ruby/test_gc.rb: catch up this change.

Mon Nov 25 03:59:45 2013  Koichi Sasada  <ko1@atdot.net>

	* test/ruby/test_gc.rb: catch up last commit.
	  Now RUBY_GC_OLDSPACE_LIMIT(...) is RUBY_GC_OLDMALLOC_LIMIT(...).

Mon Nov 25 03:10:46 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c: change terminology OLDSPACE -> OLDMALLOC.
	  (oldspace -> oldmalloc for variable names)

	  OLDSPACE is confusing because it is not includes slots.
	  To more clearly, rename such as (oldspace_limit -> oldmalloc_limit).
	  It is clear that it measures (estimates) malloc()'ed size.

Mon Nov 25 00:50:03 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* internal.h: use __builtin_bswap16() if possible.

	* configure.in: check existence of __builtin_bswap16().

Sun Nov 24 22:24:19 2013  Tanaka Akira  <akr@fsij.org>

	* bignum.c (bigxor_int): Apply BIGLO for long in a BDIGIT expression.
	  (bigor_int): Ditto.
	  (bigand_int): Ditto.

Sun Nov 24 18:13:23 2013  Tanaka Akira  <akr@fsij.org>

	* include/ruby/defines.h (SIZEOF_ACTUAL_BDIGIT): Defined.

	* include/ruby/ruby.h (RBIGNUM_EMBED_LEN_MAX): Use
	  SIZEOF_ACTUAL_BDIGIT instead of SIZEOF_BDIGITS.
	  SIZEOF_BDIGITS can be different to sizeof(BDIGIT).

Sun Nov 24 13:49:08 2013  Tanaka Akira  <akr@fsij.org>

	* include/ruby/defines.h: Don't use int128_t for Bignum.
	  It's not always faster.

	* bignum.c: Ditto.

Sun Nov 24 10:18:15 2013  Aman Gupta <ruby@tmm1.net>

	* NEWS: Add details about new debugging features and APIs.

Sun Nov 24 09:37:20 2013  Andrew Vit  <andrew@avit.ca>

	* lib/csv.rb: Optimize header hashes by freezing string keys.
	  [ruby-core:58510]

Sun Nov 24 09:18:06 2013  Aman Gupta <ruby@tmm1.net>

	* ext/objspace/objspace_dump.c (dump_object): Use PRIuSIZE to print
	  size_t for better win32 compatibility.
	* test/objspace/test_objspace.rb (test_dump_all): Hold reference to
	  test string to avoid failure due to GC. Reduce size of failure message
	  using grep(/TEST STRING/).

Sun Nov 24 08:38:00 2013  Kyle Stevens  <kstevens715@gmail.com>

	* lib/csv.rb: If skip_lines is set to a String, convert it to a Regexp
	  to prevent the alternative, which is that each line in the CSV gets
	  converted to a Regexp when calling skip_lines#match.

Sun Nov 24 01:03:00 2013  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (BigDecimal_power): Use FIX2LONG instead
	  of FIX2INT to avoid conversion error.

Sun Nov 24 00:44:30 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/ruby.h (RBIGNUM_EMBED_LEN_MAX): define by macros
	  defined in defines.h, instead of complex and repeated expression.

Sat Nov 23 22:22:26 2013  Tanaka Akira  <akr@fsij.org>

	* include/ruby/ruby.h (RBIGNUM_EMBED_LEN_MAX): Limit the value to
	  less than 8.

Sat Nov 23 19:52:00 2013  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/lib/bigdecimal/math.rb (BigMath.E): Use BigMath.exp.
	  [Feature #6857] [ruby-core:47130]

Sat Nov 23 19:46:00 2013  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (BigMath_s_exp): Optimize the
	  calculation algorithm to reduce the number of divisions.
	  This optimization was proposed by Rafal Michalski.
	  [Feature #6857] [ruby-core:47130]

Sat Nov 23 19:20:00 2013  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (BigDecimal_div2): The signature was
	  changed to allow us to pass arguments directly.

	* ext/bigdecimal/bigdecimal.c (BigDecimal_div3): Added for the role of
	  the old BigDecimal_div2.

Sat Nov 23 12:31:00 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c: fix global variable name.
	  Now we have following environments (and related variable names).

	  * RUBY_GC_HEAP_INIT_SLOTS
	  * RUBY_GC_HEAP_FREE_SLOTS
	  * RUBY_GC_HEAP_GROWTH_FACTOR (new from 2.1)
	  * RUBY_GC_HEAP_GROWTH_MAX_SLOTS (new from 2.1)

	  * obsolete
	    * RUBY_FREE_MIN       -> RUBY_GC_HEAP_FREE_SLOTS (from 2.1)
	    * RUBY_HEAP_MIN_SLOTS -> RUBY_GC_HEAP_INIT_SLOTS (from 2.1)

	  * RUBY_GC_MALLOC_LIMIT
	  * RUBY_GC_MALLOC_LIMIT_MAX (new from 2.1)
	  * RUBY_GC_MALLOC_LIMIT_GROWTH_FACTOR (new from 2.1)

	  * RUBY_GC_OLDSPACE_LIMIT (new from 2.1)
	  * RUBY_GC_OLDSPACE_LIMIT_MAX (new from 2.1)
	  * RUBY_GC_OLDSPACE_LIMIT_GROWTH_FACTOR (new from 2.1)

	* test/ruby/test_gc.rb: catch up this change.

Sat Nov 23 09:45:49 2013  Aman Gupta <ruby@tmm1.net>

	* marshal.c (w_object): Use HASH_PROC_DEFAULT directly from internal.h

Sat Nov 23 08:43:23 2013  Aman Gupta <ruby@tmm1.net>

	* gc.c: Rename heap_pages_swept_num to heap_pages_swept_slots to
	  clarify meaning (number of slots, not pages).

Sat Nov 23 08:23:23 2013  Aman Gupta <ruby@tmm1.net>

	* lib/set.rb (class SortedSet): Fix source_location for methods
	  defined via eval.

Sat Nov 23 03:44:03 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems:  Update to RubyGems master dcce4ff.  Important changes
	  in this commit:

	  Remove automatic detection of gem dependencies files.  This prevents a
	  security hole as described in [ruby-core:58490]

	  Fixed bugs for installing git gems.

	* test/rubygems:  ditto.

Fri Nov 22 22:30:00 2013  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (BigDecimal_power):
	  Round the result value only if the precision is given.

Fri Nov 22 17:20:50 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* transcode.c (str_transcode0): don't scrub invalid chars if
	  str.encode doesn't have explicit invalid: :replace.
	  workaround fix for see #8995

Fri Nov 22 17:11:26 2013  Narihiro Nakamura  <authornari@gmail.com>

	* include/ruby/intern.h, internal.h: Expose rb_gc_count().

Fri Nov 22 17:07:00 2013  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.gemspec: version 1.2.2.

Fri Nov 22 17:04:00 2013  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (BigDecimal_data_type):
	  Use RUBY_TYPED_FREE_IMMEDIATELY only if it is available.

Fri Nov 22 16:49:00 2013  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (BigDecimal_power): Round the result value.
	  [Bug #8818] [ruby-core:56802]

	* test/bigdecimal/test_bigdecimal.rb: Add a test for the above fix.

Fri Nov 22 16:25:43 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (heap_set_increment): accept minimum additional page number.

	* gc.c (gc_after_sweep): allocate pages to allocate at least
	   RUBY_HEAP_MIN_SLOTS.
	   [Bug #9137]

Fri Nov 22 16:19:52 2013  Narihiro Nakamura  <authornari@gmail.com>

	* include/ruby/intern.h (rb_gc_set_params): Deprecate
	  rb_gc_set_params because it's only used in ruby internal.

	* internal.h (ruby_gc_set_params): Declare rb_gc_set_params's
	  alias function.

	* gc.c: ditto.

	* ruby.c: use ruby_gc_set_params.

Fri Nov 22 14:55:00 2013  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (BigMath_s_exp): Insert rb_thread_check_ints.

Fri Nov 22 14:35:00 2013  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (BigMath_s_exp): Fix the inserting points
	  of RB_GC_GUARDs.

Fri Nov 22 14:31:00 2013  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c: Fix indentation.

Fri Nov 22 14:03:00 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/nkf: merge nkf 2.1.3 2a2f2c5.

Fri Nov 22 12:43:52 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* util.c (ruby_strtod): ignore too long fraction part, which does not
	  affect the result.

Fri Nov 22 12:17:14 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/openssl/lib/openssl/buffering.rb (OpenSSL::Buffering#initialize):
	  initialize of a module should pass arguments to super.

Fri Nov 22 12:02:58 2013  Tanaka Akira  <akr@fsij.org>

	* test/ruby/test_settracefunc.rb: Ignore events from other threads.

Fri Nov 22 10:35:57 2013  Koichi Sasada  <ko1@atdot.net>

	* vm.c (ruby_vm_destruct): do not use ruby_xfree() after freeing
	  objspace.

	* gc.c (ruby_mimfree): added. It is similar to ruby_mimmalloc().

	* internal.h: ditto.

Fri Nov 22 09:42:35 2013  Zachary Scott  <e@zzak.io>

	* test/digest/test_digest.rb: Reverse order of assert_equal
	  Reported by @splattael

Fri Nov 22 09:03:16 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* gc.c: fix build failure on FreeBSD introduced by r43763.
	  malloc_usable_size() is defined by malloc_np.h on FreeBSD.

	* configure.in: check malloc.h and malloc_np.h.

Fri Nov 22 08:27:13 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems:  Update to RubyGems master 50a8210.  Important changes
	  in this commit:

	  RubyGems now automatically checks for gem.deps.rb or Gemfile when
	  running ruby executables.  This behavior is similar to `bundle exec
	  rake`.  This change may be reverted before Ruby 2.1.0 if too many bugs
	  are found.

	* test/rubygems:  ditto.

Thu Nov 21 22:33:59 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c: RGENGC_CHECK_MODE should be 0.

Thu Nov 21 21:40:00 2013  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (VpAlloc): Fix the expr to adjust the size
	  of the digit array.

Thu Nov 21 21:36:00 2013  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (BigDecimal_sqrt): Fix the precision of
	  the result BigDecimal of sqrt.
	  [Bug #5266] [ruby-dev:44450]

	* test/bigdecimal/test_bigdecimal.rb: add tests for the above changes.

Thu Nov 21 18:49:02 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* gc.c (vm_xrealloc, vm_xfree): use malloc_usable_size() to obtain old
	  size if available.

Thu Nov 21 18:47:29 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/delegate.rb (SimpleDelegator#__getobj__): target object must be set.

	* lib/delegate.rb (DelegateClass#__getobj__): ditto.

Thu Nov 21 18:28:42 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/tempfile.rb (Tempfile#initialize): use class method to get rid
	  of warnings when $VERBOSE.

Thu Nov 21 17:43:29 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c: rename initial_xxx variables to gc_params.xxx.
	  They are not only used initial values.

	  Chikanaga-san: Congratulations on RubyPrize!

Thu Nov 21 17:16:00 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c: enable "RGENGC_ESTIMATE_OLDSPACE" option as default.
	  Without this option, some application consumes huge memory.
	  (and there are only a few performance down)

	  Introduced new environment variables:
	  * RUBY_GC_HEAP_OLDSPACE (default 16MB)
	  * RUBY_GC_HEAP_OLDSPACE_MAX (default 128 MB)
	  * RUBY_GC_HEAP_OLDSPACE_GROWTH_FACTOR (default 1.2)

	* gc.c (initial_malloc_limit): rename to initial_malloc_limit_min.

Thu Nov 21 16:51:34 2013  Zachary Scott  <e@zzak.io>

	* ext/digest/bubblebabble/bubblebabble.c: Teach RDoc digest/bubblebabble

Thu Nov 21 16:50:16 2013  Zachary Scott  <e@zzak.io>

	* test/digest/test_digest.rb: Add more tests for digest/bubblebabble

Thu Nov 21 16:32:47 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/delegate.rb (Delegator#method_missing): try private methods defined in
	  Kernel after the target.  [Fixes GH-449]

Thu Nov 21 16:25:08 2013  Akinori MUSHA  <knu@iDaemons.org>

	* test/uri/test_generic.rb (URI#test_merge): Test uri + URI(path)
	  in addition to uri + path.

Thu Nov 21 15:36:08 2013  Zachary Scott  <e@zzak.io>

	* ext/openssl/lib/openssl/buffering.rb: [DOC] Fix HEREDOC comment for
	  OpenSSL::Buffering which breaks overview because of RDoc bug

Thu Nov 21 14:46:57 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* eval_intern.h (SAVE_ROOT_JMPBUF): workaround for the failure of
	  test/ruby/test_exception.rb on Windows.
	  wrap by __try and __exception statements on mswin to raise SIGSEGV
	  when EXCEPTION_STACK_OVERFLOW is occurred, because MSVCRT doesn't
	  handle the exception.
	  however, (1) mingw-gcc doesn't support __try and __exception
	  statements, and (2) we cannot retry SystemStackError after this
	  change yet (maybe crashed) because SEH and longjmp() are too
	  uncongenial.

	* signal.c (check_stack_overflow, CHECK_STACK_OVERFLOW): now defined on
	  Windows, too.

	* thread_win32.c (ruby_stack_overflowed_p): ditto.

Thu Nov 21 14:18:24 2013  Zachary Scott  <e@zzak.io>

	* object.c: [DOC] Clarify Object#dup vs #clone [Bug #9128]
	  Moving existing doc for this comparison to separate section of #dup
	  Adding examples to document behavior of #dup with Module#extend.
	  Based on a patch by stevegoobermanhill

Thu Nov 21 14:06:02 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (gc_marks_check): do not dump all refs.

	* gc.c (allrefs_dump_i): fix output format.

Thu Nov 21 13:43:07 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c: change RGENGC_CHECK_MODE (>= 2) logic.
	  Basically, make an object graph of all of living objects before and
	  after marking and check status.

	  [Before marking: check WB sanity]
	  If there is a non-old object `obj' pointed from old object
	  (`parent') then `parent' or `obj' should be remembered.

	  [After marking: check marking miss]
	  Traversible objects with the object graph should be marked.
	  (However, this alert about objects pointed by machine context
	   can be false positive. We only display alert.)

	  [Implementation memo]
	  objspace_allrefs() creates an object graph.
	  The object graph is represented by st_table, key is object (VALUE)
	  and value is referring objects. Referring objects are stored by
	  "struct reflist".

	* gc.c (init_mark_stack): do not use push_mark_stack_chunk() at init.
	  This pre-allocation causes failure on is_mark_stack_empty()
	  without any pushing.

Thu Nov 21 13:40:20 2013  Zachary Scott  <e@zzak.io>

	* lib/observer.rb: [DOC] Clarify default observer method.
	  By @edward [Fixes GH-450] https://github.com/ruby/ruby/pull/450

Thu Nov 21 13:32:53 2013  Zachary Scott  <e@zzak.io>

	* ext/openssl/ossl_engine.c: [DOC] Documentation for OpenSSL::Engine
	  This patch is based off work by @vbatts in GH-436 completing the
	  documentation for this class and its methods.
	  https://github.com/ruby/ruby/pull/436

Thu Nov 21 10:45:22 2013  Zachary Scott  <e@zzak.io>

	* ext/openssl/lib/openssl/buffering.rb: Remove unused arguments from
	  OpenSSL::Buffering.new [Fixes GH-445]

Thu Nov 21 10:30:47 2013  Zachary Scott  <e@zzak.io>

	* test/digest/test_digest.rb: Add test for Digest::SHA256.bubblebabble

Wed Nov 20 20:54:01 2013  Masaya Tarui  <tarui@ruby-lang.org>

	* tool/instruction.rb : fix typo.

Wed Nov 20 19:45:22 2013  Tanaka Akira  <akr@fsij.org>

	* random.c (rand_init): Make it possible to specify arbitrary array
	  for init_genrand().

Wed Nov 20 17:34:13 2013  Koichi Sasada  <ko1@atdot.net>

	* parse.y (rb_gc_mark_symbols): set global_symbols.minor_marked only
	  when full_mark is 0.
	  rb_gc_mark_symbols() (with full_mark == 1) can be called by other
	  than GC (such as rb_objspace_reachable_objects_from_root()).

Wed Nov 20 11:46:38 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/json: merge JSON 1.8.1.
	  https://github.com/nurse/json/compare/002ac2771ce32776b32ccd2d06e5604de6c36dcd...e09ffc0d7da25d0393873936c118c188c78dbac3
	* Remove Rubinius exception since transcoding should be working now.
	* Fix https://github.com/flori/json/issues/162 reported by Marc-Andre
	  Lafortune <github_rocks@marc-andre.ca>. Thanks!
	* Applied patches by Yui NARUSE <naruse@airemix.jp> to suppress
	  warning with -Wchar-subscripts and better validate UTF-8 strings.
	* Applied patch by ginriki@github to remove unnecessary if.
	* Add load/dump interface to JSON::GenericObject to make
	  serialize :some_attribute, JSON::GenericObject
	  work in Rails active models for convenient
	  SomeModel#some_attribute.foo.bar access to serialised JSON data.

Wed Nov 20 01:39:02 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/rdoc/constant.rb (RDoc::Constant#documented?): workaround for
	  NoMethodError when the original of alias is not found.

Tue Nov 19 23:38:49 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (--with-os-version-style): option to transform target
	  OS version string.

Tue Nov 19 21:27:33 2013  Tanaka Akira  <akr@fsij.org>

	* test/net/http/utils.rb (spawn_server): Specify zero for port to
	  avoid reusing an allocated port.

	* test/net/http/test_http.rb: Don't specify port here.

	* test/net/http/test_https.rb: Ditto.

Tue Nov 19 18:52:10 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (heap_is_swept_object): use heap_page::before_sweep flag.

Tue Nov 19 18:49:32 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (rb_objspace_reachable_objects_from_root): do major marking.

Tue Nov 19 18:45:40 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (rb_gc_resurrect): added.
	  rb_fstring() used rb_gc_mark() to avoid freeing used string.
	  However, rb_gc_mark() set mark bit *and* pushes mark_stack.
	  rb_gc_resurrect() does only set mark bit if it is before sweeping.

	* string.c (rb_fstring): use rb_gc_resurrect.

	* internal.h: add decl.

Tue Nov 19 09:47:02 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rdoc:  Update to RDoc master a1195ce.  Changes include:

	  Improved accessibility of the main sidebar navigation.

	  Fixed handling of regexp options in HTML source highlighting.

	* test/rdoc:  ditto.

Tue Nov 19 09:33:52 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems:  Update to RubyGems master 6a3d9f9.  Changes include:

	  Compatibly renamed Gem::DependencyResolver to Gem::Resolver.

	  Added support for git gems in gem.deps.rb and Gemfile.

	  Fixed resolver bugs.

	* test/rubygems: ditto.

	* lib/rubygems/LICENSE.txt:  Updated to license from RubyGems trunk.
	  [ruby-trunk - Bug #9086]

	* lib/rubygems/commands/which_command.rb:  RubyGems now indicates
	  failure when any file is missing.  [ruby-trunk - Bug #9004]

	* lib/rubygems/ext/builder:  Extensions are now installed into the
	  extension install directory and the first directory in the require
	  path from the gem.  This allows backwards compatibility with msgpack
	  and other gems that calculate full require paths.
	  [ruby-trunk - Bug #9106]


Tue Nov 19 07:21:56 2013  Tanaka Akira  <akr@fsij.org>

	* configure.in (LOCALTIME_OVERFLOW_PROBLEM): Define it for cross
	  compiling.
	  [ruby-core:58391] [Bug #9119] Reported by Luis Lavena.
	  Analyzed by Heesob Park.

Tue Nov 19 05:55:05 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rdoc/rubygems_hook.rb:  Remove debugging puts committed by
	  accident.

Mon Nov 18 22:47:54 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval_intern.h (TH_PUSH_TAG, TH_EXEC_TAG): refine stack overflow
	  detection.  chain local tag after setjmp() successed on it, because
	  calling setjmp() also can overflow the stack.
	  [ruby-dev:47804] [Bug #9109]

	* vm_eval.c (rb_catch_obj): now th->tag points previous tag until
	  TH_EXEC_TAG().

	* thread_pthread.c (ruby_init_stack): set stack_start properly by
	  get_main_stack() if possible.

Mon Nov 18 22:45:49 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval_jump.c (rb_exec_end_proc): unlink and free procs data before
	  calling for each procs.  [Bug #9110]

Sun Nov 17 06:33:32 2013  Shota Fukumori  <her@sorah.jp>

	* configure.in: Use $LIBS for base of $SOLIBS, also in darwin.
	  By this fix, environment that libgmp is located in $LIBS can build
	  ruby.

Sun Nov 17 01:56:32 2013  Tanaka Akira  <akr@fsij.org>

	* thread_pthread.c (rb_thread_create_timer_thread): Show error
	  message instead of error number.
	  (thread_create_core): Ditto.

	* cont.c (fiber_machine_stack_alloc): Ditto.

Sat Nov 16 18:28:08 2013  Kouhei Sutou  <kou@cozmixng.org>

	* lib/rexml/parsers/ultralightparser.rb
	  (REXML::Parsers::UltraLightParser#parse): Fix wrong :start_doctype
	  position.
	  [Bug #9061] [ruby-dev:47778]
	  Patch by Ippei Obayashi. Thanks!!!

	* test/rexml/parser/test_ultra_light.rb: Add a test for this case.

Sat Nov 16 02:13:56 2013  Masaya Tarui  <tarui@ruby-lang.org>

	* cont.c : Introduce ensure rollback mechanism. Please see below.

	* internal.h (ruby_register_rollback_func_for_ensure): catch up above change.
	  Add rollback mechanism API.

	* vm_core.h (typedef struct rb_vm_struct): catch up above change.
	  Introduce ensure-rollback relation table.

	* vm_core.h (typedef struct rb_thread_struct): catch up above change.
	  Introduce ensure stack.

	* eval.c (rb_ensure): catch up above change.
	  Introduce ensure stack.

	* hash.c : New function for rollback ensure, and register it to
	  ensure-rollback relation table. [ruby-dev:47803] [Bug #9105]

	Ensure Rollback Mechanism:
	A rollback's function is a function to rollback a state before ensure's
	function execution.
	When the jump of callcc is across the scope of rb_ensure,
	ensure's functions and rollback's functions are executed appropriately
	for keeping consistency.

	Current API is unstable, and only internal use.

	ruby_register_rollback_func_for_ensure(ensure_func,rollback_func)
	This API create relation ensure's function to rollback's function.
	By registered rollback's function, it is executed When jumping into
	corresponding rb_ensure scope.

Sat Nov 16 00:18:36 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* eval_jump.c (rb_exec_end_proc): fix double free or corruption error
	  when reentering by callcc. [ruby-core:58329] [Bug #9110]

	* test/ruby/test_beginendblock.rb: test for above.

Fri Nov 15 01:06:04 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/objspace/objspace_dump.c (dump_output): allow IO object as
	  output, and use Tempfile.create and return open file instead of
	  mkstemp() and path name for :file output.
	  [ruby-core:58266] [Bug #9102]

	* test/objspace/test_objspace.rb (TestObjSpace#dump_my_heap_please):
	  remove temporary output file.

Thu Nov 14 23:39:00 2013  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* ext/bigdecimal/lib/bigdecimal/util.rb: [DOC] remove example of
	  Rational#to_d without argument. [Bug #8958]

Thu Nov 14 20:24:15 2013  Naohisa Goto  <ngotogenome@gmail.com>

	* ruby_atomic.h (ATOMIC_SIZE_CAS): fix compile error on Solaris
	  since r43460.

Thu Nov 14 19:53:00 2013  Tanaka Akira  <akr@fsij.org>

	* test/openssl/test_cipher.rb (test_aes_gcm_wrong_tag): Don't use
	  String#succ because it can make modified (wrong) auth_tag longer
	  than 16 bytes.  The longer auth_tag makes that
	  EVP_CIPHER_CTX_ctrl (and internally aes_gcm_ctrl) fail.
	  [ruby-core:55143] [Bug #8439] reported by Vit Ondruch.

Thu Nov 14 11:33:47 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* hash.c (foreach_safe_i, hash_foreach_iter): deal with error detected
	  by ST_CHECK.

	* st.c (st_foreach_check): call with non-error argument in normal case.

Thu Nov 14 02:37:14 2013  Zachary Scott  <e@zzak.io>

	* ext/thread/thread.c: [DOC] This patch accomplishes the following:

	  - Teach RDoc about ConditionVariable
	  - Teach RDoc about Queue
	  - Teach RDoc about SizedQueue
	  - Use fully-qualified namespace for Document-method
	    This is necessary to separate definitions between classes
	  - Fix rdoc bug in call_seq vs. call-seq
	  - Correct doc for SizedQueue#pop patch by @jackdanger [Bug #8988]

Thu Nov 14 01:11:54 2013  Zachary Scott  <e@zzak.io>

	* ext/bigdecimal/lib/bigdecimal/util.rb: [DOC] +precision+ is required

Wed Nov 13 19:21:36 2013  Zachary Scott  <e@zzak.io>

	* ext/bigdecimal/lib/bigdecimal/util.rb: [DOC] Document the required
	  +precision+ argument for Rational#to_d [Bug #8958]

Wed Nov 13 19:02:05 2013  Zachary Scott  <e@zzak.io>

	* ext/digest/*: [DOC] Fix several typos and broken http links.
	  Improved examples for Digest overview and fixed a broken example in
	  Digest::HMAC overview. This patch also adds a description of
	  Digest::SHA256.bubblebabble to the Digest overview.

	  Patched by @stomar [Bug #9027]

Wed Nov 13 18:32:12 2013  Zachary Scott  <e@zzak.io>

	* ext/openssl/ossl_config.c: [DOC] Document the following:

	  - OpenSSL::ConfigError
	  - OpenSSL::Config::DEFAULT_CONFIG_FILE

	  Patched by @vbatts via GH-436
	  https://github.com/ruby/ruby/pull/436

Wed Nov 13 18:03:00 2013  Zachary Scott  <e@zzak.io>

	* ext/openssl/ossl_asn1.c: [DOC] Document parts of
	  OpenSSL::ASN1::ObjectId included a fix for the class overview, which
	  previously showed the documentation for Constructive due to missing
	  ObjectId overview. This patch also includes a note for Primitive.

	  Based on a patch by @vbatts via GH-436
	  https://github.com/ruby/ruby/pull/436

Wed Nov 13 17:19:36 2013  Zachary Scott  <e@zzak.io>

	* ext/openssl/lib/openssl/config.rb: In #parse use +string+ for +str+

Wed Nov 13 17:09:45 2013  Zachary Scott  <e@zzak.io>

	* ext/openssl/lib/openssl/*.rb: [DOC] Document the following:

	  - Integer#to_bn
	  - OpenSSL::Buffering module
	  - Deprecated OpenSSL::Digest::Digest compatibility class
	  - OpenSSL::Config

	  These changes were based on a patch by @vbatts via GH-436
	  https://github.com/ruby/ruby/pull/436

Wed Nov 13 10:55:43 2013  Zachary Scott  <e@zzak.io>

	* doc/regexp.rdoc: [DOC] Fix typo in Special global variables section.
	  Reported by Alex Johnson on ruby-doc.org

Wed Nov 13 10:43:19 2013  Zachary Scott  <e@zzak.io>

	* hash.c: [DOC] Adds an example for Hash#store

Wed Nov 13 09:03:40 2013  Zachary Scott  <e@zzak.io>

	* doc/regexp.rdoc: [DOC] add note about Bug #4044 as suggested by
	  duerst-san in [ruby-core:43612] [Fixes GH-443] Patched by @rosenfeld
	  https://github.com/ruby/ruby/pull/443

Tue Nov 12 10:15:14 2013  Eric Hodel  <drbrain@segment7.net>

	* test/rubygems/insure_session.rb:  Remove unused test file.

Tue Nov 12 09:16:24 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems:  Update to RubyGems master b9213d7.  Changes include:

	  Fixed tests on Windows (I hope) by forcing platform for
	  platform-dependent tests.

	  Fixed File.exists? warnings.

	  Improved testing infrastructure.

	* test/rubygems:  ditto.

	* test/rdoc/test_rdoc_rubygems_hook.rb:  Switch to util_spec like
	  RubyGems.

Mon Nov 11 18:31:12 2013  Aman Gupta <ruby@tmm1.net>

	* internal.h: move common string/hash flags to include file.
	* ext/objspace/objspace_dump.c: remove flags shared above.
	* hash.c: ditto.
	* string.c: ditto.

Mon Nov 11 04:36:14 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems/specification.rb:  Include 2.2.0.preview.2 when checking
	  if extensions should be built.  Fixes a ruby-ci failure.
	* test/rubygems/test_gem_specification.rb:  Test for the above.

Mon Nov 11 03:15:56 2013  Koichi Sasada  <ko1@atdot.net>

	* vm_trace.c (symbol2event_flag): add secret feature.
	  add a_call/a_return events.
	  a_call is call | b_call | c_call, and same as a_return.

Mon Nov 11 02:51:17 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems: Update to RubyGems master 4bdc4f2.  Important changes
	  in this commit:

	  RubyGems now chooses the test server port reliably.  Patch by akr.

	  Partial implementation of bundler's Gemfile format.

	  Refactorings to improve the new resolver.

	  Fixes bugs in the resolver.

	* test/rubygems:  Tests for the above.

Mon Nov 11 01:02:06 2013  Zachary Scott  <e@zzak.io>

	* lib/timeout.rb: [DOC] Add note about change from #8730 [Fixes GH-440]
	* NEWS: [DOC] Improve grammar on change to Timeout
	  Patched by @srawlins in https://github.com/ruby/ruby/pull/440

Sun Nov 10 23:47:05 2013  Kazuki Tsujimoto  <kazuki@callcc.net>

	* gc.c (rb_gcdebug_print_obj_condition): catch up recent changes
	  to compile on GC_DEBUG.

Sun Nov 10 22:16:19 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* error.c (exc_cause): captured previous exception.

	* eval.c (make_exception): capture previous exception automagically.
	  [Feature #8257]

Sun Nov 10 08:37:20 2013  Zachary Scott  <e@zzak.io>

	* thread.c: [DOC] Remove duplicate reference

Sun Nov 10 08:09:29 2013  Zachary Scott  <e@zzak.io>

	* lib/drb/drb.rb: [DOC] promote better windows-safe filename regular
	  expression in DRb Logger example. Reported by Chris Pheonix
	  [Bug #9074]

Sun Nov 10 08:03:05 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* gc.c (rb_define_finalizer, rb_undefine_finalizer): rename and export
	  finalizer functions.

Sun Nov 10 07:41:22 2013  Zachary Scott  <e@zzak.io>

	* lib/weakref.rb: [DOC] fix typos by @xaviershay [Fixes GH-439]
	  https://github.com/ruby/ruby/pull/439

Sun Nov 10 06:14:39 2013  Charlie Somerville  <charliesome@ruby-lang.org>

	* compile.c (iseq_compile_each): emit opt_str_freeze if the #freeze
	  method is called on a static string literal with no arguments.

	* defs/id.def (firstline): add freeze so idFreeze is available

	* insns.def (opt_str_freeze): add opt_str_freeze instruction which
	  pushes a frozen string literal without allocating a new object if
	  String#freeze is not overridden

	* string.c (Init_String): define String#freeze

	* vm.c (vm_init_redefined_flag): define BOP_FREEZE on String class as
	  a basic operation

	* vm_insnhelper.h: ditto

	[Feature #8992] [ruby-core:57705]

Sun Nov 10 01:34:14 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (vm_malloc_increase): sweep immediately on GC due to malloc().
	  To reduce memory usage, sweep as soon as possible.
	  This behavior is same as Ruby 2.0.0 and before.

Sun Nov 10 00:39:26 2013  Koichi Sasada  <ko1@atdot.net>

	* benchmark/gc/gcbench.rb: output version description and GC::OPTS.

Sun Nov 10 00:36:42 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* gc.c (should_be_callable): allow private call since rb_eval_cmd
	  calls even private methods.

Sun Nov 10 00:33:17 2013  Zachary Scott  <e@zzak.io>

	* lib/racc/rdoc/grammar.en.rdoc: [DOC] fix typo by Tsuyoshi Sawada
	  [Bug #9077]

Sat Nov  9 22:35:35 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* tool/rbinstall.rb (Gem::Specification.load): obtain spec date from
	  VCS for the case using git, RUBY_RELEASE_DATE is the last resort.
	  probably fixes [Bug #9085].

Sat Nov  9 20:56:12 2013  Narihiro Nakamura  <authornari@gmail.com>

	* ext/objspace/object_tracing.c: use declarations in internal.h.

	* ext/objspace/objspace.c: ditto

Sat Nov  9 20:32:59 2013  Tanaka Akira  <akr@fsij.org>

	* test/objspace/test_objspace.rb (test_dump_all): Make the test string
	  shorter to be an embedded string on 32bit environment as well as
	  64bit environment.

Sat Nov  9 15:00:16 2013  Zachary Scott  <e@zzak.io>

	* io.c: [DOC] ARGF.gets may return nil [Bug #9029] patch by znz

Sat Nov  9 14:54:52 2013  Zachary Scott  <e@zzak.io>

	* lib/rss/*: [DOC] document various constants @steveklabnik [Bug #8812]

Sat Nov  9 14:50:09 2013  Zachary Scott  <e@zzak.io>

	* lib/rss/rss.rb: [DOC] document Time#w3cdtf by @steveklabnik
	  [Bug #8821]

Sat Nov  9 14:29:04 2013  Zachary Scott  <e@zzak.io>

	* ext/dl/cfunc.c: [DOC] fix typo in example [Bug #8944]
	  Patched by Heesob Park

Sat Nov  9 13:59:58 2013  Zachary Scott  <e@zzak.io>

	* lib/test/unit/assertions.rb: [DOC] better example for assert_send()
	  Patch by Andrew Grimm [Bug #8975]

Sat Nov  9 12:45:00 2013  Charlie Somerville  <charliesome@ruby-lang.org>

	* insns.def: unify ic_constant_serial and ic_class_serial into one field
	  ic_serial. This is possible because these fields are only ever used
	  exclusively with each other.

	* insns.def: ditto
	* vm_core.h: ditto
	* vm_insnhelper.c: ditto

Sat Nov  9 12:31:00 2013  Charlie Somerville  <charliesome@ruby-lang.org>

	* class.c: unify names of vm state version counters to 'serial'.
	  This includes renaming 'vm_state_version_t' to 'rb_serial_t',
	  'method_state' to 'method_serial', 'seq' to 'class_serial',
	  'vmstat' to 'constant_serial', etc.

	* insns.def: ditto
	* internal.h: ditto
	* vm.c: ditto
	* vm_core.h: ditto
	* vm_insnhelper.c: ditto
	* vm_insnhelper.h: ditto
	* vm_method.c: ditto

Sat Nov  9 09:22:29 2013  Masaya Tarui  <tarui@ruby-lang.org>

	* gc.c (gc_page_sweep, rgengc_rememberset_mark): Refactoring.
	  Get bitmaps directly.

Sat Nov  9 09:16:36 2013  Masaya Tarui  <tarui@ruby-lang.org>

	* gc.c (RVALUE_PROMOTE_INFANT): Refactoring. Remove duplicated nonsense
	  code.

Sat Nov  9 09:04:48 2013  Masaya Tarui  <tarui@ruby-lang.org>

	* gc.c (gc_marks_test): Bugfix. Fix a struct member name for build
	  with RGENGC_CHECK_MODE.

Sat Nov  9 08:58:23 2013  Masaya Tarui  <tarui@ruby-lang.org>

	* gc.c : Add GC_PROFILE_DETAIL_MEMORY option.
	  If GC_PROFILE_MORE_DETAIL && GC_PROFILE_DETAIL_MEMORY,
	  maxrss, minflt and majflt are added to each profile record.

Sat Nov  9 07:41:41 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* internal.h (rb_vm_backtrace_object, rb_gc_count): make prototype
	  declarations, not old-K&R style.

Sat Nov  9 06:11:14 2013  vo.x (Vit Ondruch)  <vondruch@redhat.com>

	* tool/rbinstall.rb (Gem::Specification#collect): make stable
	  Gem::Specification.files in default .gemspecs the different order of
	  "files" in .gemspec files makes them different therefore possibly
	  conflicting in multilib scenario.  patch by vo.x (Vit Ondruch) at
	  [ruby-core:57544] [Bug #8623].

Sat Nov  9 01:59:18 2013  Aman Gupta <ruby@tmm1.net>

	* ext/objspace/objspace_dump.c: Add experimental methods to
	  dump objectspace as json: ObjectSpace.dump_all and
	  ObjectSpace.dump(obj). These methods are useful for debugging
	  reference leaks and memory growth in large ruby applications.
	  [Bug #9026] [ruby-core:57893] [Fixes GH-423]
	* test/objspace/test_objspace.rb: tests for above.

Sat Nov  9 00:26:50 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (GetLastError): already defined in windows.h on nowadays
	  cygwin, and caused the confliction with the system provided
	  definition on cygwin64.  by @kou1okada [Fixes GH-433].

Fri Nov  8 18:35:31 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* lib/open3.rb: receive arguments as keyword arguments.

Fri Nov  8 13:19:26 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* io.c (rb_io_open_with_args): use RARRAY_CONST_PTR().

	* io.c (rb_scan_open_args): use const qualifier for above.

	* io.c (rb_open_file): ditto.

	* io.c (rb_io_open_with_args): ditto.

Fri Nov  8 11:35:06 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* dir.c, pack.c, ruby.c, struct.c, vm_eval.c: use RARRAY_CONST_PTR().

Fri Nov  8 10:58:02 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* compile.c (iseq_build_from_ary_exception): use RARRAY_CONST_PTR().

	* compile.c (iseq_build_from_ary_body): ditto.

Fri Nov  8 10:49:34 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* enumerator.c (append_method): use RARRAY_CONST_PTR().

	* enumerator.c (lazy_init_iterator): ditto.

Fri Nov  8 02:44:29 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (vm_malloc_increase): check GVL before gc_rest_sweep().
	  vm_malloc_increase() can be called without GVL.
	  However, gc_rest_sweep() assumes acquiring GVL.
	  To avoid this problem, check GVL before gc_rest_sweep().
	  [Bug #9090]

	  This workaround introduces possibility to set malloc_limit as
	  wrong value (*1). However, this may be rare case. So I commit it.

	  *1: Without rest_sweep() here, gc_rest_sweep() can decrease
	      malloc_increase due to ruby_sized_xfree().

Fri Nov  8 02:50:25 2013  Zachary Scott  <e@zzak.io>

	* lib/securerandom.rb: [DOC] specify arguments passed to ::random_bytes
	  By @chastell [Fixes GH-412] https://github.com/ruby/ruby/pull/412

Fri Nov  8 02:43:01 2013  Zachary Scott  <e@zzak.io>

	* ext/objspace/object_tracing.c: [DOC] trace_object_allocations_stop
	  By @srawlins [Fixes GH-421] https://github.com/ruby/ruby/pull/421

Fri Nov  8 02:34:20 2013  Zachary Scott  <e@zzak.io>

	* lib/net/ftp.rb: [DOC] Document Net::FTP.mdtm and .set_socket and fix
	  spelling typo, based on patch by @artfuldodger [Fixes GH-426]
	  https://github.com/ruby/ruby/pull/426

Fri Nov  8 02:14:37 2013  Zachary Scott  <e@zzak.io>

	* array.c: [DOC] Add note about negative indices in Array overview
	  By @ckaenzig [Fixes GH-427] https://github.com/ruby/ruby/pull/427

Fri Nov  8 02:09:12 2013  Zachary Scott  <e@zzak.io>

	* lib/csv.rb: [DOC] Fix typo in CSV.parse_line by @funky-bibimbap
	  [Fixes GH-430] https://github.com/ruby/ruby/pull/430

Fri Nov  8 01:01:54 2013  Zachary Scott  <e@zzak.io>

	* golf_prelude.rb: syntax formatting for whitespace [Fixes GH-425]
	  Patch by @edward https://github.com/ruby/ruby/pull/425

Thu Nov  7 19:36:09 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c: modify malloc_limit strategy.

	  * fix default values:
	    GC_MALLOC_LIMIT_GROWTH_FACTOR
	    GC_MALLOC_LIMIT: 8MB -> 16MB
	    GC_MALLOC_LIMIT_MAX: 384MB -> 32MB

	  * algorithm of malloc_limit increment.
	    if (malloc_increase < malloc_limit) {
	      next_malloc_limit = malloc_limit * factor
	      if (malloc_limit > malloc_limit_max) {
	        malloc_limit = malloc_increase
	      }
	    }
	    This algorithm change malloc_limit from
	    16MB -> 32MB slowly.
	    If malloc_limit exceeds malloc_limit_max, then
	    increase with malloc_increase.

Thu Nov  7 11:06:05 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* array.c (rb_ary_shuffle_bang): use RARRAY_PTR_USE() without WB
	  because there are not new relations.

Thu Nov  7 10:34:12 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* array.c (rb_ary_sample): use rb_ary_dup().

Thu Nov  7 09:39:41 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_trace.c (rb_threadptr_exec_event_hooks_orig): errinfo should not
	  be propagated to trace blocks so that no argument raise does not
	  throw internal objects.  [ruby-dev:47793] [Bug #9088]

Wed Nov  6 21:30:55 2013  Masaya Tarui  <tarui@ruby-lang.org>

	* gc.c (gc_before_sweep): Change algorithm of malloc_limit to
	  conservative for closing to memory consumption of ruby 2.0.

	* gc.c (GC_MALLOC_LIMIT, GC_MALLOC_LIMIT_GROWTH_FACTOR):
	  Adjust parameters for new algorithm.

Wed Nov  6 21:16:51 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* array.c (rb_ary_shift_m): use RARRAY_PTR_USE() without WB because
	  there are not new relations.

Wed Nov  6 21:05:20 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* array.c (rb_ary_reverse): use RARRAY_PTR_USE().

Wed Nov  6 19:30:44 2013  Masaya Tarui  <tarui@ruby-lang.org>

	* common.mk (help): add texts about gcbench.

Wed Nov  6 16:32:32 2013  Martin Duerst <duerst@it.aoyama.ac.jp>

	* lib/open3.rb: tweaked grammar in comments

Wed Nov  6 11:46:36 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* array.c (rb_ary_sample): use RARRAY_AREF() and RARRAY_PTR_USE()
	  instead of RARRAY_PTR().

Wed Nov  6 10:37:07 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* array.c (rb_ary_and): defer hash creation and some refactoring.

Wed Nov  6 09:14:31 2013  Koichi Sasada  <ko1@atdot.net>

	* benchmark/bm_vm1_gc_short_lived.rb: added.
	  These GC benchmarks do not reflect practical applications.
	  They are only for tuning.

	* benchmark/bm_vm1_gc_short_with_complex_long.rb: added.

	* benchmark/bm_vm1_gc_short_with_long.rb: added.

	* benchmark/bm_vm1_gc_short_with_symbol.rb: added.

	* benchmark/bm_vm1_gc_wb_ary.rb: added.

	* benchmark/bm_vm1_gc_wb_obj.rb: added.

	* benchmark/bm_vm_thread_queue.rb: added.
	  This benchmark is added to know how fast C version of thread.so.

Wed Nov  6 09:13:32 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c: define RGENGC_ESTIMATE_OLDSPACE == 0 if USE_RGENGC is 0.

Wed Nov  6 07:13:18 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (Init_GC): add GC::OPTS to show options.

Wed Nov  6 07:12:17 2013  Koichi Sasada  <ko1@atdot.net>

	* benchmark/gc/gcbench.rb: add some options to make quiet.

Wed Nov  6 04:14:25 2013  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/visitors/to_ruby.rb: process merge keys before
	  reviving objects. Fixes GH psych #168
	* test/psych/test_merge_keys.rb: test for change
	  https://github.com/tenderlove/psych/issues/168

Tue Nov  5 21:21:47 2013  Tanaka Akira  <akr@fsij.org>

	* test/ruby/test_thread.rb (test_thread_join_in_trap):
	  Run the test in a different process.

Tue Nov  5 20:14:32 2013  Masaya Tarui  <tarui@ruby-lang.org>

	* gc.c (is_live_object): A hidden object may be a live object.
	  [ruby-dev:47788] [Bug #9072]

Tue Nov  5 13:37:19 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c: add support to estimate increase of oldspace memory usage.
	  This is another approach to solve an issue discussed at r43530.
	  This feature is disabled as default.

	  This feature measures an increment of memory consumption by oldgen
	  objects. It measures memory consumption for each objects when
	  the object is promoted. However, measurement of memory consumption
	  is not accurate now. So that this measurement is `estimation'.

	  To implement this feature, move memsize_of() function from
	  ext/objspace/objspace.c and expose rb_obj_memsize_of().

	  Some memsize() functions for T_DATA (T_TYPEDDATA) have problem to
	  measure memory size, so that we ignores T_DATA objects now.
	  For example, some functions skip NULL check for pointer.

	  The macro RGENGC_ESTIMATE_OLDSPACE enables/disables this feature,
	  and turned off as default.

	  We need to compare 3gen GC and this feature carefully.
	  (it is possible to enable both feature)
	  We need a help to compare them.

	* internal.h: expose rb_obj_memsize_of().

	* ext/objspace/objspace.c: use rb_obj_memsize_of() function.

	* cont.c (fiber_memsize): fix to check NULL.

	* variable.c (autoload_memsize): ditto.

	* vm.c (vm_memsize): ditto.

Tue Nov  5 04:03:07 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (GC_MALLOC_LIMIT_MAX): fix default value 512MB -> 384MB.
	  512MB is huge.

Tue Nov  5 03:31:23 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c: add 3gen GC patch, but disabled as default.

	  RGenGC is designed as 2 generational GC, young and old generation.
	  Young objects will be promoted to old objects after one GC.
	  Old objects are not collect until major (full) GC.

	  The issue of this approach is some objects can promoted as old
	  objects accidentally and not freed until major GC.
	  Major GC is not frequently so short-lived but accidentally becoming
	  old objects are not freed.

	  For example, the program "loop{Array.new(1_000_000)}" consumes huge
	  memories because short lived objects (an array which has 1M
	  elements) are promoted while GC and they are not freed before major
	  GC.

	  To solve this problem, generational GC with more generations
	  technique is known. This patch implements three generations gen GC.

	  At first, newly created objects are "Infant" objects.
	  After surviving one GC, "Infant" objects are promoted to "Young"
	  objects.
	  "Young" objects are promoted to "Old" objects after surviving
	  next GC.
	  "Infant" and "Young" objects are collected if it is not marked
	  while minor GC. So that this technique solves this problem.

	  Representation of generations:
	  * Infant: !FL_PROMOTED and !oldgen_bitmap [00]
	  * Young :  FL_PROMOTED and !oldgen_bitmap [10]
	  * Old   :  FL_PROMOTED and  oldgen_bitmap [11]

	  The macro "RGENGC_THREEGEN" enables/disables this feature, and
	  turned off as default because there are several problems.
	  (1) Failed sometimes (Heisenbugs).
	  (2) Performance down.
	      Especially on write barriers. We need to detect Young or Old
	      object by oldgen_bitmap. It is slower than checking flags.

	  To evaluate this feature on more applications, I commit this patch.
	  Reports are very welcome.

	  This patch includes some refactoring (renaming names, etc).

	* include/ruby/ruby.h: catch up 3gen GC.

	* .gdbinit: fix to show a prompt "[PROMOTED]" for promoted objects.

Tue Nov  5 00:05:51 2013  Koichi Sasada  <ko1@atdot.net>

	* node.h: catch up comments for last commit.

Tue Nov  5 00:02:00 2013  Koichi Sasada  <ko1@atdot.net>

	* include/ruby/ruby.h: rename FL_OLDGEN to FL_PROMOTED.
	  This flag represents that "this object is promoted at least once."

	* gc.c, debug.c, object.c: catch up this change.

Mon Nov  4 22:20:16 2013  Tanaka Akira  <akr@fsij.org>

	* test/xmlrpc: Don't use fixed ports: 8070 and 8071.

Mon Nov  4 15:25:52 2013  Tanaka Akira  <akr@fsij.org>

	* test/xmlrpc/webrick_testing.rb (start_server): Initialize the server
	  at main thread to fail early.

Mon Nov  4 10:08:17 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval_intern.h (TH_EXEC_TAG, TH_JUMP_TAG): get rid of undefined
	  behavior of setjmp() in rhs of assignment expression.
	  [ISO/IEC 9899:1999] 7.13.1.1

Sun Nov  3 23:06:51 2013  Tanaka Akira  <akr@fsij.org>

	* sample/test.rb: Make temporary file names unique.

Sun Nov  3 20:41:17 2013  Tanaka Akira  <akr@fsij.org>

	* test/xmlrpc: Wrap definitions by TestXMLRPC module.

Sun Nov  3 20:23:38 2013  Tanaka Akira  <akr@fsij.org>

	* test/xmlrpc/webrick_testing.rb (stop_server): Don't try to shutdown
	  the server if the server is not started.

Sun Nov  3 09:35:47 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* load.c (rb_feature_p): deal with default loadable suffixes.

	* load.c (load_lock): initialize statically linked extensions.

	* load.c (search_required, rb_require_safe): deal with statically
	  linked extensions.

	* load.c (ruby_init_ext): defer initialization of statically linked
	  extensions until required actually.  [Bug #8883]

Sat Nov  2 15:14:33 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/logger.rb (Logger::LogDevice::LogDeviceMutex#lock_shift_log):
	  open file can't be removed or renamed on Windows.  [ruby-dev:47790]
	  [Bug #9046]

	* test/logger/test_logger.rb (TestLogDevice#run_children): don't use
	  fork.

Sat Nov  2 07:08:43 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/logger.rb: Inter-process locking for log rotation
	  Current implementation fails log rotation on multi process env.
	  by sonots <sonots@gmail.com>
	  https://github.com/ruby/ruby/pull/428 fix GH-428 [Bug #9046]

Fri Nov  1 23:24:31 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* gc.c (wmap_mark_map): mark live objects only, but delete zombies.
	  [ruby-dev:47787] [Bug #9069]

Fri Nov  1 22:45:54 2013  Masaya Tarui  <tarui@ruby-lang.org>

	* gc.c (struct heap_page, gc_page_sweep, gc_sweep): Refactoring for
	  performance. Add before_sweep condition to heap_page structure.

	* gc.c (rb_gc_force_recycle): Use before_sweep member.

	* gc.c (heap_is_before_sweep, is_before_sweep): Remove. They have not
	  already been used.

Fri Nov  1 22:20:28 2013  Masaya Tarui  <tarui@ruby-lang.org>

	* gc.c (make_deferred): Refactoring. Collect codes which should be
	  atomic.

	* gc.c (make_io_deferred, obj_free, rb_objspace_call_finalizer,
	  gc_page_sweep): Correspond to the above.

Fri Nov  1 21:40:35 2013  Masaya Tarui  <tarui@ruby-lang.org>

	* gc.c (typedef struct rb_objspace): Refactoring. Move some members
	  into profile member.

	* gc.c (newobj_of): Correspond to the above.

	* gc.c (finalize_list): Ditto.

	* gc.c (objspace_live_num): Ditto.

	* gc.c (gc_page_sweep): Ditto.

	* gc.c (rb_gc_force_recycle): Ditto.

	* gc.c (garbage_collect_body): Ditto.

	* gc.c (rb_gc_count): Ditto.

	* gc.c (gc_stat): Ditto.

	* gc.c (gc_prof_set_heap_info): Ditto.

	* gc.c (gc_profile_dump_on): Ditto.

Fri Nov  1 20:53:56 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_scrub): fix typo, should yield invalid byte
	  sequence to be scrubbed.  reported by znz at IRC.

Fri Nov  1 17:25:30 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* gc.c (is_live_object): finalizer may not run because of lazy-sweep.
	  [ruby-dev:47786] [Bug #9069]

Fri Nov  1 16:55:52 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_scrub): export with fixed length arguments, and
	  allow nil as replacement string instead of omitting.

Fri Nov  1 06:20:44 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_mutex_struct): reduce rb_mutex_t size by 8 bytes
	  on 64bit platform. Patch by Eric Wong. [Feature #9068][ruby-core:58114]

Fri Nov  1 01:08:33 2013  Koichi Sasada  <ko1@atdot.net>

	* benchmark/gc/gcbench.rb: print HWM (high water mark) if possible.

Thu Oct 31 21:48:31 2013  Kouhei Sutou  <kou@cozmixng.org>

	* lib/rexml/parsers/streamparser.rb: Add dependency file require.
	  [Bug #9062] [ruby-dev:47779]
	  Reported by Ippei Obayashi. Thanks!!!

Thu Oct 31 14:09:32 2013  Koichi Sasada  <ko1@atdot.net>

	* vm_method.c (rb_method_entry_make): fix to pass an ISeq value.
	  OBJ_WRITTEN() accepts only VALUE.

Wed Oct 30 19:07:57 2013  Akinori MUSHA  <knu@iDaemons.org>

	* misc/ruby-additional.el (ruby-brace-to-do-end)
	  (ruby-do-end-to-brace, ruby-toggle-block): Remove functions that
	  are already in the latest released version of Emacs (24.3).
	  [Bug #7565]

Wed Oct 30 12:44:28 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* win32/Makefile.sub (config.status): add missing variables,
	  PLATFORM_DIR and THREAD_MODEL.

Wed Oct 30 12:20:32 2013  Tanaka Akira  <akr@fsij.org>

	* time.c (v2w): Normalize a rational value to an integer if possible.
	  [ruby-core:58070] [Bug #9059] reported by Isaac Schwabacher.

Wed Oct 30 12:08:41 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* array.c (rb_ary_uniq_bang): use rb_ary_modify_check() instead of
	  rb_ary_modify() because the array will be unshared soon.

Wed Oct 30 03:25:10 2013  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/visitors/yaml_tree.rb: make less garbage when
	  testing if a string is binary.

Wed Oct 30 03:08:24 2013  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/visitors/yaml_tree.rb: string subclasses should
	  not be considered to be binary.  Fixes Psych / GH 166
	  https://github.com/tenderlove/psych/issues/166

	* test/psych/test_string.rb: test for fix

Tue Oct 29 23:01:18 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* array.c (rb_ary_zip): some refactoring.

Tue Oct 29 22:11:37 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* array.c (rb_ary_uniq_bang): use st_foreach() instead of for loop.

Tue Oct 29 20:01:58 2013  Koichi Sasada  <ko1@atdot.net>

	* add RUBY_TYPED_FREE_IMMEDIATELY to data types which only use
	  safe functions during garbage collection such as xfree().

	  On default, T_DATA objects are freed at same points as finalizers.
	  This approach protects issues such as reported by [ruby-dev:35578].
	  However, freeing T_DATA objects immediately helps heap usage.

	  Most of T_DATA (in other words, most of dfree functions) are safe.
	  However, we turned off RUBY_TYPED_FREE_IMMEDIATELY by default
	  for safety.

	* cont.c: ditto.

	* dir.c: ditto.

	* encoding.c: ditto.

	* enumerator.c: ditto.

	* error.c: ditto.

	* file.c: ditto.

	* gc.c: ditto.

	* io.c: ditto.

	* iseq.c: ditto.

	* marshal.c: ditto.

	* parse.y: ditto.

	* proc.c: ditto.

	* process.c: ditto.

	* random.c: ditto.

	* thread.c: ditto.

	* time.c: ditto.

	* transcode.c: ditto.

	* variable.c: ditto.

	* vm.c: ditto.

	* vm_backtrace.c: ditto.

	* vm_trace.c: ditto.

	* ext/bigdecimal/bigdecimal.c: ditto.

	* ext/objspace/objspace.c: ditto.

	* ext/stringio/stringio.c: ditto.

	* ext/strscan/strscan.c: ditto.

Tue Oct 29 19:48:33 2013  Koichi Sasada  <ko1@atdot.net>

	* include/ruby/ruby.h: fix typo (FL_WB_PROTECT -> FL_WB_PROTECTED).

Tue Oct 29 18:45:08 2013  Koichi Sasada  <ko1@atdot.net>

	* vm_trace.c (tp_free): removed because empty free function.
	  Use RUBY_TYPED_NEVER_FREE instead.

Tue Oct 29 18:37:33 2013  Koichi Sasada  <ko1@atdot.net>

	* include/ruby/ruby.h: introduce new flags for T_TYPEDDATA.
	  * RUBY_TYPED_FREE_IMMEDIATELY: free the data given by DATA_PTR()
	    with dfree function immediately.  Otherwise (default), the data
	    freed at finalization point.
	  * RUBY_TYPED_WB_PROTECTED: make this object with FL_WB_PROTECT
	    (not shady).

	* gc.c (obj_free): support RUBY_TYPED_FREE_IMMEDIATELY.

Tue Oct 29 16:49:03 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (vm_malloc_increase): decrease it more carefully.

Tue Oct 29 16:24:52 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (heap_page_resurrect): return a page in tomb heap even if
	  freelist is NULL.

Tue Oct 29 15:46:30 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ruby_atomic.h (ATOMIC_SIZE_CAS): new macro, compare and swap size_t.

Tue Oct 29 12:08:05 2013  Tanaka Akira  <akr@fsij.org>

	* ext/readline/readline.c (readline_getc): Consider
	  NULL as input.

Tue Oct 29 11:10:08 2013  Aman Gupta <ruby@tmm1.net>

	* gc.c (gc_profile_total_time): fix off-by-one error in
	  GC::Profiler.total_time.
	* test/ruby/test_gc.rb (class TestGc): test for above.

Tue Oct 29 09:53:00 2013  Charlie Somerville  <charliesome@ruby-lang.org>

	* insns.def, vm.c, vm_insnhelper.c, vm_insnhelper.h, vm_method.c: split
	  ruby_vm_global_state_version into two separate counters - one for the
	  global method state and one for the global constant state. This means
	  changes to constants do not affect method caches, and changes to
	  methods do not affect constant caches. In particular, this means
	  inclusions of modules containing constants no longer globally
	  invalidate the method cache.

	* class.c, eval.c, include/ruby/intern.h, insns.def, vm.c, vm_method.c:
	  rename rb_clear_cache_by_class to rb_clear_method_cache_by_class

	* class.c, include/ruby/intern.h, variable.c, vm_method.c: add
	  rb_clear_constant_cache

	* compile.c, vm_core.h, vm_insnhelper.c: rename vmstat field in
	  rb_call_info_struct to method_state

	* vm_method.c: rename vmstat field in struct cache_entry to method_state

Mon Oct 28 23:26:04 2013  Tanaka Akira  <akr@fsij.org>

	* test/readline/test_readline.rb (teardown): Clear Readline.input and
	  Readline.output.

Mon Oct 28 21:35:31 2013  Tanaka Akira  <akr@fsij.org>

	* ext/-test-/file/depend, ext/-test-/postponed_job/depend,
	  ext/-test-/tracepoint/depend: New files for dependencies.

Mon Oct 28 15:32:18 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/openssl/depend (ossl.o): work around of dependency of
	  thread_native.h, which depends on headers by THREAD_MODEL.
	  [ruby-dev:47777]

	* ext/openssl/extconf.rb: need THREAD_MODEL.

Mon Oct 28 14:57:01 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* load.c (ruby_init_ext): share feature names between frame name and
	  provided features.

Mon Oct 28 14:41:27 2013  Akinori MUSHA  <knu@iDaemons.org>

	* misc/ruby-electric.el: Import ruby-electric.el 2.1 from
	  https://github.com/knu/ruby-electric.el.

	  * Hitting the newline-and-indent key within a comment fires
	    comment-indent-new-line.

	  * Introduce a new feature
	    `ruby-electric-autoindent-on-closing-char`.

	  * Fix fallback behavior of ruby-electric-space/return that
	    caused error with auto-complete.

Mon Oct 28 13:17:17 2013  Or Cohen  <orc@fewbytes.com>

	* error.c (name_err_to_s): remove no longer needed overriding, since
	  r30455 which made exc_to_s almost same.  Fixes [GH-413].

Mon Oct 28 12:42:11 2013  Tanaka Akira  <akr@fsij.org>

	* common.mk, ext/objspace/depend, ext/coverage/depend,
	  ext/-test-/debug/depend, ext/date/depend: Update dependencies.

Mon Oct 28 09:29:00 2013  Charlie Somerville  <charliesome@ruby-lang.org>

	* vm.c: vm_clear_all_cache is not necessary now we use a 64 bit counter
	  for global state version.

	* vm_insnhelper.h: ruby_vm_global_state_version overflow is unnecessary

Mon Oct 28 07:47:32 2013  Aman Gupta <ruby@tmm1.net>

	* vm_backtrace.c (rb_profile_frame_classpath): do not use rb_inspect
	  directly, since it might have a custom implementation or show ivars.

Mon Oct 28 04:10:41 2013  Aman Gupta <ruby@tmm1.net>

	* vm_backtrace.c (rb_profile_frame_classpath): handle singleton
	  methods defined directly on an object.
	* test/-ext-/debug/test_profile_frames.rb: test for above.

Mon Oct 28 00:52:36 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* struct.c (new_struct): fix warning message, class name and encoding.

Sun Oct 27 20:53:08 2013  Tanaka Akira  <akr@fsij.org>

	* ext/readline/readline.c: Include ruby/thread.h for
	  rb_thread_call_without_gvl2.
	  (readline_rl_instream, readline_rl_outstream): Record FILE
	  structures allocated by this extension.
	  (getc_body): New function extracted from readline_getc.
	  (getc_func): New function.
	  (readline_getc): Use rb_thread_call_without_gvl2 to invoke getc_func.
	  [ruby-dev:47033] [Bug #8749]
	  (clear_rl_instream, clear_rl_outstream): Close FILE structure
	  allocated by this extension reliably.  [ruby-core:57951] [Bug #9040]
	  (readline_readline): Use clear_rl_instream and clear_rl_outstream.
	  (readline_s_set_input): Set readline_rl_instream.
	  (readline_s_set_output): Set readline_rl_outstream.
	  (Init_readline): Don't call readline_s_set_input because
	  readline_getc doesn't block other threads for any FILE structure now.

	  [ruby-dev:47033] [Bug #8749] reported by Nobuhiro IMAI.
	  [ruby-core:57951] [Bug #9040] reported by Eamonn Webster.

Sat Oct 26 19:31:28 2013  Kazuki Tsujimoto  <kazuki@callcc.net>

	* gc.c: catch up recent changes to compile on GC_DEBUG,
	  RGENGC_CHECK_MODE.

Sat Oct 26 19:08:00 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* range.c (range_initialize_copy): disallow to modify after
	  initialized.

Sat Oct 26 17:48:54 2013  Tanaka Akira  <akr@fsij.org>

	* lib/open-uri.rb (meta_add_field): : Re-implemented.
	   [ruby-core:58017] [Bug #9051] patch by Eamonn Webster.

Sat Oct 26 14:35:09 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (gc_profile_dump_on): use "Page" terminology.

Sat Oct 26 13:25:45 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (gc_sweep, gc_heap_lazy_sweep): fix measurement code.
	  We only need one sweep time measurement without lazy sweep.

Sat Oct 26 11:59:13 2013  Tanaka Akira  <akr@fsij.org>

	* addr2line.c: Include ELF header after system headers (especially
	  sys/types.h) to avoid compilation failure,
	  "usr/include/sh3/elf_machdep.h:4:2: error: #error Define _BYTE_ORDER!",
	  on NetBSD/sh3 (dreamcast, hpcsh, landisk, mmeye).

Sat Oct 26 11:35:22 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c: tuning parameters.

	* gc.c (GC_MALLOC_LIMIT): change default value to 16MB.

	* gc.c (GC_MALLOC_LIMIT_GROWTH_FACTOR): change default value to 2.0.

	* gc.c (gc_before_sweep): change decrease ratio of `malloc_limit'
	  from 1/4 to 1/10.

Sat Oct 26 11:30:07 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (vm_malloc_increase): do gc_rest_sweep() before GC.
	  gc_rest_sweep() can reduce malloc_increase, so try it before GC.
	  Otherwise, malloc_increase can be less than malloc_limit at
	  gc_before_sweep(). This means that re-calculation of malloc_limit
	  may be wrong value.

Sat Oct 26 06:35:41 2013  Masaya Tarui  <tarui@ruby-lang.org>

	* gc.c (gc_before_heap_sweep): Restructure code to mean clearly.
	  heap->freelist is connected to end of list.

Sat Oct 26 04:01:35 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (gc_before_heap_sweep): fix freelist management.
	  After rb_gc_force_recycle() for a object belonging to heap->freelist,
	  `heap->using_page->freelist' is not null.

Thu Oct 24 21:57:24 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* parse.y: Remove +(binary) and -(binary) special cases
	  [Feature #9048]

Thu Oct 24 12:45:53 2013  Zachary Scott  <e@zzak.io>

	* object.c: [DOC] Document first argument also takes string for:

	  rb_mod_const_get, rb_mod_const_set, rb_mod_const_defined

	  Also added note about NameError exception for invalid constant name

Thu Oct 24 12:23:58 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_thread_terminate_all): add a comment why we need
	  state check and call terminate_i again.

Thu Oct 24 12:15:02 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_thread_terminate_all): add a comment why infinite
	  sleep is safe.

Thu Oct 24 07:41:42 2013  Aman Gupta <ruby@tmm1.net>

	* gc.c: add new initial_growth_max tuning parameter.
	  [ruby-core:57928] [Bug #9035]
	* gc.c (heap_set_increment): when initial_growth_max is set,
	  do not grow number of slots by more than growth_max at a time.
	* gc.c (rb_gc_set_params): load optional new tuning value from
	  RUBY_HEAP_SLOTS_GROWTH_MAX environment variable.
	* test/ruby/test_gc.rb (class TestGc): test for above.

Thu Oct 24 01:34:12 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/win32.h (rb_infinity_float): suppress overflow in
	  constant arithmetic warnings.  [ruby-core:57981] [Bug #9044]

Thu Oct 24 00:11:24 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/ostruct.rb: raise NoMethodError with a #name and #args.
	  Raise RuntimeError when modifying frozen instances
	  instead of TypeError.
	  (OpenStruct#each_pair): Return an enumerator with size
	  (OpenStruct#delete): Use the converted argument.
	  Patches by Kenichi Kamiya. [Fixes GH-383]

	* test/ostruct/test_ostruct.rb: Added tests for above.

Thu Oct 24 00:10:22 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* array.c: Add Array#to_h [Feature #7292]

	* enum.c: Add Enumerable#to_h

Wed Oct 23 23:48:28 2013  Aman Gupta <ruby@tmm1.net>

	* gc.c: Rename free_min to min_free_slots and free_min_page to
	  max_free_slots. The algorithm for heap growth is:
	    if (swept_slots < min_free_slots) pages++
	    if (swept_slots > max_free_slots) pages--

Wed Oct 23 22:51:03 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* win32/Makefile.sub (config.h): VC 2013 supports C99 mathematics
	  functions.  [ruby-core:57981] [Bug #9044]

Wed Oct 23 19:13:18 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c: move increment from heap to heap_pages.
	  Share `increment' information with heaps.

	* gc.c: change ratio of heap_pages_free_min_page
	  to 0.80.
	  This change means slow down page freeing speed.

Wed Oct 23 17:52:03 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (heap_pages_free_unused_pages): cast to (int) for size_t
	  variable `i'.

Wed Oct 23 17:39:35 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c: introduce tomb heap.
	  Tomb heap is where zombie objects and ghost (freed slot) lived in.
	  Separate from other heaps (now there is only eden heap) at sweeping
	  helps freeing pages more efficiently.
	  Before this patch, even if there is an empty page at former phase
	  of sweeping, we can't free it.

	  Algorithm:
	    (1) Sweeping all pages in a heap and move empty pages from the
	        heap to tomb_heap.
	    (2) Check all existing pages and free a page
	        if all slots of this page are empty and
	           there is enough empty slots (checking by swept_num)

	  To introduce this patch, there are several tuning of GC parameters.

Wed Oct 23 14:20:56 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (gc_prof_sweep_timer_stop): catch up recent changes
	  to compile on GC_PROFILE_MORE_DETAIL=1.

Wed Oct 23 11:43:27 2013  Zachary Scott  <e@zzak.io>

	* file.c: [DOC] fix rdoc format of File#expand_path from r43386

Tue Oct 22 21:58:28 2013  URABE Shyouhei  <shyouhei@ruby-lang.org>

	* vm_core.h (enum): avoid syntax error.

	* method.h: ditto.

	* internal.h: ditto.

Tue Oct 22 19:53:16 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (Init_heap): move logics from heap_pages_init() and remove
	  heap_pages_init().

Tue Oct 22 19:19:05 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c: allow multiple heaps.
	  Now, objects are managed by page. And a set of pages is called heap.
	  This commit supports multiple heaps in the object space.

	  * Functions heap_* and rb_heap_t manages heap data structure.
	  * Functions heap_page_* and struct heap_page manage page data
	    structure.
	  * Functions heap_pages_* and struct rb_objspace_t::heap_pages
	    maintains all pages.
	    For example, pages are allocated from the heap_pages.

	  See https://bugs.ruby-lang.org/projects/ruby-trunk/wiki/GC_design
	  and https://bugs.ruby-lang.org/attachments/4015/data-heap_structure_with_multiple_heaps.png
	  for more details.

	  Now, there is only one heap called `eden', which is a space for all
	  new generated objects.

Tue Oct 22 18:26:12 2013  Tanaka Akira  <akr@fsij.org>

	* lib/pp.rb (object_address_group): Use Kernel#to_s to obtain the class
	  name and object address.
	  This fix a problem caused by %p in C generates variable length
	  address.
	  Reported by ko1 via IRC.
